/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * license agreements; and to You under the Apache License, version 2.0:
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * This file is part of the Apache Pekko project, which was derived from Akka.
 */

/*
 * Copyright (C) 2020-2022 Lightbend Inc. <https://www.lightbend.com>
 */

// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: ClusterMessages.proto

package org.apache.pekko.cluster.protobuf.msg;

public final class ClusterMessages {
  private ClusterMessages() {}
  public static void registerAllExtensions(
      org.apache.pekko.protobufv3.internal.ExtensionRegistryLite registry) {
  }

  public static void registerAllExtensions(
      org.apache.pekko.protobufv3.internal.ExtensionRegistry registry) {
    registerAllExtensions(
        (org.apache.pekko.protobufv3.internal.ExtensionRegistryLite) registry);
  }
  /**
   * <pre>
   **
   * Reachability status
   * </pre>
   *
   * Protobuf enum {@code ReachabilityStatus}
   */
  public enum ReachabilityStatus
      implements org.apache.pekko.protobufv3.internal.ProtocolMessageEnum {
    /**
     * <code>Reachable = 0;</code>
     */
    Reachable(0),
    /**
     * <code>Unreachable = 1;</code>
     */
    Unreachable(1),
    /**
     * <code>Terminated = 2;</code>
     */
    Terminated(2),
    ;

    /**
     * <code>Reachable = 0;</code>
     */
    public static final int Reachable_VALUE = 0;
    /**
     * <code>Unreachable = 1;</code>
     */
    public static final int Unreachable_VALUE = 1;
    /**
     * <code>Terminated = 2;</code>
     */
    public static final int Terminated_VALUE = 2;


    public final int getNumber() {
      return value;
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static ReachabilityStatus valueOf(int value) {
      return forNumber(value);
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     */
    public static ReachabilityStatus forNumber(int value) {
      switch (value) {
        case 0: return Reachable;
        case 1: return Unreachable;
        case 2: return Terminated;
        default: return null;
      }
    }

    public static org.apache.pekko.protobufv3.internal.Internal.EnumLiteMap<ReachabilityStatus>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final org.apache.pekko.protobufv3.internal.Internal.EnumLiteMap<
        ReachabilityStatus> internalValueMap =
          new org.apache.pekko.protobufv3.internal.Internal.EnumLiteMap<ReachabilityStatus>() {
            public ReachabilityStatus findValueByNumber(int number) {
              return ReachabilityStatus.forNumber(number);
            }
          };

    public final org.apache.pekko.protobufv3.internal.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      return getDescriptor().getValues().get(ordinal());
    }
    public final org.apache.pekko.protobufv3.internal.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.EnumDescriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.getDescriptor().getEnumTypes().get(0);
    }

    private static final ReachabilityStatus[] VALUES = values();

    public static ReachabilityStatus valueOf(
        org.apache.pekko.protobufv3.internal.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      return VALUES[desc.getIndex()];
    }

    private final int value;

    private ReachabilityStatus(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:ReachabilityStatus)
  }

  /**
   * <pre>
   **
   * Member Status
   * </pre>
   *
   * Protobuf enum {@code MemberStatus}
   */
  public enum MemberStatus
      implements org.apache.pekko.protobufv3.internal.ProtocolMessageEnum {
    /**
     * <code>Joining = 0;</code>
     */
    Joining(0),
    /**
     * <code>Up = 1;</code>
     */
    Up(1),
    /**
     * <code>Leaving = 2;</code>
     */
    Leaving(2),
    /**
     * <code>Exiting = 3;</code>
     */
    Exiting(3),
    /**
     * <code>Down = 4;</code>
     */
    Down(4),
    /**
     * <code>Removed = 5;</code>
     */
    Removed(5),
    /**
     * <code>WeaklyUp = 6;</code>
     */
    WeaklyUp(6),
    /**
     * <code>PreparingForShutdown = 7;</code>
     */
    PreparingForShutdown(7),
    /**
     * <code>ReadyForShutdown = 8;</code>
     */
    ReadyForShutdown(8),
    ;

    /**
     * <code>Joining = 0;</code>
     */
    public static final int Joining_VALUE = 0;
    /**
     * <code>Up = 1;</code>
     */
    public static final int Up_VALUE = 1;
    /**
     * <code>Leaving = 2;</code>
     */
    public static final int Leaving_VALUE = 2;
    /**
     * <code>Exiting = 3;</code>
     */
    public static final int Exiting_VALUE = 3;
    /**
     * <code>Down = 4;</code>
     */
    public static final int Down_VALUE = 4;
    /**
     * <code>Removed = 5;</code>
     */
    public static final int Removed_VALUE = 5;
    /**
     * <code>WeaklyUp = 6;</code>
     */
    public static final int WeaklyUp_VALUE = 6;
    /**
     * <code>PreparingForShutdown = 7;</code>
     */
    public static final int PreparingForShutdown_VALUE = 7;
    /**
     * <code>ReadyForShutdown = 8;</code>
     */
    public static final int ReadyForShutdown_VALUE = 8;


    public final int getNumber() {
      return value;
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     * @deprecated Use {@link #forNumber(int)} instead.
     */
    @java.lang.Deprecated
    public static MemberStatus valueOf(int value) {
      return forNumber(value);
    }

    /**
     * @param value The numeric wire value of the corresponding enum entry.
     * @return The enum associated with the given numeric wire value.
     */
    public static MemberStatus forNumber(int value) {
      switch (value) {
        case 0: return Joining;
        case 1: return Up;
        case 2: return Leaving;
        case 3: return Exiting;
        case 4: return Down;
        case 5: return Removed;
        case 6: return WeaklyUp;
        case 7: return PreparingForShutdown;
        case 8: return ReadyForShutdown;
        default: return null;
      }
    }

    public static org.apache.pekko.protobufv3.internal.Internal.EnumLiteMap<MemberStatus>
        internalGetValueMap() {
      return internalValueMap;
    }
    private static final org.apache.pekko.protobufv3.internal.Internal.EnumLiteMap<
        MemberStatus> internalValueMap =
          new org.apache.pekko.protobufv3.internal.Internal.EnumLiteMap<MemberStatus>() {
            public MemberStatus findValueByNumber(int number) {
              return MemberStatus.forNumber(number);
            }
          };

    public final org.apache.pekko.protobufv3.internal.Descriptors.EnumValueDescriptor
        getValueDescriptor() {
      return getDescriptor().getValues().get(ordinal());
    }
    public final org.apache.pekko.protobufv3.internal.Descriptors.EnumDescriptor
        getDescriptorForType() {
      return getDescriptor();
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.EnumDescriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.getDescriptor().getEnumTypes().get(1);
    }

    private static final MemberStatus[] VALUES = values();

    public static MemberStatus valueOf(
        org.apache.pekko.protobufv3.internal.Descriptors.EnumValueDescriptor desc) {
      if (desc.getType() != getDescriptor()) {
        throw new java.lang.IllegalArgumentException(
          "EnumValueDescriptor is not for this type.");
      }
      return VALUES[desc.getIndex()];
    }

    private final int value;

    private MemberStatus(int value) {
      this.value = value;
    }

    // @@protoc_insertion_point(enum_scope:MemberStatus)
  }

  public interface JoinOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Join)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .UniqueAddress node = 1;</code>
     * @return Whether the node field is set.
     */
    boolean hasNode();
    /**
     * <code>required .UniqueAddress node = 1;</code>
     * @return The node.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getNode();
    /**
     * <code>required .UniqueAddress node = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getNodeOrBuilder();

    /**
     * <code>repeated string roles = 2;</code>
     * @return A list containing the roles.
     */
    java.util.List<java.lang.String>
        getRolesList();
    /**
     * <code>repeated string roles = 2;</code>
     * @return The count of roles.
     */
    int getRolesCount();
    /**
     * <code>repeated string roles = 2;</code>
     * @param index The index of the element to return.
     * @return The roles at the given index.
     */
    java.lang.String getRoles(int index);
    /**
     * <code>repeated string roles = 2;</code>
     * @param index The index of the value to return.
     * @return The bytes of the roles at the given index.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getRolesBytes(int index);

    /**
     * <code>optional string appVersion = 3;</code>
     * @return Whether the appVersion field is set.
     */
    boolean hasAppVersion();
    /**
     * <code>optional string appVersion = 3;</code>
     * @return The appVersion.
     */
    java.lang.String getAppVersion();
    /**
     * <code>optional string appVersion = 3;</code>
     * @return The bytes for appVersion.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getAppVersionBytes();
  }
  /**
   * <pre>
   **
   * Join
   * </pre>
   *
   * Protobuf type {@code Join}
   */
  public  static final class Join extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Join)
      JoinOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Join.newBuilder() to construct.
    private Join(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Join() {
      roles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      appVersion_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new Join();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Join(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = node_.toBuilder();
              }
              node_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(node_);
                node_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 18: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              if (!((mutable_bitField0_ & 0x00000002) != 0)) {
                roles_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000002;
              }
              roles_.add(bs);
              break;
            }
            case 26: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000002;
              appVersion_ = bs;
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000002) != 0)) {
          roles_ = roles_.getUnmodifiableView();
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Join_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Join_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join.Builder.class);
    }

    private int bitField0_;
    public static final int NODE_FIELD_NUMBER = 1;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress node_;
    /**
     * <code>required .UniqueAddress node = 1;</code>
     * @return Whether the node field is set.
     */
    public boolean hasNode() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .UniqueAddress node = 1;</code>
     * @return The node.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getNode() {
      return node_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : node_;
    }
    /**
     * <code>required .UniqueAddress node = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getNodeOrBuilder() {
      return node_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : node_;
    }

    public static final int ROLES_FIELD_NUMBER = 2;
    private org.apache.pekko.protobufv3.internal.LazyStringList roles_;
    /**
     * <code>repeated string roles = 2;</code>
     * @return A list containing the roles.
     */
    public org.apache.pekko.protobufv3.internal.ProtocolStringList
        getRolesList() {
      return roles_;
    }
    /**
     * <code>repeated string roles = 2;</code>
     * @return The count of roles.
     */
    public int getRolesCount() {
      return roles_.size();
    }
    /**
     * <code>repeated string roles = 2;</code>
     * @param index The index of the element to return.
     * @return The roles at the given index.
     */
    public java.lang.String getRoles(int index) {
      return roles_.get(index);
    }
    /**
     * <code>repeated string roles = 2;</code>
     * @param index The index of the value to return.
     * @return The bytes of the roles at the given index.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getRolesBytes(int index) {
      return roles_.getByteString(index);
    }

    public static final int APPVERSION_FIELD_NUMBER = 3;
    private volatile java.lang.Object appVersion_;
    /**
     * <code>optional string appVersion = 3;</code>
     * @return Whether the appVersion field is set.
     */
    public boolean hasAppVersion() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>optional string appVersion = 3;</code>
     * @return The appVersion.
     */
    public java.lang.String getAppVersion() {
      java.lang.Object ref = appVersion_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.pekko.protobufv3.internal.ByteString bs = 
            (org.apache.pekko.protobufv3.internal.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          appVersion_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string appVersion = 3;</code>
     * @return The bytes for appVersion.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getAppVersionBytes() {
      java.lang.Object ref = appVersion_;
      if (ref instanceof java.lang.String) {
        org.apache.pekko.protobufv3.internal.ByteString b = 
            org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        appVersion_ = b;
        return b;
      } else {
        return (org.apache.pekko.protobufv3.internal.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasNode()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getNode().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(1, getNode());
      }
      for (int i = 0; i < roles_.size(); i++) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 2, roles_.getRaw(i));
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 3, appVersion_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, getNode());
      }
      {
        int dataSize = 0;
        for (int i = 0; i < roles_.size(); i++) {
          dataSize += computeStringSizeNoTag(roles_.getRaw(i));
        }
        size += dataSize;
        size += 1 * getRolesList().size();
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.GeneratedMessageV3.computeStringSize(3, appVersion_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join) obj;

      if (hasNode() != other.hasNode()) return false;
      if (hasNode()) {
        if (!getNode()
            .equals(other.getNode())) return false;
      }
      if (!getRolesList()
          .equals(other.getRolesList())) return false;
      if (hasAppVersion() != other.hasAppVersion()) return false;
      if (hasAppVersion()) {
        if (!getAppVersion()
            .equals(other.getAppVersion())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasNode()) {
        hash = (37 * hash) + NODE_FIELD_NUMBER;
        hash = (53 * hash) + getNode().hashCode();
      }
      if (getRolesCount() > 0) {
        hash = (37 * hash) + ROLES_FIELD_NUMBER;
        hash = (53 * hash) + getRolesList().hashCode();
      }
      if (hasAppVersion()) {
        hash = (37 * hash) + APPVERSION_FIELD_NUMBER;
        hash = (53 * hash) + getAppVersion().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Join
     * </pre>
     *
     * Protobuf type {@code Join}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Join)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.JoinOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Join_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Join_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getNodeFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (nodeBuilder_ == null) {
          node_ = null;
        } else {
          nodeBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        roles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        appVersion_ = "";
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Join_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          if (nodeBuilder_ == null) {
            result.node_ = node_;
          } else {
            result.node_ = nodeBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((bitField0_ & 0x00000002) != 0)) {
          roles_ = roles_.getUnmodifiableView();
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.roles_ = roles_;
        if (((from_bitField0_ & 0x00000004) != 0)) {
          to_bitField0_ |= 0x00000002;
        }
        result.appVersion_ = appVersion_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join.getDefaultInstance()) return this;
        if (other.hasNode()) {
          mergeNode(other.getNode());
        }
        if (!other.roles_.isEmpty()) {
          if (roles_.isEmpty()) {
            roles_ = other.roles_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureRolesIsMutable();
            roles_.addAll(other.roles_);
          }
          onChanged();
        }
        if (other.hasAppVersion()) {
          bitField0_ |= 0x00000004;
          appVersion_ = other.appVersion_;
          onChanged();
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasNode()) {
          return false;
        }
        if (!getNode().isInitialized()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress node_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> nodeBuilder_;
      /**
       * <code>required .UniqueAddress node = 1;</code>
       * @return Whether the node field is set.
       */
      public boolean hasNode() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .UniqueAddress node = 1;</code>
       * @return The node.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getNode() {
        if (nodeBuilder_ == null) {
          return node_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : node_;
        } else {
          return nodeBuilder_.getMessage();
        }
      }
      /**
       * <code>required .UniqueAddress node = 1;</code>
       */
      public Builder setNode(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (nodeBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          node_ = value;
          onChanged();
        } else {
          nodeBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress node = 1;</code>
       */
      public Builder setNode(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder builderForValue) {
        if (nodeBuilder_ == null) {
          node_ = builderForValue.build();
          onChanged();
        } else {
          nodeBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress node = 1;</code>
       */
      public Builder mergeNode(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (nodeBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0) &&
              node_ != null &&
              node_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance()) {
            node_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.newBuilder(node_).mergeFrom(value).buildPartial();
          } else {
            node_ = value;
          }
          onChanged();
        } else {
          nodeBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress node = 1;</code>
       */
      public Builder clearNode() {
        if (nodeBuilder_ == null) {
          node_ = null;
          onChanged();
        } else {
          nodeBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .UniqueAddress node = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder getNodeBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getNodeFieldBuilder().getBuilder();
      }
      /**
       * <code>required .UniqueAddress node = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getNodeOrBuilder() {
        if (nodeBuilder_ != null) {
          return nodeBuilder_.getMessageOrBuilder();
        } else {
          return node_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : node_;
        }
      }
      /**
       * <code>required .UniqueAddress node = 1;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
          getNodeFieldBuilder() {
        if (nodeBuilder_ == null) {
          nodeBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder>(
                  getNode(),
                  getParentForChildren(),
                  isClean());
          node_ = null;
        }
        return nodeBuilder_;
      }

      private org.apache.pekko.protobufv3.internal.LazyStringList roles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      private void ensureRolesIsMutable() {
        if (!((bitField0_ & 0x00000002) != 0)) {
          roles_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList(roles_);
          bitField0_ |= 0x00000002;
         }
      }
      /**
       * <code>repeated string roles = 2;</code>
       * @return A list containing the roles.
       */
      public org.apache.pekko.protobufv3.internal.ProtocolStringList
          getRolesList() {
        return roles_.getUnmodifiableView();
      }
      /**
       * <code>repeated string roles = 2;</code>
       * @return The count of roles.
       */
      public int getRolesCount() {
        return roles_.size();
      }
      /**
       * <code>repeated string roles = 2;</code>
       * @param index The index of the element to return.
       * @return The roles at the given index.
       */
      public java.lang.String getRoles(int index) {
        return roles_.get(index);
      }
      /**
       * <code>repeated string roles = 2;</code>
       * @param index The index of the value to return.
       * @return The bytes of the roles at the given index.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getRolesBytes(int index) {
        return roles_.getByteString(index);
      }
      /**
       * <code>repeated string roles = 2;</code>
       * @param index The index to set the value at.
       * @param value The roles to set.
       * @return This builder for chaining.
       */
      public Builder setRoles(
          int index, java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureRolesIsMutable();
        roles_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string roles = 2;</code>
       * @param value The roles to add.
       * @return This builder for chaining.
       */
      public Builder addRoles(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureRolesIsMutable();
        roles_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string roles = 2;</code>
       * @param values The roles to add.
       * @return This builder for chaining.
       */
      public Builder addAllRoles(
          java.lang.Iterable<java.lang.String> values) {
        ensureRolesIsMutable();
        org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
            values, roles_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string roles = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearRoles() {
        roles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string roles = 2;</code>
       * @param value The bytes of the roles to add.
       * @return This builder for chaining.
       */
      public Builder addRolesBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureRolesIsMutable();
        roles_.add(value);
        onChanged();
        return this;
      }

      private java.lang.Object appVersion_ = "";
      /**
       * <code>optional string appVersion = 3;</code>
       * @return Whether the appVersion field is set.
       */
      public boolean hasAppVersion() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>optional string appVersion = 3;</code>
       * @return The appVersion.
       */
      public java.lang.String getAppVersion() {
        java.lang.Object ref = appVersion_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.pekko.protobufv3.internal.ByteString bs =
              (org.apache.pekko.protobufv3.internal.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            appVersion_ = s;
          }
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string appVersion = 3;</code>
       * @return The bytes for appVersion.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getAppVersionBytes() {
        java.lang.Object ref = appVersion_;
        if (ref instanceof String) {
          org.apache.pekko.protobufv3.internal.ByteString b = 
              org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          appVersion_ = b;
          return b;
        } else {
          return (org.apache.pekko.protobufv3.internal.ByteString) ref;
        }
      }
      /**
       * <code>optional string appVersion = 3;</code>
       * @param value The appVersion to set.
       * @return This builder for chaining.
       */
      public Builder setAppVersion(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        appVersion_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string appVersion = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearAppVersion() {
        bitField0_ = (bitField0_ & ~0x00000004);
        appVersion_ = getDefaultInstance().getAppVersion();
        onChanged();
        return this;
      }
      /**
       * <code>optional string appVersion = 3;</code>
       * @param value The bytes for appVersion to set.
       * @return This builder for chaining.
       */
      public Builder setAppVersionBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        appVersion_ = value;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Join)
    }

    // @@protoc_insertion_point(class_scope:Join)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Join>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Join>() {
      @java.lang.Override
      public Join parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new Join(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<Join> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<Join> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Join getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface WelcomeOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Welcome)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return Whether the from field is set.
     */
    boolean hasFrom();
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return The from.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom();
    /**
     * <code>required .UniqueAddress from = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder();

    /**
     * <code>required .Gossip gossip = 2;</code>
     * @return Whether the gossip field is set.
     */
    boolean hasGossip();
    /**
     * <code>required .Gossip gossip = 2;</code>
     * @return The gossip.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip getGossip();
    /**
     * <code>required .Gossip gossip = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOrBuilder getGossipOrBuilder();
  }
  /**
   * <pre>
   **
   * Welcome, reply to Join
   * </pre>
   *
   * Protobuf type {@code Welcome}
   */
  public  static final class Welcome extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Welcome)
      WelcomeOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Welcome.newBuilder() to construct.
    private Welcome(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Welcome() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new Welcome();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Welcome(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = from_.toBuilder();
              }
              from_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(from_);
                from_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 18: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.Builder subBuilder = null;
              if (((bitField0_ & 0x00000002) != 0)) {
                subBuilder = gossip_.toBuilder();
              }
              gossip_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(gossip_);
                gossip_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000002;
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Welcome_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Welcome_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome.Builder.class);
    }

    private int bitField0_;
    public static final int FROM_FIELD_NUMBER = 1;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress from_;
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return Whether the from field is set.
     */
    public boolean hasFrom() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return The from.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
    }
    /**
     * <code>required .UniqueAddress from = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
    }

    public static final int GOSSIP_FIELD_NUMBER = 2;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip gossip_;
    /**
     * <code>required .Gossip gossip = 2;</code>
     * @return Whether the gossip field is set.
     */
    public boolean hasGossip() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required .Gossip gossip = 2;</code>
     * @return The gossip.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip getGossip() {
      return gossip_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.getDefaultInstance() : gossip_;
    }
    /**
     * <code>required .Gossip gossip = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOrBuilder getGossipOrBuilder() {
      return gossip_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.getDefaultInstance() : gossip_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasFrom()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasGossip()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getFrom().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getGossip().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(1, getFrom());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeMessage(2, getGossip());
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, getFrom());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(2, getGossip());
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome) obj;

      if (hasFrom() != other.hasFrom()) return false;
      if (hasFrom()) {
        if (!getFrom()
            .equals(other.getFrom())) return false;
      }
      if (hasGossip() != other.hasGossip()) return false;
      if (hasGossip()) {
        if (!getGossip()
            .equals(other.getGossip())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasFrom()) {
        hash = (37 * hash) + FROM_FIELD_NUMBER;
        hash = (53 * hash) + getFrom().hashCode();
      }
      if (hasGossip()) {
        hash = (37 * hash) + GOSSIP_FIELD_NUMBER;
        hash = (53 * hash) + getGossip().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Welcome, reply to Join
     * </pre>
     *
     * Protobuf type {@code Welcome}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Welcome)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.WelcomeOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Welcome_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Welcome_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getFromFieldBuilder();
          getGossipFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (fromBuilder_ == null) {
          from_ = null;
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        if (gossipBuilder_ == null) {
          gossip_ = null;
        } else {
          gossipBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Welcome_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          if (fromBuilder_ == null) {
            result.from_ = from_;
          } else {
            result.from_ = fromBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          if (gossipBuilder_ == null) {
            result.gossip_ = gossip_;
          } else {
            result.gossip_ = gossipBuilder_.build();
          }
          to_bitField0_ |= 0x00000002;
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome.getDefaultInstance()) return this;
        if (other.hasFrom()) {
          mergeFrom(other.getFrom());
        }
        if (other.hasGossip()) {
          mergeGossip(other.getGossip());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasFrom()) {
          return false;
        }
        if (!hasGossip()) {
          return false;
        }
        if (!getFrom().isInitialized()) {
          return false;
        }
        if (!getGossip().isInitialized()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress from_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> fromBuilder_;
      /**
       * <code>required .UniqueAddress from = 1;</code>
       * @return Whether the from field is set.
       */
      public boolean hasFrom() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       * @return The from.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom() {
        if (fromBuilder_ == null) {
          return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
        } else {
          return fromBuilder_.getMessage();
        }
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder setFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (fromBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          from_ = value;
          onChanged();
        } else {
          fromBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder setFrom(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder builderForValue) {
        if (fromBuilder_ == null) {
          from_ = builderForValue.build();
          onChanged();
        } else {
          fromBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (fromBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0) &&
              from_ != null &&
              from_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance()) {
            from_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.newBuilder(from_).mergeFrom(value).buildPartial();
          } else {
            from_ = value;
          }
          onChanged();
        } else {
          fromBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder clearFrom() {
        if (fromBuilder_ == null) {
          from_ = null;
          onChanged();
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder getFromBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getFromFieldBuilder().getBuilder();
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder() {
        if (fromBuilder_ != null) {
          return fromBuilder_.getMessageOrBuilder();
        } else {
          return from_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
        }
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
          getFromFieldBuilder() {
        if (fromBuilder_ == null) {
          fromBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder>(
                  getFrom(),
                  getParentForChildren(),
                  isClean());
          from_ = null;
        }
        return fromBuilder_;
      }

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip gossip_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOrBuilder> gossipBuilder_;
      /**
       * <code>required .Gossip gossip = 2;</code>
       * @return Whether the gossip field is set.
       */
      public boolean hasGossip() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required .Gossip gossip = 2;</code>
       * @return The gossip.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip getGossip() {
        if (gossipBuilder_ == null) {
          return gossip_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.getDefaultInstance() : gossip_;
        } else {
          return gossipBuilder_.getMessage();
        }
      }
      /**
       * <code>required .Gossip gossip = 2;</code>
       */
      public Builder setGossip(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip value) {
        if (gossipBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          gossip_ = value;
          onChanged();
        } else {
          gossipBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .Gossip gossip = 2;</code>
       */
      public Builder setGossip(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.Builder builderForValue) {
        if (gossipBuilder_ == null) {
          gossip_ = builderForValue.build();
          onChanged();
        } else {
          gossipBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .Gossip gossip = 2;</code>
       */
      public Builder mergeGossip(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip value) {
        if (gossipBuilder_ == null) {
          if (((bitField0_ & 0x00000002) != 0) &&
              gossip_ != null &&
              gossip_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.getDefaultInstance()) {
            gossip_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.newBuilder(gossip_).mergeFrom(value).buildPartial();
          } else {
            gossip_ = value;
          }
          onChanged();
        } else {
          gossipBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .Gossip gossip = 2;</code>
       */
      public Builder clearGossip() {
        if (gossipBuilder_ == null) {
          gossip_ = null;
          onChanged();
        } else {
          gossipBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }
      /**
       * <code>required .Gossip gossip = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.Builder getGossipBuilder() {
        bitField0_ |= 0x00000002;
        onChanged();
        return getGossipFieldBuilder().getBuilder();
      }
      /**
       * <code>required .Gossip gossip = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOrBuilder getGossipOrBuilder() {
        if (gossipBuilder_ != null) {
          return gossipBuilder_.getMessageOrBuilder();
        } else {
          return gossip_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.getDefaultInstance() : gossip_;
        }
      }
      /**
       * <code>required .Gossip gossip = 2;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOrBuilder> 
          getGossipFieldBuilder() {
        if (gossipBuilder_ == null) {
          gossipBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOrBuilder>(
                  getGossip(),
                  getParentForChildren(),
                  isClean());
          gossip_ = null;
        }
        return gossipBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Welcome)
    }

    // @@protoc_insertion_point(class_scope:Welcome)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Welcome>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Welcome>() {
      @java.lang.Override
      public Welcome parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new Welcome(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<Welcome> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<Welcome> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Welcome getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface InitJoinOrBuilder extends
      // @@protoc_insertion_point(interface_extends:InitJoin)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>optional string currentConfig = 1;</code>
     * @return Whether the currentConfig field is set.
     */
    boolean hasCurrentConfig();
    /**
     * <code>optional string currentConfig = 1;</code>
     * @return The currentConfig.
     */
    java.lang.String getCurrentConfig();
    /**
     * <code>optional string currentConfig = 1;</code>
     * @return The bytes for currentConfig.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getCurrentConfigBytes();
  }
  /**
   * <pre>
   **
   * InitJoin
   * </pre>
   *
   * Protobuf type {@code InitJoin}
   */
  public  static final class InitJoin extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:InitJoin)
      InitJoinOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use InitJoin.newBuilder() to construct.
    private InitJoin(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private InitJoin() {
      currentConfig_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new InitJoin();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private InitJoin(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000001;
              currentConfig_ = bs;
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoin_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoin_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin.Builder.class);
    }

    private int bitField0_;
    public static final int CURRENTCONFIG_FIELD_NUMBER = 1;
    private volatile java.lang.Object currentConfig_;
    /**
     * <code>optional string currentConfig = 1;</code>
     * @return Whether the currentConfig field is set.
     */
    public boolean hasCurrentConfig() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>optional string currentConfig = 1;</code>
     * @return The currentConfig.
     */
    public java.lang.String getCurrentConfig() {
      java.lang.Object ref = currentConfig_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.pekko.protobufv3.internal.ByteString bs = 
            (org.apache.pekko.protobufv3.internal.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          currentConfig_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string currentConfig = 1;</code>
     * @return The bytes for currentConfig.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getCurrentConfigBytes() {
      java.lang.Object ref = currentConfig_;
      if (ref instanceof java.lang.String) {
        org.apache.pekko.protobufv3.internal.ByteString b = 
            org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        currentConfig_ = b;
        return b;
      } else {
        return (org.apache.pekko.protobufv3.internal.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 1, currentConfig_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.GeneratedMessageV3.computeStringSize(1, currentConfig_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin) obj;

      if (hasCurrentConfig() != other.hasCurrentConfig()) return false;
      if (hasCurrentConfig()) {
        if (!getCurrentConfig()
            .equals(other.getCurrentConfig())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasCurrentConfig()) {
        hash = (37 * hash) + CURRENTCONFIG_FIELD_NUMBER;
        hash = (53 * hash) + getCurrentConfig().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * InitJoin
     * </pre>
     *
     * Protobuf type {@code InitJoin}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:InitJoin)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoin_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoin_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        currentConfig_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoin_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          to_bitField0_ |= 0x00000001;
        }
        result.currentConfig_ = currentConfig_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin.getDefaultInstance()) return this;
        if (other.hasCurrentConfig()) {
          bitField0_ |= 0x00000001;
          currentConfig_ = other.currentConfig_;
          onChanged();
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private java.lang.Object currentConfig_ = "";
      /**
       * <code>optional string currentConfig = 1;</code>
       * @return Whether the currentConfig field is set.
       */
      public boolean hasCurrentConfig() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>optional string currentConfig = 1;</code>
       * @return The currentConfig.
       */
      public java.lang.String getCurrentConfig() {
        java.lang.Object ref = currentConfig_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.pekko.protobufv3.internal.ByteString bs =
              (org.apache.pekko.protobufv3.internal.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            currentConfig_ = s;
          }
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string currentConfig = 1;</code>
       * @return The bytes for currentConfig.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getCurrentConfigBytes() {
        java.lang.Object ref = currentConfig_;
        if (ref instanceof String) {
          org.apache.pekko.protobufv3.internal.ByteString b = 
              org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          currentConfig_ = b;
          return b;
        } else {
          return (org.apache.pekko.protobufv3.internal.ByteString) ref;
        }
      }
      /**
       * <code>optional string currentConfig = 1;</code>
       * @param value The currentConfig to set.
       * @return This builder for chaining.
       */
      public Builder setCurrentConfig(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        currentConfig_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string currentConfig = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearCurrentConfig() {
        bitField0_ = (bitField0_ & ~0x00000001);
        currentConfig_ = getDefaultInstance().getCurrentConfig();
        onChanged();
        return this;
      }
      /**
       * <code>optional string currentConfig = 1;</code>
       * @param value The bytes for currentConfig to set.
       * @return This builder for chaining.
       */
      public Builder setCurrentConfigBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        currentConfig_ = value;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:InitJoin)
    }

    // @@protoc_insertion_point(class_scope:InitJoin)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<InitJoin>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<InitJoin>() {
      @java.lang.Override
      public InitJoin parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new InitJoin(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<InitJoin> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<InitJoin> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoin getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface InitJoinAckOrBuilder extends
      // @@protoc_insertion_point(interface_extends:InitJoinAck)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .Address address = 1;</code>
     * @return Whether the address field is set.
     */
    boolean hasAddress();
    /**
     * <code>required .Address address = 1;</code>
     * @return The address.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getAddress();
    /**
     * <code>required .Address address = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder getAddressOrBuilder();

    /**
     * <code>required .ConfigCheck configCheck = 2;</code>
     * @return Whether the configCheck field is set.
     */
    boolean hasConfigCheck();
    /**
     * <code>required .ConfigCheck configCheck = 2;</code>
     * @return The configCheck.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck getConfigCheck();
    /**
     * <code>required .ConfigCheck configCheck = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheckOrBuilder getConfigCheckOrBuilder();
  }
  /**
   * <pre>
   **
   * InitJoinAck
   * </pre>
   *
   * Protobuf type {@code InitJoinAck}
   */
  public  static final class InitJoinAck extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:InitJoinAck)
      InitJoinAckOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use InitJoinAck.newBuilder() to construct.
    private InitJoinAck(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private InitJoinAck() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new InitJoinAck();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private InitJoinAck(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = address_.toBuilder();
              }
              address_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(address_);
                address_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 18: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Builder subBuilder = null;
              if (((bitField0_ & 0x00000002) != 0)) {
                subBuilder = configCheck_.toBuilder();
              }
              configCheck_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(configCheck_);
                configCheck_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000002;
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoinAck_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoinAck_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck.Builder.class);
    }

    private int bitField0_;
    public static final int ADDRESS_FIELD_NUMBER = 1;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address address_;
    /**
     * <code>required .Address address = 1;</code>
     * @return Whether the address field is set.
     */
    public boolean hasAddress() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .Address address = 1;</code>
     * @return The address.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getAddress() {
      return address_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : address_;
    }
    /**
     * <code>required .Address address = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder getAddressOrBuilder() {
      return address_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : address_;
    }

    public static final int CONFIGCHECK_FIELD_NUMBER = 2;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck configCheck_;
    /**
     * <code>required .ConfigCheck configCheck = 2;</code>
     * @return Whether the configCheck field is set.
     */
    public boolean hasConfigCheck() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required .ConfigCheck configCheck = 2;</code>
     * @return The configCheck.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck getConfigCheck() {
      return configCheck_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.getDefaultInstance() : configCheck_;
    }
    /**
     * <code>required .ConfigCheck configCheck = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheckOrBuilder getConfigCheckOrBuilder() {
      return configCheck_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.getDefaultInstance() : configCheck_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasAddress()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasConfigCheck()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getAddress().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getConfigCheck().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(1, getAddress());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeMessage(2, getConfigCheck());
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, getAddress());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(2, getConfigCheck());
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck) obj;

      if (hasAddress() != other.hasAddress()) return false;
      if (hasAddress()) {
        if (!getAddress()
            .equals(other.getAddress())) return false;
      }
      if (hasConfigCheck() != other.hasConfigCheck()) return false;
      if (hasConfigCheck()) {
        if (!getConfigCheck()
            .equals(other.getConfigCheck())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasAddress()) {
        hash = (37 * hash) + ADDRESS_FIELD_NUMBER;
        hash = (53 * hash) + getAddress().hashCode();
      }
      if (hasConfigCheck()) {
        hash = (37 * hash) + CONFIGCHECK_FIELD_NUMBER;
        hash = (53 * hash) + getConfigCheck().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * InitJoinAck
     * </pre>
     *
     * Protobuf type {@code InitJoinAck}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:InitJoinAck)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAckOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoinAck_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoinAck_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getAddressFieldBuilder();
          getConfigCheckFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (addressBuilder_ == null) {
          address_ = null;
        } else {
          addressBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        if (configCheckBuilder_ == null) {
          configCheck_ = null;
        } else {
          configCheckBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_InitJoinAck_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          if (addressBuilder_ == null) {
            result.address_ = address_;
          } else {
            result.address_ = addressBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          if (configCheckBuilder_ == null) {
            result.configCheck_ = configCheck_;
          } else {
            result.configCheck_ = configCheckBuilder_.build();
          }
          to_bitField0_ |= 0x00000002;
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck.getDefaultInstance()) return this;
        if (other.hasAddress()) {
          mergeAddress(other.getAddress());
        }
        if (other.hasConfigCheck()) {
          mergeConfigCheck(other.getConfigCheck());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasAddress()) {
          return false;
        }
        if (!hasConfigCheck()) {
          return false;
        }
        if (!getAddress().isInitialized()) {
          return false;
        }
        if (!getConfigCheck().isInitialized()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address address_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder> addressBuilder_;
      /**
       * <code>required .Address address = 1;</code>
       * @return Whether the address field is set.
       */
      public boolean hasAddress() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .Address address = 1;</code>
       * @return The address.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getAddress() {
        if (addressBuilder_ == null) {
          return address_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : address_;
        } else {
          return addressBuilder_.getMessage();
        }
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public Builder setAddress(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address value) {
        if (addressBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          address_ = value;
          onChanged();
        } else {
          addressBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public Builder setAddress(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder builderForValue) {
        if (addressBuilder_ == null) {
          address_ = builderForValue.build();
          onChanged();
        } else {
          addressBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public Builder mergeAddress(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address value) {
        if (addressBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0) &&
              address_ != null &&
              address_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance()) {
            address_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.newBuilder(address_).mergeFrom(value).buildPartial();
          } else {
            address_ = value;
          }
          onChanged();
        } else {
          addressBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public Builder clearAddress() {
        if (addressBuilder_ == null) {
          address_ = null;
          onChanged();
        } else {
          addressBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder getAddressBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getAddressFieldBuilder().getBuilder();
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder getAddressOrBuilder() {
        if (addressBuilder_ != null) {
          return addressBuilder_.getMessageOrBuilder();
        } else {
          return address_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : address_;
        }
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder> 
          getAddressFieldBuilder() {
        if (addressBuilder_ == null) {
          addressBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder>(
                  getAddress(),
                  getParentForChildren(),
                  isClean());
          address_ = null;
        }
        return addressBuilder_;
      }

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck configCheck_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheckOrBuilder> configCheckBuilder_;
      /**
       * <code>required .ConfigCheck configCheck = 2;</code>
       * @return Whether the configCheck field is set.
       */
      public boolean hasConfigCheck() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required .ConfigCheck configCheck = 2;</code>
       * @return The configCheck.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck getConfigCheck() {
        if (configCheckBuilder_ == null) {
          return configCheck_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.getDefaultInstance() : configCheck_;
        } else {
          return configCheckBuilder_.getMessage();
        }
      }
      /**
       * <code>required .ConfigCheck configCheck = 2;</code>
       */
      public Builder setConfigCheck(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck value) {
        if (configCheckBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          configCheck_ = value;
          onChanged();
        } else {
          configCheckBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .ConfigCheck configCheck = 2;</code>
       */
      public Builder setConfigCheck(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Builder builderForValue) {
        if (configCheckBuilder_ == null) {
          configCheck_ = builderForValue.build();
          onChanged();
        } else {
          configCheckBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .ConfigCheck configCheck = 2;</code>
       */
      public Builder mergeConfigCheck(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck value) {
        if (configCheckBuilder_ == null) {
          if (((bitField0_ & 0x00000002) != 0) &&
              configCheck_ != null &&
              configCheck_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.getDefaultInstance()) {
            configCheck_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.newBuilder(configCheck_).mergeFrom(value).buildPartial();
          } else {
            configCheck_ = value;
          }
          onChanged();
        } else {
          configCheckBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .ConfigCheck configCheck = 2;</code>
       */
      public Builder clearConfigCheck() {
        if (configCheckBuilder_ == null) {
          configCheck_ = null;
          onChanged();
        } else {
          configCheckBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }
      /**
       * <code>required .ConfigCheck configCheck = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Builder getConfigCheckBuilder() {
        bitField0_ |= 0x00000002;
        onChanged();
        return getConfigCheckFieldBuilder().getBuilder();
      }
      /**
       * <code>required .ConfigCheck configCheck = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheckOrBuilder getConfigCheckOrBuilder() {
        if (configCheckBuilder_ != null) {
          return configCheckBuilder_.getMessageOrBuilder();
        } else {
          return configCheck_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.getDefaultInstance() : configCheck_;
        }
      }
      /**
       * <code>required .ConfigCheck configCheck = 2;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheckOrBuilder> 
          getConfigCheckFieldBuilder() {
        if (configCheckBuilder_ == null) {
          configCheckBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheckOrBuilder>(
                  getConfigCheck(),
                  getParentForChildren(),
                  isClean());
          configCheck_ = null;
        }
        return configCheckBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:InitJoinAck)
    }

    // @@protoc_insertion_point(class_scope:InitJoinAck)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<InitJoinAck>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<InitJoinAck>() {
      @java.lang.Override
      public InitJoinAck parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new InitJoinAck(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<InitJoinAck> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<InitJoinAck> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.InitJoinAck getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ConfigCheckOrBuilder extends
      // @@protoc_insertion_point(interface_extends:ConfigCheck)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .ConfigCheck.Type type = 1;</code>
     * @return Whether the type field is set.
     */
    boolean hasType();
    /**
     * <code>required .ConfigCheck.Type type = 1;</code>
     * @return The type.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type getType();

    /**
     * <code>optional string clusterConfig = 2;</code>
     * @return Whether the clusterConfig field is set.
     */
    boolean hasClusterConfig();
    /**
     * <code>optional string clusterConfig = 2;</code>
     * @return The clusterConfig.
     */
    java.lang.String getClusterConfig();
    /**
     * <code>optional string clusterConfig = 2;</code>
     * @return The bytes for clusterConfig.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getClusterConfigBytes();
  }
  /**
   * Protobuf type {@code ConfigCheck}
   */
  public  static final class ConfigCheck extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:ConfigCheck)
      ConfigCheckOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ConfigCheck.newBuilder() to construct.
    private ConfigCheck(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ConfigCheck() {
      type_ = 1;
      clusterConfig_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new ConfigCheck();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private ConfigCheck(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              int rawValue = input.readEnum();
                @SuppressWarnings("deprecation")
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type value = org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(1, rawValue);
              } else {
                bitField0_ |= 0x00000001;
                type_ = rawValue;
              }
              break;
            }
            case 18: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000002;
              clusterConfig_ = bs;
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ConfigCheck_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ConfigCheck_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Builder.class);
    }

    /**
     * Protobuf enum {@code ConfigCheck.Type}
     */
    public enum Type
        implements org.apache.pekko.protobufv3.internal.ProtocolMessageEnum {
      /**
       * <code>UncheckedConfig = 1;</code>
       */
      UncheckedConfig(1),
      /**
       * <code>IncompatibleConfig = 2;</code>
       */
      IncompatibleConfig(2),
      /**
       * <code>CompatibleConfig = 3;</code>
       */
      CompatibleConfig(3),
      ;

      /**
       * <code>UncheckedConfig = 1;</code>
       */
      public static final int UncheckedConfig_VALUE = 1;
      /**
       * <code>IncompatibleConfig = 2;</code>
       */
      public static final int IncompatibleConfig_VALUE = 2;
      /**
       * <code>CompatibleConfig = 3;</code>
       */
      public static final int CompatibleConfig_VALUE = 3;


      public final int getNumber() {
        return value;
      }

      /**
       * @param value The numeric wire value of the corresponding enum entry.
       * @return The enum associated with the given numeric wire value.
       * @deprecated Use {@link #forNumber(int)} instead.
       */
      @java.lang.Deprecated
      public static Type valueOf(int value) {
        return forNumber(value);
      }

      /**
       * @param value The numeric wire value of the corresponding enum entry.
       * @return The enum associated with the given numeric wire value.
       */
      public static Type forNumber(int value) {
        switch (value) {
          case 1: return UncheckedConfig;
          case 2: return IncompatibleConfig;
          case 3: return CompatibleConfig;
          default: return null;
        }
      }

      public static org.apache.pekko.protobufv3.internal.Internal.EnumLiteMap<Type>
          internalGetValueMap() {
        return internalValueMap;
      }
      private static final org.apache.pekko.protobufv3.internal.Internal.EnumLiteMap<
          Type> internalValueMap =
            new org.apache.pekko.protobufv3.internal.Internal.EnumLiteMap<Type>() {
              public Type findValueByNumber(int number) {
                return Type.forNumber(number);
              }
            };

      public final org.apache.pekko.protobufv3.internal.Descriptors.EnumValueDescriptor
          getValueDescriptor() {
        return getDescriptor().getValues().get(ordinal());
      }
      public final org.apache.pekko.protobufv3.internal.Descriptors.EnumDescriptor
          getDescriptorForType() {
        return getDescriptor();
      }
      public static final org.apache.pekko.protobufv3.internal.Descriptors.EnumDescriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.getDescriptor().getEnumTypes().get(0);
      }

      private static final Type[] VALUES = values();

      public static Type valueOf(
          org.apache.pekko.protobufv3.internal.Descriptors.EnumValueDescriptor desc) {
        if (desc.getType() != getDescriptor()) {
          throw new java.lang.IllegalArgumentException(
            "EnumValueDescriptor is not for this type.");
        }
        return VALUES[desc.getIndex()];
      }

      private final int value;

      private Type(int value) {
        this.value = value;
      }

      // @@protoc_insertion_point(enum_scope:ConfigCheck.Type)
    }

    private int bitField0_;
    public static final int TYPE_FIELD_NUMBER = 1;
    private int type_;
    /**
     * <code>required .ConfigCheck.Type type = 1;</code>
     * @return Whether the type field is set.
     */
    public boolean hasType() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .ConfigCheck.Type type = 1;</code>
     * @return The type.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type getType() {
      @SuppressWarnings("deprecation")
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type result = org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type.valueOf(type_);
      return result == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type.UncheckedConfig : result;
    }

    public static final int CLUSTERCONFIG_FIELD_NUMBER = 2;
    private volatile java.lang.Object clusterConfig_;
    /**
     * <code>optional string clusterConfig = 2;</code>
     * @return Whether the clusterConfig field is set.
     */
    public boolean hasClusterConfig() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>optional string clusterConfig = 2;</code>
     * @return The clusterConfig.
     */
    public java.lang.String getClusterConfig() {
      java.lang.Object ref = clusterConfig_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.pekko.protobufv3.internal.ByteString bs = 
            (org.apache.pekko.protobufv3.internal.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          clusterConfig_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string clusterConfig = 2;</code>
     * @return The bytes for clusterConfig.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getClusterConfigBytes() {
      java.lang.Object ref = clusterConfig_;
      if (ref instanceof java.lang.String) {
        org.apache.pekko.protobufv3.internal.ByteString b = 
            org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        clusterConfig_ = b;
        return b;
      } else {
        return (org.apache.pekko.protobufv3.internal.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasType()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeEnum(1, type_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 2, clusterConfig_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeEnumSize(1, type_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.GeneratedMessageV3.computeStringSize(2, clusterConfig_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck) obj;

      if (hasType() != other.hasType()) return false;
      if (hasType()) {
        if (type_ != other.type_) return false;
      }
      if (hasClusterConfig() != other.hasClusterConfig()) return false;
      if (hasClusterConfig()) {
        if (!getClusterConfig()
            .equals(other.getClusterConfig())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasType()) {
        hash = (37 * hash) + TYPE_FIELD_NUMBER;
        hash = (53 * hash) + type_;
      }
      if (hasClusterConfig()) {
        hash = (37 * hash) + CLUSTERCONFIG_FIELD_NUMBER;
        hash = (53 * hash) + getClusterConfig().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code ConfigCheck}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:ConfigCheck)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheckOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ConfigCheck_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ConfigCheck_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        type_ = 1;
        bitField0_ = (bitField0_ & ~0x00000001);
        clusterConfig_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ConfigCheck_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          to_bitField0_ |= 0x00000001;
        }
        result.type_ = type_;
        if (((from_bitField0_ & 0x00000002) != 0)) {
          to_bitField0_ |= 0x00000002;
        }
        result.clusterConfig_ = clusterConfig_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.getDefaultInstance()) return this;
        if (other.hasType()) {
          setType(other.getType());
        }
        if (other.hasClusterConfig()) {
          bitField0_ |= 0x00000002;
          clusterConfig_ = other.clusterConfig_;
          onChanged();
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasType()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private int type_ = 1;
      /**
       * <code>required .ConfigCheck.Type type = 1;</code>
       * @return Whether the type field is set.
       */
      public boolean hasType() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .ConfigCheck.Type type = 1;</code>
       * @return The type.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type getType() {
        @SuppressWarnings("deprecation")
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type result = org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type.valueOf(type_);
        return result == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type.UncheckedConfig : result;
      }
      /**
       * <code>required .ConfigCheck.Type type = 1;</code>
       * @param value The type to set.
       * @return This builder for chaining.
       */
      public Builder setType(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck.Type value) {
        if (value == null) {
          throw new NullPointerException();
        }
        bitField0_ |= 0x00000001;
        type_ = value.getNumber();
        onChanged();
        return this;
      }
      /**
       * <code>required .ConfigCheck.Type type = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearType() {
        bitField0_ = (bitField0_ & ~0x00000001);
        type_ = 1;
        onChanged();
        return this;
      }

      private java.lang.Object clusterConfig_ = "";
      /**
       * <code>optional string clusterConfig = 2;</code>
       * @return Whether the clusterConfig field is set.
       */
      public boolean hasClusterConfig() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>optional string clusterConfig = 2;</code>
       * @return The clusterConfig.
       */
      public java.lang.String getClusterConfig() {
        java.lang.Object ref = clusterConfig_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.pekko.protobufv3.internal.ByteString bs =
              (org.apache.pekko.protobufv3.internal.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            clusterConfig_ = s;
          }
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string clusterConfig = 2;</code>
       * @return The bytes for clusterConfig.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getClusterConfigBytes() {
        java.lang.Object ref = clusterConfig_;
        if (ref instanceof String) {
          org.apache.pekko.protobufv3.internal.ByteString b = 
              org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          clusterConfig_ = b;
          return b;
        } else {
          return (org.apache.pekko.protobufv3.internal.ByteString) ref;
        }
      }
      /**
       * <code>optional string clusterConfig = 2;</code>
       * @param value The clusterConfig to set.
       * @return This builder for chaining.
       */
      public Builder setClusterConfig(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        clusterConfig_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string clusterConfig = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearClusterConfig() {
        bitField0_ = (bitField0_ & ~0x00000002);
        clusterConfig_ = getDefaultInstance().getClusterConfig();
        onChanged();
        return this;
      }
      /**
       * <code>optional string clusterConfig = 2;</code>
       * @param value The bytes for clusterConfig to set.
       * @return This builder for chaining.
       */
      public Builder setClusterConfigBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        clusterConfig_ = value;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:ConfigCheck)
    }

    // @@protoc_insertion_point(class_scope:ConfigCheck)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<ConfigCheck>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<ConfigCheck>() {
      @java.lang.Override
      public ConfigCheck parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new ConfigCheck(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<ConfigCheck> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<ConfigCheck> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ConfigCheck getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface HeartbeatOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Heartbeat)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .Address from = 1;</code>
     * @return Whether the from field is set.
     */
    boolean hasFrom();
    /**
     * <code>required .Address from = 1;</code>
     * @return The from.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getFrom();
    /**
     * <code>required .Address from = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder getFromOrBuilder();

    /**
     * <code>optional int64 sequenceNr = 2;</code>
     * @return Whether the sequenceNr field is set.
     */
    boolean hasSequenceNr();
    /**
     * <code>optional int64 sequenceNr = 2;</code>
     * @return The sequenceNr.
     */
    long getSequenceNr();

    /**
     * <code>optional sint64 creationTime = 3;</code>
     * @return Whether the creationTime field is set.
     */
    boolean hasCreationTime();
    /**
     * <code>optional sint64 creationTime = 3;</code>
     * @return The creationTime.
     */
    long getCreationTime();
  }
  /**
   * <pre>
   **
   * Prior to version 2.5.24
   * Heartbeat sends an Address
   * Version 2.5.24 can deserialize this message but does not send it.
   * </pre>
   *
   * Protobuf type {@code Heartbeat}
   */
  public  static final class Heartbeat extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Heartbeat)
      HeartbeatOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Heartbeat.newBuilder() to construct.
    private Heartbeat(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Heartbeat() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new Heartbeat();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Heartbeat(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = from_.toBuilder();
              }
              from_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(from_);
                from_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              sequenceNr_ = input.readInt64();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              creationTime_ = input.readSInt64();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Heartbeat_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Heartbeat_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat.Builder.class);
    }

    private int bitField0_;
    public static final int FROM_FIELD_NUMBER = 1;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address from_;
    /**
     * <code>required .Address from = 1;</code>
     * @return Whether the from field is set.
     */
    public boolean hasFrom() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .Address from = 1;</code>
     * @return The from.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getFrom() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : from_;
    }
    /**
     * <code>required .Address from = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder getFromOrBuilder() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : from_;
    }

    public static final int SEQUENCENR_FIELD_NUMBER = 2;
    private long sequenceNr_;
    /**
     * <code>optional int64 sequenceNr = 2;</code>
     * @return Whether the sequenceNr field is set.
     */
    public boolean hasSequenceNr() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>optional int64 sequenceNr = 2;</code>
     * @return The sequenceNr.
     */
    public long getSequenceNr() {
      return sequenceNr_;
    }

    public static final int CREATIONTIME_FIELD_NUMBER = 3;
    private long creationTime_;
    /**
     * <code>optional sint64 creationTime = 3;</code>
     * @return Whether the creationTime field is set.
     */
    public boolean hasCreationTime() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <code>optional sint64 creationTime = 3;</code>
     * @return The creationTime.
     */
    public long getCreationTime() {
      return creationTime_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasFrom()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getFrom().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(1, getFrom());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeInt64(2, sequenceNr_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeSInt64(3, creationTime_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, getFrom());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt64Size(2, sequenceNr_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeSInt64Size(3, creationTime_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat) obj;

      if (hasFrom() != other.hasFrom()) return false;
      if (hasFrom()) {
        if (!getFrom()
            .equals(other.getFrom())) return false;
      }
      if (hasSequenceNr() != other.hasSequenceNr()) return false;
      if (hasSequenceNr()) {
        if (getSequenceNr()
            != other.getSequenceNr()) return false;
      }
      if (hasCreationTime() != other.hasCreationTime()) return false;
      if (hasCreationTime()) {
        if (getCreationTime()
            != other.getCreationTime()) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasFrom()) {
        hash = (37 * hash) + FROM_FIELD_NUMBER;
        hash = (53 * hash) + getFrom().hashCode();
      }
      if (hasSequenceNr()) {
        hash = (37 * hash) + SEQUENCENR_FIELD_NUMBER;
        hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashLong(
            getSequenceNr());
      }
      if (hasCreationTime()) {
        hash = (37 * hash) + CREATIONTIME_FIELD_NUMBER;
        hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashLong(
            getCreationTime());
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Prior to version 2.5.24
     * Heartbeat sends an Address
     * Version 2.5.24 can deserialize this message but does not send it.
     * </pre>
     *
     * Protobuf type {@code Heartbeat}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Heartbeat)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartbeatOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Heartbeat_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Heartbeat_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getFromFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (fromBuilder_ == null) {
          from_ = null;
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        sequenceNr_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000002);
        creationTime_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Heartbeat_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          if (fromBuilder_ == null) {
            result.from_ = from_;
          } else {
            result.from_ = fromBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.sequenceNr_ = sequenceNr_;
          to_bitField0_ |= 0x00000002;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.creationTime_ = creationTime_;
          to_bitField0_ |= 0x00000004;
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat.getDefaultInstance()) return this;
        if (other.hasFrom()) {
          mergeFrom(other.getFrom());
        }
        if (other.hasSequenceNr()) {
          setSequenceNr(other.getSequenceNr());
        }
        if (other.hasCreationTime()) {
          setCreationTime(other.getCreationTime());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasFrom()) {
          return false;
        }
        if (!getFrom().isInitialized()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address from_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder> fromBuilder_;
      /**
       * <code>required .Address from = 1;</code>
       * @return Whether the from field is set.
       */
      public boolean hasFrom() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .Address from = 1;</code>
       * @return The from.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getFrom() {
        if (fromBuilder_ == null) {
          return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : from_;
        } else {
          return fromBuilder_.getMessage();
        }
      }
      /**
       * <code>required .Address from = 1;</code>
       */
      public Builder setFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address value) {
        if (fromBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          from_ = value;
          onChanged();
        } else {
          fromBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Address from = 1;</code>
       */
      public Builder setFrom(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder builderForValue) {
        if (fromBuilder_ == null) {
          from_ = builderForValue.build();
          onChanged();
        } else {
          fromBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Address from = 1;</code>
       */
      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address value) {
        if (fromBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0) &&
              from_ != null &&
              from_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance()) {
            from_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.newBuilder(from_).mergeFrom(value).buildPartial();
          } else {
            from_ = value;
          }
          onChanged();
        } else {
          fromBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Address from = 1;</code>
       */
      public Builder clearFrom() {
        if (fromBuilder_ == null) {
          from_ = null;
          onChanged();
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .Address from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder getFromBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getFromFieldBuilder().getBuilder();
      }
      /**
       * <code>required .Address from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder getFromOrBuilder() {
        if (fromBuilder_ != null) {
          return fromBuilder_.getMessageOrBuilder();
        } else {
          return from_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : from_;
        }
      }
      /**
       * <code>required .Address from = 1;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder> 
          getFromFieldBuilder() {
        if (fromBuilder_ == null) {
          fromBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder>(
                  getFrom(),
                  getParentForChildren(),
                  isClean());
          from_ = null;
        }
        return fromBuilder_;
      }

      private long sequenceNr_ ;
      /**
       * <code>optional int64 sequenceNr = 2;</code>
       * @return Whether the sequenceNr field is set.
       */
      public boolean hasSequenceNr() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>optional int64 sequenceNr = 2;</code>
       * @return The sequenceNr.
       */
      public long getSequenceNr() {
        return sequenceNr_;
      }
      /**
       * <code>optional int64 sequenceNr = 2;</code>
       * @param value The sequenceNr to set.
       * @return This builder for chaining.
       */
      public Builder setSequenceNr(long value) {
        bitField0_ |= 0x00000002;
        sequenceNr_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int64 sequenceNr = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearSequenceNr() {
        bitField0_ = (bitField0_ & ~0x00000002);
        sequenceNr_ = 0L;
        onChanged();
        return this;
      }

      private long creationTime_ ;
      /**
       * <code>optional sint64 creationTime = 3;</code>
       * @return Whether the creationTime field is set.
       */
      public boolean hasCreationTime() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>optional sint64 creationTime = 3;</code>
       * @return The creationTime.
       */
      public long getCreationTime() {
        return creationTime_;
      }
      /**
       * <code>optional sint64 creationTime = 3;</code>
       * @param value The creationTime to set.
       * @return This builder for chaining.
       */
      public Builder setCreationTime(long value) {
        bitField0_ |= 0x00000004;
        creationTime_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional sint64 creationTime = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearCreationTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        creationTime_ = 0L;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Heartbeat)
    }

    // @@protoc_insertion_point(class_scope:Heartbeat)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Heartbeat>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Heartbeat>() {
      @java.lang.Override
      public Heartbeat parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new Heartbeat(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<Heartbeat> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<Heartbeat> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Heartbeat getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface HeartBeatResponseOrBuilder extends
      // @@protoc_insertion_point(interface_extends:HeartBeatResponse)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return Whether the from field is set.
     */
    boolean hasFrom();
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return The from.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom();
    /**
     * <code>required .UniqueAddress from = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder();

    /**
     * <code>optional int64 sequenceNr = 2;</code>
     * @return Whether the sequenceNr field is set.
     */
    boolean hasSequenceNr();
    /**
     * <code>optional int64 sequenceNr = 2;</code>
     * @return The sequenceNr.
     */
    long getSequenceNr();

    /**
     * <code>optional int64 creationTime = 3;</code>
     * @return Whether the creationTime field is set.
     */
    boolean hasCreationTime();
    /**
     * <code>optional int64 creationTime = 3;</code>
     * @return The creationTime.
     */
    long getCreationTime();
  }
  /**
   * <pre>
   **
   * Prior to version 2.5.24
   * HeartbeatRsp Sends an UniqueAddress
   * Version 2.5.24 can deserialize this message but does not send it.
   * </pre>
   *
   * Protobuf type {@code HeartBeatResponse}
   */
  public  static final class HeartBeatResponse extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:HeartBeatResponse)
      HeartBeatResponseOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use HeartBeatResponse.newBuilder() to construct.
    private HeartBeatResponse(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private HeartBeatResponse() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new HeartBeatResponse();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private HeartBeatResponse(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = from_.toBuilder();
              }
              from_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(from_);
                from_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              sequenceNr_ = input.readInt64();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              creationTime_ = input.readInt64();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_HeartBeatResponse_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_HeartBeatResponse_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse.Builder.class);
    }

    private int bitField0_;
    public static final int FROM_FIELD_NUMBER = 1;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress from_;
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return Whether the from field is set.
     */
    public boolean hasFrom() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return The from.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
    }
    /**
     * <code>required .UniqueAddress from = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
    }

    public static final int SEQUENCENR_FIELD_NUMBER = 2;
    private long sequenceNr_;
    /**
     * <code>optional int64 sequenceNr = 2;</code>
     * @return Whether the sequenceNr field is set.
     */
    public boolean hasSequenceNr() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>optional int64 sequenceNr = 2;</code>
     * @return The sequenceNr.
     */
    public long getSequenceNr() {
      return sequenceNr_;
    }

    public static final int CREATIONTIME_FIELD_NUMBER = 3;
    private long creationTime_;
    /**
     * <code>optional int64 creationTime = 3;</code>
     * @return Whether the creationTime field is set.
     */
    public boolean hasCreationTime() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <code>optional int64 creationTime = 3;</code>
     * @return The creationTime.
     */
    public long getCreationTime() {
      return creationTime_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasFrom()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getFrom().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(1, getFrom());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeInt64(2, sequenceNr_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeInt64(3, creationTime_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, getFrom());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt64Size(2, sequenceNr_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt64Size(3, creationTime_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse) obj;

      if (hasFrom() != other.hasFrom()) return false;
      if (hasFrom()) {
        if (!getFrom()
            .equals(other.getFrom())) return false;
      }
      if (hasSequenceNr() != other.hasSequenceNr()) return false;
      if (hasSequenceNr()) {
        if (getSequenceNr()
            != other.getSequenceNr()) return false;
      }
      if (hasCreationTime() != other.hasCreationTime()) return false;
      if (hasCreationTime()) {
        if (getCreationTime()
            != other.getCreationTime()) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasFrom()) {
        hash = (37 * hash) + FROM_FIELD_NUMBER;
        hash = (53 * hash) + getFrom().hashCode();
      }
      if (hasSequenceNr()) {
        hash = (37 * hash) + SEQUENCENR_FIELD_NUMBER;
        hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashLong(
            getSequenceNr());
      }
      if (hasCreationTime()) {
        hash = (37 * hash) + CREATIONTIME_FIELD_NUMBER;
        hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashLong(
            getCreationTime());
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Prior to version 2.5.24
     * HeartbeatRsp Sends an UniqueAddress
     * Version 2.5.24 can deserialize this message but does not send it.
     * </pre>
     *
     * Protobuf type {@code HeartBeatResponse}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:HeartBeatResponse)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponseOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_HeartBeatResponse_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_HeartBeatResponse_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getFromFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (fromBuilder_ == null) {
          from_ = null;
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        sequenceNr_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000002);
        creationTime_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_HeartBeatResponse_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          if (fromBuilder_ == null) {
            result.from_ = from_;
          } else {
            result.from_ = fromBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.sequenceNr_ = sequenceNr_;
          to_bitField0_ |= 0x00000002;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.creationTime_ = creationTime_;
          to_bitField0_ |= 0x00000004;
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse.getDefaultInstance()) return this;
        if (other.hasFrom()) {
          mergeFrom(other.getFrom());
        }
        if (other.hasSequenceNr()) {
          setSequenceNr(other.getSequenceNr());
        }
        if (other.hasCreationTime()) {
          setCreationTime(other.getCreationTime());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasFrom()) {
          return false;
        }
        if (!getFrom().isInitialized()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress from_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> fromBuilder_;
      /**
       * <code>required .UniqueAddress from = 1;</code>
       * @return Whether the from field is set.
       */
      public boolean hasFrom() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       * @return The from.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom() {
        if (fromBuilder_ == null) {
          return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
        } else {
          return fromBuilder_.getMessage();
        }
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder setFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (fromBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          from_ = value;
          onChanged();
        } else {
          fromBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder setFrom(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder builderForValue) {
        if (fromBuilder_ == null) {
          from_ = builderForValue.build();
          onChanged();
        } else {
          fromBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (fromBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0) &&
              from_ != null &&
              from_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance()) {
            from_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.newBuilder(from_).mergeFrom(value).buildPartial();
          } else {
            from_ = value;
          }
          onChanged();
        } else {
          fromBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder clearFrom() {
        if (fromBuilder_ == null) {
          from_ = null;
          onChanged();
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder getFromBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getFromFieldBuilder().getBuilder();
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder() {
        if (fromBuilder_ != null) {
          return fromBuilder_.getMessageOrBuilder();
        } else {
          return from_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
        }
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
          getFromFieldBuilder() {
        if (fromBuilder_ == null) {
          fromBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder>(
                  getFrom(),
                  getParentForChildren(),
                  isClean());
          from_ = null;
        }
        return fromBuilder_;
      }

      private long sequenceNr_ ;
      /**
       * <code>optional int64 sequenceNr = 2;</code>
       * @return Whether the sequenceNr field is set.
       */
      public boolean hasSequenceNr() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>optional int64 sequenceNr = 2;</code>
       * @return The sequenceNr.
       */
      public long getSequenceNr() {
        return sequenceNr_;
      }
      /**
       * <code>optional int64 sequenceNr = 2;</code>
       * @param value The sequenceNr to set.
       * @return This builder for chaining.
       */
      public Builder setSequenceNr(long value) {
        bitField0_ |= 0x00000002;
        sequenceNr_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int64 sequenceNr = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearSequenceNr() {
        bitField0_ = (bitField0_ & ~0x00000002);
        sequenceNr_ = 0L;
        onChanged();
        return this;
      }

      private long creationTime_ ;
      /**
       * <code>optional int64 creationTime = 3;</code>
       * @return Whether the creationTime field is set.
       */
      public boolean hasCreationTime() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>optional int64 creationTime = 3;</code>
       * @return The creationTime.
       */
      public long getCreationTime() {
        return creationTime_;
      }
      /**
       * <code>optional int64 creationTime = 3;</code>
       * @param value The creationTime to set.
       * @return This builder for chaining.
       */
      public Builder setCreationTime(long value) {
        bitField0_ |= 0x00000004;
        creationTime_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int64 creationTime = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearCreationTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        creationTime_ = 0L;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:HeartBeatResponse)
    }

    // @@protoc_insertion_point(class_scope:HeartBeatResponse)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<HeartBeatResponse>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<HeartBeatResponse>() {
      @java.lang.Override
      public HeartBeatResponse parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new HeartBeatResponse(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<HeartBeatResponse> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<HeartBeatResponse> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.HeartBeatResponse getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface GossipEnvelopeOrBuilder extends
      // @@protoc_insertion_point(interface_extends:GossipEnvelope)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return Whether the from field is set.
     */
    boolean hasFrom();
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return The from.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom();
    /**
     * <code>required .UniqueAddress from = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder();

    /**
     * <code>required .UniqueAddress to = 2;</code>
     * @return Whether the to field is set.
     */
    boolean hasTo();
    /**
     * <code>required .UniqueAddress to = 2;</code>
     * @return The to.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getTo();
    /**
     * <code>required .UniqueAddress to = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getToOrBuilder();

    /**
     * <code>required bytes serializedGossip = 3;</code>
     * @return Whether the serializedGossip field is set.
     */
    boolean hasSerializedGossip();
    /**
     * <code>required bytes serializedGossip = 3;</code>
     * @return The serializedGossip.
     */
    org.apache.pekko.protobufv3.internal.ByteString getSerializedGossip();
  }
  /**
   * <pre>
   **
   * Gossip Envelope
   * </pre>
   *
   * Protobuf type {@code GossipEnvelope}
   */
  public  static final class GossipEnvelope extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:GossipEnvelope)
      GossipEnvelopeOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use GossipEnvelope.newBuilder() to construct.
    private GossipEnvelope(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private GossipEnvelope() {
      serializedGossip_ = org.apache.pekko.protobufv3.internal.ByteString.EMPTY;
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new GossipEnvelope();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private GossipEnvelope(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = from_.toBuilder();
              }
              from_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(from_);
                from_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 18: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder subBuilder = null;
              if (((bitField0_ & 0x00000002) != 0)) {
                subBuilder = to_.toBuilder();
              }
              to_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(to_);
                to_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000002;
              break;
            }
            case 26: {
              bitField0_ |= 0x00000004;
              serializedGossip_ = input.readBytes();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipEnvelope_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipEnvelope_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope.Builder.class);
    }

    private int bitField0_;
    public static final int FROM_FIELD_NUMBER = 1;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress from_;
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return Whether the from field is set.
     */
    public boolean hasFrom() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return The from.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
    }
    /**
     * <code>required .UniqueAddress from = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
    }

    public static final int TO_FIELD_NUMBER = 2;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress to_;
    /**
     * <code>required .UniqueAddress to = 2;</code>
     * @return Whether the to field is set.
     */
    public boolean hasTo() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required .UniqueAddress to = 2;</code>
     * @return The to.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getTo() {
      return to_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : to_;
    }
    /**
     * <code>required .UniqueAddress to = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getToOrBuilder() {
      return to_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : to_;
    }

    public static final int SERIALIZEDGOSSIP_FIELD_NUMBER = 3;
    private org.apache.pekko.protobufv3.internal.ByteString serializedGossip_;
    /**
     * <code>required bytes serializedGossip = 3;</code>
     * @return Whether the serializedGossip field is set.
     */
    public boolean hasSerializedGossip() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <code>required bytes serializedGossip = 3;</code>
     * @return The serializedGossip.
     */
    public org.apache.pekko.protobufv3.internal.ByteString getSerializedGossip() {
      return serializedGossip_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasFrom()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasTo()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasSerializedGossip()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getFrom().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getTo().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(1, getFrom());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeMessage(2, getTo());
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeBytes(3, serializedGossip_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, getFrom());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(2, getTo());
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeBytesSize(3, serializedGossip_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope) obj;

      if (hasFrom() != other.hasFrom()) return false;
      if (hasFrom()) {
        if (!getFrom()
            .equals(other.getFrom())) return false;
      }
      if (hasTo() != other.hasTo()) return false;
      if (hasTo()) {
        if (!getTo()
            .equals(other.getTo())) return false;
      }
      if (hasSerializedGossip() != other.hasSerializedGossip()) return false;
      if (hasSerializedGossip()) {
        if (!getSerializedGossip()
            .equals(other.getSerializedGossip())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasFrom()) {
        hash = (37 * hash) + FROM_FIELD_NUMBER;
        hash = (53 * hash) + getFrom().hashCode();
      }
      if (hasTo()) {
        hash = (37 * hash) + TO_FIELD_NUMBER;
        hash = (53 * hash) + getTo().hashCode();
      }
      if (hasSerializedGossip()) {
        hash = (37 * hash) + SERIALIZEDGOSSIP_FIELD_NUMBER;
        hash = (53 * hash) + getSerializedGossip().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Gossip Envelope
     * </pre>
     *
     * Protobuf type {@code GossipEnvelope}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:GossipEnvelope)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelopeOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipEnvelope_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipEnvelope_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getFromFieldBuilder();
          getToFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (fromBuilder_ == null) {
          from_ = null;
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        if (toBuilder_ == null) {
          to_ = null;
        } else {
          toBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        serializedGossip_ = org.apache.pekko.protobufv3.internal.ByteString.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipEnvelope_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          if (fromBuilder_ == null) {
            result.from_ = from_;
          } else {
            result.from_ = fromBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          if (toBuilder_ == null) {
            result.to_ = to_;
          } else {
            result.to_ = toBuilder_.build();
          }
          to_bitField0_ |= 0x00000002;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          to_bitField0_ |= 0x00000004;
        }
        result.serializedGossip_ = serializedGossip_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope.getDefaultInstance()) return this;
        if (other.hasFrom()) {
          mergeFrom(other.getFrom());
        }
        if (other.hasTo()) {
          mergeTo(other.getTo());
        }
        if (other.hasSerializedGossip()) {
          setSerializedGossip(other.getSerializedGossip());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasFrom()) {
          return false;
        }
        if (!hasTo()) {
          return false;
        }
        if (!hasSerializedGossip()) {
          return false;
        }
        if (!getFrom().isInitialized()) {
          return false;
        }
        if (!getTo().isInitialized()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress from_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> fromBuilder_;
      /**
       * <code>required .UniqueAddress from = 1;</code>
       * @return Whether the from field is set.
       */
      public boolean hasFrom() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       * @return The from.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom() {
        if (fromBuilder_ == null) {
          return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
        } else {
          return fromBuilder_.getMessage();
        }
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder setFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (fromBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          from_ = value;
          onChanged();
        } else {
          fromBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder setFrom(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder builderForValue) {
        if (fromBuilder_ == null) {
          from_ = builderForValue.build();
          onChanged();
        } else {
          fromBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (fromBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0) &&
              from_ != null &&
              from_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance()) {
            from_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.newBuilder(from_).mergeFrom(value).buildPartial();
          } else {
            from_ = value;
          }
          onChanged();
        } else {
          fromBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder clearFrom() {
        if (fromBuilder_ == null) {
          from_ = null;
          onChanged();
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder getFromBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getFromFieldBuilder().getBuilder();
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder() {
        if (fromBuilder_ != null) {
          return fromBuilder_.getMessageOrBuilder();
        } else {
          return from_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
        }
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
          getFromFieldBuilder() {
        if (fromBuilder_ == null) {
          fromBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder>(
                  getFrom(),
                  getParentForChildren(),
                  isClean());
          from_ = null;
        }
        return fromBuilder_;
      }

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress to_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> toBuilder_;
      /**
       * <code>required .UniqueAddress to = 2;</code>
       * @return Whether the to field is set.
       */
      public boolean hasTo() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required .UniqueAddress to = 2;</code>
       * @return The to.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getTo() {
        if (toBuilder_ == null) {
          return to_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : to_;
        } else {
          return toBuilder_.getMessage();
        }
      }
      /**
       * <code>required .UniqueAddress to = 2;</code>
       */
      public Builder setTo(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (toBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          to_ = value;
          onChanged();
        } else {
          toBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .UniqueAddress to = 2;</code>
       */
      public Builder setTo(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder builderForValue) {
        if (toBuilder_ == null) {
          to_ = builderForValue.build();
          onChanged();
        } else {
          toBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .UniqueAddress to = 2;</code>
       */
      public Builder mergeTo(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (toBuilder_ == null) {
          if (((bitField0_ & 0x00000002) != 0) &&
              to_ != null &&
              to_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance()) {
            to_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.newBuilder(to_).mergeFrom(value).buildPartial();
          } else {
            to_ = value;
          }
          onChanged();
        } else {
          toBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .UniqueAddress to = 2;</code>
       */
      public Builder clearTo() {
        if (toBuilder_ == null) {
          to_ = null;
          onChanged();
        } else {
          toBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }
      /**
       * <code>required .UniqueAddress to = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder getToBuilder() {
        bitField0_ |= 0x00000002;
        onChanged();
        return getToFieldBuilder().getBuilder();
      }
      /**
       * <code>required .UniqueAddress to = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getToOrBuilder() {
        if (toBuilder_ != null) {
          return toBuilder_.getMessageOrBuilder();
        } else {
          return to_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : to_;
        }
      }
      /**
       * <code>required .UniqueAddress to = 2;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
          getToFieldBuilder() {
        if (toBuilder_ == null) {
          toBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder>(
                  getTo(),
                  getParentForChildren(),
                  isClean());
          to_ = null;
        }
        return toBuilder_;
      }

      private org.apache.pekko.protobufv3.internal.ByteString serializedGossip_ = org.apache.pekko.protobufv3.internal.ByteString.EMPTY;
      /**
       * <code>required bytes serializedGossip = 3;</code>
       * @return Whether the serializedGossip field is set.
       */
      public boolean hasSerializedGossip() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>required bytes serializedGossip = 3;</code>
       * @return The serializedGossip.
       */
      public org.apache.pekko.protobufv3.internal.ByteString getSerializedGossip() {
        return serializedGossip_;
      }
      /**
       * <code>required bytes serializedGossip = 3;</code>
       * @param value The serializedGossip to set.
       * @return This builder for chaining.
       */
      public Builder setSerializedGossip(org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        serializedGossip_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required bytes serializedGossip = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearSerializedGossip() {
        bitField0_ = (bitField0_ & ~0x00000004);
        serializedGossip_ = getDefaultInstance().getSerializedGossip();
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:GossipEnvelope)
    }

    // @@protoc_insertion_point(class_scope:GossipEnvelope)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<GossipEnvelope>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<GossipEnvelope>() {
      @java.lang.Override
      public GossipEnvelope parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new GossipEnvelope(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<GossipEnvelope> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<GossipEnvelope> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipEnvelope getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface GossipStatusOrBuilder extends
      // @@protoc_insertion_point(interface_extends:GossipStatus)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return Whether the from field is set.
     */
    boolean hasFrom();
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return The from.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom();
    /**
     * <code>required .UniqueAddress from = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder();

    /**
     * <code>repeated string allHashes = 2;</code>
     * @return A list containing the allHashes.
     */
    java.util.List<java.lang.String>
        getAllHashesList();
    /**
     * <code>repeated string allHashes = 2;</code>
     * @return The count of allHashes.
     */
    int getAllHashesCount();
    /**
     * <code>repeated string allHashes = 2;</code>
     * @param index The index of the element to return.
     * @return The allHashes at the given index.
     */
    java.lang.String getAllHashes(int index);
    /**
     * <code>repeated string allHashes = 2;</code>
     * @param index The index of the value to return.
     * @return The bytes of the allHashes at the given index.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getAllHashesBytes(int index);

    /**
     * <code>required .VectorClock version = 3;</code>
     * @return Whether the version field is set.
     */
    boolean hasVersion();
    /**
     * <code>required .VectorClock version = 3;</code>
     * @return The version.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock getVersion();
    /**
     * <code>required .VectorClock version = 3;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder getVersionOrBuilder();

    /**
     * <code>optional bytes seenDigest = 4;</code>
     * @return Whether the seenDigest field is set.
     */
    boolean hasSeenDigest();
    /**
     * <code>optional bytes seenDigest = 4;</code>
     * @return The seenDigest.
     */
    org.apache.pekko.protobufv3.internal.ByteString getSeenDigest();
  }
  /**
   * <pre>
   **
   * Gossip Status
   * </pre>
   *
   * Protobuf type {@code GossipStatus}
   */
  public  static final class GossipStatus extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:GossipStatus)
      GossipStatusOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use GossipStatus.newBuilder() to construct.
    private GossipStatus(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private GossipStatus() {
      allHashes_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      seenDigest_ = org.apache.pekko.protobufv3.internal.ByteString.EMPTY;
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new GossipStatus();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private GossipStatus(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = from_.toBuilder();
              }
              from_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(from_);
                from_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 18: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              if (!((mutable_bitField0_ & 0x00000002) != 0)) {
                allHashes_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000002;
              }
              allHashes_.add(bs);
              break;
            }
            case 26: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder subBuilder = null;
              if (((bitField0_ & 0x00000002) != 0)) {
                subBuilder = version_.toBuilder();
              }
              version_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(version_);
                version_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000002;
              break;
            }
            case 34: {
              bitField0_ |= 0x00000004;
              seenDigest_ = input.readBytes();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000002) != 0)) {
          allHashes_ = allHashes_.getUnmodifiableView();
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipStatus_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipStatus_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus.Builder.class);
    }

    private int bitField0_;
    public static final int FROM_FIELD_NUMBER = 1;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress from_;
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return Whether the from field is set.
     */
    public boolean hasFrom() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .UniqueAddress from = 1;</code>
     * @return The from.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
    }
    /**
     * <code>required .UniqueAddress from = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder() {
      return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
    }

    public static final int ALLHASHES_FIELD_NUMBER = 2;
    private org.apache.pekko.protobufv3.internal.LazyStringList allHashes_;
    /**
     * <code>repeated string allHashes = 2;</code>
     * @return A list containing the allHashes.
     */
    public org.apache.pekko.protobufv3.internal.ProtocolStringList
        getAllHashesList() {
      return allHashes_;
    }
    /**
     * <code>repeated string allHashes = 2;</code>
     * @return The count of allHashes.
     */
    public int getAllHashesCount() {
      return allHashes_.size();
    }
    /**
     * <code>repeated string allHashes = 2;</code>
     * @param index The index of the element to return.
     * @return The allHashes at the given index.
     */
    public java.lang.String getAllHashes(int index) {
      return allHashes_.get(index);
    }
    /**
     * <code>repeated string allHashes = 2;</code>
     * @param index The index of the value to return.
     * @return The bytes of the allHashes at the given index.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getAllHashesBytes(int index) {
      return allHashes_.getByteString(index);
    }

    public static final int VERSION_FIELD_NUMBER = 3;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock version_;
    /**
     * <code>required .VectorClock version = 3;</code>
     * @return Whether the version field is set.
     */
    public boolean hasVersion() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required .VectorClock version = 3;</code>
     * @return The version.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock getVersion() {
      return version_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance() : version_;
    }
    /**
     * <code>required .VectorClock version = 3;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder getVersionOrBuilder() {
      return version_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance() : version_;
    }

    public static final int SEENDIGEST_FIELD_NUMBER = 4;
    private org.apache.pekko.protobufv3.internal.ByteString seenDigest_;
    /**
     * <code>optional bytes seenDigest = 4;</code>
     * @return Whether the seenDigest field is set.
     */
    public boolean hasSeenDigest() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <code>optional bytes seenDigest = 4;</code>
     * @return The seenDigest.
     */
    public org.apache.pekko.protobufv3.internal.ByteString getSeenDigest() {
      return seenDigest_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasFrom()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasVersion()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getFrom().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getVersion().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(1, getFrom());
      }
      for (int i = 0; i < allHashes_.size(); i++) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 2, allHashes_.getRaw(i));
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeMessage(3, getVersion());
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeBytes(4, seenDigest_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, getFrom());
      }
      {
        int dataSize = 0;
        for (int i = 0; i < allHashes_.size(); i++) {
          dataSize += computeStringSizeNoTag(allHashes_.getRaw(i));
        }
        size += dataSize;
        size += 1 * getAllHashesList().size();
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(3, getVersion());
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeBytesSize(4, seenDigest_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus) obj;

      if (hasFrom() != other.hasFrom()) return false;
      if (hasFrom()) {
        if (!getFrom()
            .equals(other.getFrom())) return false;
      }
      if (!getAllHashesList()
          .equals(other.getAllHashesList())) return false;
      if (hasVersion() != other.hasVersion()) return false;
      if (hasVersion()) {
        if (!getVersion()
            .equals(other.getVersion())) return false;
      }
      if (hasSeenDigest() != other.hasSeenDigest()) return false;
      if (hasSeenDigest()) {
        if (!getSeenDigest()
            .equals(other.getSeenDigest())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasFrom()) {
        hash = (37 * hash) + FROM_FIELD_NUMBER;
        hash = (53 * hash) + getFrom().hashCode();
      }
      if (getAllHashesCount() > 0) {
        hash = (37 * hash) + ALLHASHES_FIELD_NUMBER;
        hash = (53 * hash) + getAllHashesList().hashCode();
      }
      if (hasVersion()) {
        hash = (37 * hash) + VERSION_FIELD_NUMBER;
        hash = (53 * hash) + getVersion().hashCode();
      }
      if (hasSeenDigest()) {
        hash = (37 * hash) + SEENDIGEST_FIELD_NUMBER;
        hash = (53 * hash) + getSeenDigest().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Gossip Status
     * </pre>
     *
     * Protobuf type {@code GossipStatus}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:GossipStatus)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatusOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipStatus_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipStatus_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getFromFieldBuilder();
          getVersionFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (fromBuilder_ == null) {
          from_ = null;
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        allHashes_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        if (versionBuilder_ == null) {
          version_ = null;
        } else {
          versionBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000004);
        seenDigest_ = org.apache.pekko.protobufv3.internal.ByteString.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000008);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipStatus_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          if (fromBuilder_ == null) {
            result.from_ = from_;
          } else {
            result.from_ = fromBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((bitField0_ & 0x00000002) != 0)) {
          allHashes_ = allHashes_.getUnmodifiableView();
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.allHashes_ = allHashes_;
        if (((from_bitField0_ & 0x00000004) != 0)) {
          if (versionBuilder_ == null) {
            result.version_ = version_;
          } else {
            result.version_ = versionBuilder_.build();
          }
          to_bitField0_ |= 0x00000002;
        }
        if (((from_bitField0_ & 0x00000008) != 0)) {
          to_bitField0_ |= 0x00000004;
        }
        result.seenDigest_ = seenDigest_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus.getDefaultInstance()) return this;
        if (other.hasFrom()) {
          mergeFrom(other.getFrom());
        }
        if (!other.allHashes_.isEmpty()) {
          if (allHashes_.isEmpty()) {
            allHashes_ = other.allHashes_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureAllHashesIsMutable();
            allHashes_.addAll(other.allHashes_);
          }
          onChanged();
        }
        if (other.hasVersion()) {
          mergeVersion(other.getVersion());
        }
        if (other.hasSeenDigest()) {
          setSeenDigest(other.getSeenDigest());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasFrom()) {
          return false;
        }
        if (!hasVersion()) {
          return false;
        }
        if (!getFrom().isInitialized()) {
          return false;
        }
        if (!getVersion().isInitialized()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress from_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> fromBuilder_;
      /**
       * <code>required .UniqueAddress from = 1;</code>
       * @return Whether the from field is set.
       */
      public boolean hasFrom() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       * @return The from.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getFrom() {
        if (fromBuilder_ == null) {
          return from_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
        } else {
          return fromBuilder_.getMessage();
        }
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder setFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (fromBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          from_ = value;
          onChanged();
        } else {
          fromBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder setFrom(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder builderForValue) {
        if (fromBuilder_ == null) {
          from_ = builderForValue.build();
          onChanged();
        } else {
          fromBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (fromBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0) &&
              from_ != null &&
              from_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance()) {
            from_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.newBuilder(from_).mergeFrom(value).buildPartial();
          } else {
            from_ = value;
          }
          onChanged();
        } else {
          fromBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public Builder clearFrom() {
        if (fromBuilder_ == null) {
          from_ = null;
          onChanged();
        } else {
          fromBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder getFromBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getFromFieldBuilder().getBuilder();
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getFromOrBuilder() {
        if (fromBuilder_ != null) {
          return fromBuilder_.getMessageOrBuilder();
        } else {
          return from_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance() : from_;
        }
      }
      /**
       * <code>required .UniqueAddress from = 1;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
          getFromFieldBuilder() {
        if (fromBuilder_ == null) {
          fromBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder>(
                  getFrom(),
                  getParentForChildren(),
                  isClean());
          from_ = null;
        }
        return fromBuilder_;
      }

      private org.apache.pekko.protobufv3.internal.LazyStringList allHashes_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      private void ensureAllHashesIsMutable() {
        if (!((bitField0_ & 0x00000002) != 0)) {
          allHashes_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList(allHashes_);
          bitField0_ |= 0x00000002;
         }
      }
      /**
       * <code>repeated string allHashes = 2;</code>
       * @return A list containing the allHashes.
       */
      public org.apache.pekko.protobufv3.internal.ProtocolStringList
          getAllHashesList() {
        return allHashes_.getUnmodifiableView();
      }
      /**
       * <code>repeated string allHashes = 2;</code>
       * @return The count of allHashes.
       */
      public int getAllHashesCount() {
        return allHashes_.size();
      }
      /**
       * <code>repeated string allHashes = 2;</code>
       * @param index The index of the element to return.
       * @return The allHashes at the given index.
       */
      public java.lang.String getAllHashes(int index) {
        return allHashes_.get(index);
      }
      /**
       * <code>repeated string allHashes = 2;</code>
       * @param index The index of the value to return.
       * @return The bytes of the allHashes at the given index.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getAllHashesBytes(int index) {
        return allHashes_.getByteString(index);
      }
      /**
       * <code>repeated string allHashes = 2;</code>
       * @param index The index to set the value at.
       * @param value The allHashes to set.
       * @return This builder for chaining.
       */
      public Builder setAllHashes(
          int index, java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllHashesIsMutable();
        allHashes_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allHashes = 2;</code>
       * @param value The allHashes to add.
       * @return This builder for chaining.
       */
      public Builder addAllHashes(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllHashesIsMutable();
        allHashes_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allHashes = 2;</code>
       * @param values The allHashes to add.
       * @return This builder for chaining.
       */
      public Builder addAllAllHashes(
          java.lang.Iterable<java.lang.String> values) {
        ensureAllHashesIsMutable();
        org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
            values, allHashes_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allHashes = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearAllHashes() {
        allHashes_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allHashes = 2;</code>
       * @param value The bytes of the allHashes to add.
       * @return This builder for chaining.
       */
      public Builder addAllHashesBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllHashesIsMutable();
        allHashes_.add(value);
        onChanged();
        return this;
      }

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock version_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder> versionBuilder_;
      /**
       * <code>required .VectorClock version = 3;</code>
       * @return Whether the version field is set.
       */
      public boolean hasVersion() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>required .VectorClock version = 3;</code>
       * @return The version.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock getVersion() {
        if (versionBuilder_ == null) {
          return version_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance() : version_;
        } else {
          return versionBuilder_.getMessage();
        }
      }
      /**
       * <code>required .VectorClock version = 3;</code>
       */
      public Builder setVersion(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock value) {
        if (versionBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          version_ = value;
          onChanged();
        } else {
          versionBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000004;
        return this;
      }
      /**
       * <code>required .VectorClock version = 3;</code>
       */
      public Builder setVersion(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder builderForValue) {
        if (versionBuilder_ == null) {
          version_ = builderForValue.build();
          onChanged();
        } else {
          versionBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000004;
        return this;
      }
      /**
       * <code>required .VectorClock version = 3;</code>
       */
      public Builder mergeVersion(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock value) {
        if (versionBuilder_ == null) {
          if (((bitField0_ & 0x00000004) != 0) &&
              version_ != null &&
              version_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance()) {
            version_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.newBuilder(version_).mergeFrom(value).buildPartial();
          } else {
            version_ = value;
          }
          onChanged();
        } else {
          versionBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000004;
        return this;
      }
      /**
       * <code>required .VectorClock version = 3;</code>
       */
      public Builder clearVersion() {
        if (versionBuilder_ == null) {
          version_ = null;
          onChanged();
        } else {
          versionBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }
      /**
       * <code>required .VectorClock version = 3;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder getVersionBuilder() {
        bitField0_ |= 0x00000004;
        onChanged();
        return getVersionFieldBuilder().getBuilder();
      }
      /**
       * <code>required .VectorClock version = 3;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder getVersionOrBuilder() {
        if (versionBuilder_ != null) {
          return versionBuilder_.getMessageOrBuilder();
        } else {
          return version_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance() : version_;
        }
      }
      /**
       * <code>required .VectorClock version = 3;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder> 
          getVersionFieldBuilder() {
        if (versionBuilder_ == null) {
          versionBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder>(
                  getVersion(),
                  getParentForChildren(),
                  isClean());
          version_ = null;
        }
        return versionBuilder_;
      }

      private org.apache.pekko.protobufv3.internal.ByteString seenDigest_ = org.apache.pekko.protobufv3.internal.ByteString.EMPTY;
      /**
       * <code>optional bytes seenDigest = 4;</code>
       * @return Whether the seenDigest field is set.
       */
      public boolean hasSeenDigest() {
        return ((bitField0_ & 0x00000008) != 0);
      }
      /**
       * <code>optional bytes seenDigest = 4;</code>
       * @return The seenDigest.
       */
      public org.apache.pekko.protobufv3.internal.ByteString getSeenDigest() {
        return seenDigest_;
      }
      /**
       * <code>optional bytes seenDigest = 4;</code>
       * @param value The seenDigest to set.
       * @return This builder for chaining.
       */
      public Builder setSeenDigest(org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        seenDigest_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional bytes seenDigest = 4;</code>
       * @return This builder for chaining.
       */
      public Builder clearSeenDigest() {
        bitField0_ = (bitField0_ & ~0x00000008);
        seenDigest_ = getDefaultInstance().getSeenDigest();
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:GossipStatus)
    }

    // @@protoc_insertion_point(class_scope:GossipStatus)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<GossipStatus>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<GossipStatus>() {
      @java.lang.Override
      public GossipStatus parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new GossipStatus(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<GossipStatus> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<GossipStatus> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipStatus getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface GossipOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Gossip)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress> 
        getAllAddressesList();
    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getAllAddresses(int index);
    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    int getAllAddressesCount();
    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
        getAllAddressesOrBuilderList();
    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getAllAddressesOrBuilder(
        int index);

    /**
     * <code>repeated string allRoles = 2;</code>
     * @return A list containing the allRoles.
     */
    java.util.List<java.lang.String>
        getAllRolesList();
    /**
     * <code>repeated string allRoles = 2;</code>
     * @return The count of allRoles.
     */
    int getAllRolesCount();
    /**
     * <code>repeated string allRoles = 2;</code>
     * @param index The index of the element to return.
     * @return The allRoles at the given index.
     */
    java.lang.String getAllRoles(int index);
    /**
     * <code>repeated string allRoles = 2;</code>
     * @param index The index of the value to return.
     * @return The bytes of the allRoles at the given index.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getAllRolesBytes(int index);

    /**
     * <code>repeated string allHashes = 3;</code>
     * @return A list containing the allHashes.
     */
    java.util.List<java.lang.String>
        getAllHashesList();
    /**
     * <code>repeated string allHashes = 3;</code>
     * @return The count of allHashes.
     */
    int getAllHashesCount();
    /**
     * <code>repeated string allHashes = 3;</code>
     * @param index The index of the element to return.
     * @return The allHashes at the given index.
     */
    java.lang.String getAllHashes(int index);
    /**
     * <code>repeated string allHashes = 3;</code>
     * @param index The index of the value to return.
     * @return The bytes of the allHashes at the given index.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getAllHashesBytes(int index);

    /**
     * <code>repeated .Member members = 4;</code>
     */
    java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member> 
        getMembersList();
    /**
     * <code>repeated .Member members = 4;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member getMembers(int index);
    /**
     * <code>repeated .Member members = 4;</code>
     */
    int getMembersCount();
    /**
     * <code>repeated .Member members = 4;</code>
     */
    java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder> 
        getMembersOrBuilderList();
    /**
     * <code>repeated .Member members = 4;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder getMembersOrBuilder(
        int index);

    /**
     * <code>required .GossipOverview overview = 5;</code>
     * @return Whether the overview field is set.
     */
    boolean hasOverview();
    /**
     * <code>required .GossipOverview overview = 5;</code>
     * @return The overview.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview getOverview();
    /**
     * <code>required .GossipOverview overview = 5;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverviewOrBuilder getOverviewOrBuilder();

    /**
     * <code>required .VectorClock version = 6;</code>
     * @return Whether the version field is set.
     */
    boolean hasVersion();
    /**
     * <code>required .VectorClock version = 6;</code>
     * @return The version.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock getVersion();
    /**
     * <code>required .VectorClock version = 6;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder getVersionOrBuilder();

    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone> 
        getTombstonesList();
    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone getTombstones(int index);
    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    int getTombstonesCount();
    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder> 
        getTombstonesOrBuilderList();
    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder getTombstonesOrBuilder(
        int index);

    /**
     * <code>repeated string allAppVersions = 8;</code>
     * @return A list containing the allAppVersions.
     */
    java.util.List<java.lang.String>
        getAllAppVersionsList();
    /**
     * <code>repeated string allAppVersions = 8;</code>
     * @return The count of allAppVersions.
     */
    int getAllAppVersionsCount();
    /**
     * <code>repeated string allAppVersions = 8;</code>
     * @param index The index of the element to return.
     * @return The allAppVersions at the given index.
     */
    java.lang.String getAllAppVersions(int index);
    /**
     * <code>repeated string allAppVersions = 8;</code>
     * @param index The index of the value to return.
     * @return The bytes of the allAppVersions at the given index.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getAllAppVersionsBytes(int index);
  }
  /**
   * <pre>
   **
   * Gossip
   * </pre>
   *
   * Protobuf type {@code Gossip}
   */
  public  static final class Gossip extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Gossip)
      GossipOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Gossip.newBuilder() to construct.
    private Gossip(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Gossip() {
      allAddresses_ = java.util.Collections.emptyList();
      allRoles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      allHashes_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      members_ = java.util.Collections.emptyList();
      tombstones_ = java.util.Collections.emptyList();
      allAppVersions_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new Gossip();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Gossip(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              if (!((mutable_bitField0_ & 0x00000001) != 0)) {
                allAddresses_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress>();
                mutable_bitField0_ |= 0x00000001;
              }
              allAddresses_.add(
                  input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.PARSER, extensionRegistry));
              break;
            }
            case 18: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              if (!((mutable_bitField0_ & 0x00000002) != 0)) {
                allRoles_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000002;
              }
              allRoles_.add(bs);
              break;
            }
            case 26: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              if (!((mutable_bitField0_ & 0x00000004) != 0)) {
                allHashes_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000004;
              }
              allHashes_.add(bs);
              break;
            }
            case 34: {
              if (!((mutable_bitField0_ & 0x00000008) != 0)) {
                members_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member>();
                mutable_bitField0_ |= 0x00000008;
              }
              members_.add(
                  input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.PARSER, extensionRegistry));
              break;
            }
            case 42: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = overview_.toBuilder();
              }
              overview_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(overview_);
                overview_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 50: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder subBuilder = null;
              if (((bitField0_ & 0x00000002) != 0)) {
                subBuilder = version_.toBuilder();
              }
              version_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(version_);
                version_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000002;
              break;
            }
            case 58: {
              if (!((mutable_bitField0_ & 0x00000040) != 0)) {
                tombstones_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone>();
                mutable_bitField0_ |= 0x00000040;
              }
              tombstones_.add(
                  input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.PARSER, extensionRegistry));
              break;
            }
            case 66: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              if (!((mutable_bitField0_ & 0x00000080) != 0)) {
                allAppVersions_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000080;
              }
              allAppVersions_.add(bs);
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000001) != 0)) {
          allAddresses_ = java.util.Collections.unmodifiableList(allAddresses_);
        }
        if (((mutable_bitField0_ & 0x00000002) != 0)) {
          allRoles_ = allRoles_.getUnmodifiableView();
        }
        if (((mutable_bitField0_ & 0x00000004) != 0)) {
          allHashes_ = allHashes_.getUnmodifiableView();
        }
        if (((mutable_bitField0_ & 0x00000008) != 0)) {
          members_ = java.util.Collections.unmodifiableList(members_);
        }
        if (((mutable_bitField0_ & 0x00000040) != 0)) {
          tombstones_ = java.util.Collections.unmodifiableList(tombstones_);
        }
        if (((mutable_bitField0_ & 0x00000080) != 0)) {
          allAppVersions_ = allAppVersions_.getUnmodifiableView();
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Gossip_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Gossip_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.Builder.class);
    }

    private int bitField0_;
    public static final int ALLADDRESSES_FIELD_NUMBER = 1;
    private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress> allAddresses_;
    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress> getAllAddressesList() {
      return allAddresses_;
    }
    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
        getAllAddressesOrBuilderList() {
      return allAddresses_;
    }
    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    public int getAllAddressesCount() {
      return allAddresses_.size();
    }
    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getAllAddresses(int index) {
      return allAddresses_.get(index);
    }
    /**
     * <code>repeated .UniqueAddress allAddresses = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getAllAddressesOrBuilder(
        int index) {
      return allAddresses_.get(index);
    }

    public static final int ALLROLES_FIELD_NUMBER = 2;
    private org.apache.pekko.protobufv3.internal.LazyStringList allRoles_;
    /**
     * <code>repeated string allRoles = 2;</code>
     * @return A list containing the allRoles.
     */
    public org.apache.pekko.protobufv3.internal.ProtocolStringList
        getAllRolesList() {
      return allRoles_;
    }
    /**
     * <code>repeated string allRoles = 2;</code>
     * @return The count of allRoles.
     */
    public int getAllRolesCount() {
      return allRoles_.size();
    }
    /**
     * <code>repeated string allRoles = 2;</code>
     * @param index The index of the element to return.
     * @return The allRoles at the given index.
     */
    public java.lang.String getAllRoles(int index) {
      return allRoles_.get(index);
    }
    /**
     * <code>repeated string allRoles = 2;</code>
     * @param index The index of the value to return.
     * @return The bytes of the allRoles at the given index.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getAllRolesBytes(int index) {
      return allRoles_.getByteString(index);
    }

    public static final int ALLHASHES_FIELD_NUMBER = 3;
    private org.apache.pekko.protobufv3.internal.LazyStringList allHashes_;
    /**
     * <code>repeated string allHashes = 3;</code>
     * @return A list containing the allHashes.
     */
    public org.apache.pekko.protobufv3.internal.ProtocolStringList
        getAllHashesList() {
      return allHashes_;
    }
    /**
     * <code>repeated string allHashes = 3;</code>
     * @return The count of allHashes.
     */
    public int getAllHashesCount() {
      return allHashes_.size();
    }
    /**
     * <code>repeated string allHashes = 3;</code>
     * @param index The index of the element to return.
     * @return The allHashes at the given index.
     */
    public java.lang.String getAllHashes(int index) {
      return allHashes_.get(index);
    }
    /**
     * <code>repeated string allHashes = 3;</code>
     * @param index The index of the value to return.
     * @return The bytes of the allHashes at the given index.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getAllHashesBytes(int index) {
      return allHashes_.getByteString(index);
    }

    public static final int MEMBERS_FIELD_NUMBER = 4;
    private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member> members_;
    /**
     * <code>repeated .Member members = 4;</code>
     */
    public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member> getMembersList() {
      return members_;
    }
    /**
     * <code>repeated .Member members = 4;</code>
     */
    public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder> 
        getMembersOrBuilderList() {
      return members_;
    }
    /**
     * <code>repeated .Member members = 4;</code>
     */
    public int getMembersCount() {
      return members_.size();
    }
    /**
     * <code>repeated .Member members = 4;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member getMembers(int index) {
      return members_.get(index);
    }
    /**
     * <code>repeated .Member members = 4;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder getMembersOrBuilder(
        int index) {
      return members_.get(index);
    }

    public static final int OVERVIEW_FIELD_NUMBER = 5;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview overview_;
    /**
     * <code>required .GossipOverview overview = 5;</code>
     * @return Whether the overview field is set.
     */
    public boolean hasOverview() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .GossipOverview overview = 5;</code>
     * @return The overview.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview getOverview() {
      return overview_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.getDefaultInstance() : overview_;
    }
    /**
     * <code>required .GossipOverview overview = 5;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverviewOrBuilder getOverviewOrBuilder() {
      return overview_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.getDefaultInstance() : overview_;
    }

    public static final int VERSION_FIELD_NUMBER = 6;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock version_;
    /**
     * <code>required .VectorClock version = 6;</code>
     * @return Whether the version field is set.
     */
    public boolean hasVersion() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required .VectorClock version = 6;</code>
     * @return The version.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock getVersion() {
      return version_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance() : version_;
    }
    /**
     * <code>required .VectorClock version = 6;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder getVersionOrBuilder() {
      return version_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance() : version_;
    }

    public static final int TOMBSTONES_FIELD_NUMBER = 7;
    private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone> tombstones_;
    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone> getTombstonesList() {
      return tombstones_;
    }
    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder> 
        getTombstonesOrBuilderList() {
      return tombstones_;
    }
    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    public int getTombstonesCount() {
      return tombstones_.size();
    }
    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone getTombstones(int index) {
      return tombstones_.get(index);
    }
    /**
     * <code>repeated .Tombstone tombstones = 7;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder getTombstonesOrBuilder(
        int index) {
      return tombstones_.get(index);
    }

    public static final int ALLAPPVERSIONS_FIELD_NUMBER = 8;
    private org.apache.pekko.protobufv3.internal.LazyStringList allAppVersions_;
    /**
     * <code>repeated string allAppVersions = 8;</code>
     * @return A list containing the allAppVersions.
     */
    public org.apache.pekko.protobufv3.internal.ProtocolStringList
        getAllAppVersionsList() {
      return allAppVersions_;
    }
    /**
     * <code>repeated string allAppVersions = 8;</code>
     * @return The count of allAppVersions.
     */
    public int getAllAppVersionsCount() {
      return allAppVersions_.size();
    }
    /**
     * <code>repeated string allAppVersions = 8;</code>
     * @param index The index of the element to return.
     * @return The allAppVersions at the given index.
     */
    public java.lang.String getAllAppVersions(int index) {
      return allAppVersions_.get(index);
    }
    /**
     * <code>repeated string allAppVersions = 8;</code>
     * @param index The index of the value to return.
     * @return The bytes of the allAppVersions at the given index.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getAllAppVersionsBytes(int index) {
      return allAppVersions_.getByteString(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasOverview()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasVersion()) {
        memoizedIsInitialized = 0;
        return false;
      }
      for (int i = 0; i < getAllAddressesCount(); i++) {
        if (!getAllAddresses(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      for (int i = 0; i < getMembersCount(); i++) {
        if (!getMembers(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      if (!getOverview().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getVersion().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      for (int i = 0; i < getTombstonesCount(); i++) {
        if (!getTombstones(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      for (int i = 0; i < allAddresses_.size(); i++) {
        output.writeMessage(1, allAddresses_.get(i));
      }
      for (int i = 0; i < allRoles_.size(); i++) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 2, allRoles_.getRaw(i));
      }
      for (int i = 0; i < allHashes_.size(); i++) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 3, allHashes_.getRaw(i));
      }
      for (int i = 0; i < members_.size(); i++) {
        output.writeMessage(4, members_.get(i));
      }
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(5, getOverview());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeMessage(6, getVersion());
      }
      for (int i = 0; i < tombstones_.size(); i++) {
        output.writeMessage(7, tombstones_.get(i));
      }
      for (int i = 0; i < allAppVersions_.size(); i++) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 8, allAppVersions_.getRaw(i));
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      for (int i = 0; i < allAddresses_.size(); i++) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, allAddresses_.get(i));
      }
      {
        int dataSize = 0;
        for (int i = 0; i < allRoles_.size(); i++) {
          dataSize += computeStringSizeNoTag(allRoles_.getRaw(i));
        }
        size += dataSize;
        size += 1 * getAllRolesList().size();
      }
      {
        int dataSize = 0;
        for (int i = 0; i < allHashes_.size(); i++) {
          dataSize += computeStringSizeNoTag(allHashes_.getRaw(i));
        }
        size += dataSize;
        size += 1 * getAllHashesList().size();
      }
      for (int i = 0; i < members_.size(); i++) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(4, members_.get(i));
      }
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(5, getOverview());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(6, getVersion());
      }
      for (int i = 0; i < tombstones_.size(); i++) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(7, tombstones_.get(i));
      }
      {
        int dataSize = 0;
        for (int i = 0; i < allAppVersions_.size(); i++) {
          dataSize += computeStringSizeNoTag(allAppVersions_.getRaw(i));
        }
        size += dataSize;
        size += 1 * getAllAppVersionsList().size();
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip) obj;

      if (!getAllAddressesList()
          .equals(other.getAllAddressesList())) return false;
      if (!getAllRolesList()
          .equals(other.getAllRolesList())) return false;
      if (!getAllHashesList()
          .equals(other.getAllHashesList())) return false;
      if (!getMembersList()
          .equals(other.getMembersList())) return false;
      if (hasOverview() != other.hasOverview()) return false;
      if (hasOverview()) {
        if (!getOverview()
            .equals(other.getOverview())) return false;
      }
      if (hasVersion() != other.hasVersion()) return false;
      if (hasVersion()) {
        if (!getVersion()
            .equals(other.getVersion())) return false;
      }
      if (!getTombstonesList()
          .equals(other.getTombstonesList())) return false;
      if (!getAllAppVersionsList()
          .equals(other.getAllAppVersionsList())) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (getAllAddressesCount() > 0) {
        hash = (37 * hash) + ALLADDRESSES_FIELD_NUMBER;
        hash = (53 * hash) + getAllAddressesList().hashCode();
      }
      if (getAllRolesCount() > 0) {
        hash = (37 * hash) + ALLROLES_FIELD_NUMBER;
        hash = (53 * hash) + getAllRolesList().hashCode();
      }
      if (getAllHashesCount() > 0) {
        hash = (37 * hash) + ALLHASHES_FIELD_NUMBER;
        hash = (53 * hash) + getAllHashesList().hashCode();
      }
      if (getMembersCount() > 0) {
        hash = (37 * hash) + MEMBERS_FIELD_NUMBER;
        hash = (53 * hash) + getMembersList().hashCode();
      }
      if (hasOverview()) {
        hash = (37 * hash) + OVERVIEW_FIELD_NUMBER;
        hash = (53 * hash) + getOverview().hashCode();
      }
      if (hasVersion()) {
        hash = (37 * hash) + VERSION_FIELD_NUMBER;
        hash = (53 * hash) + getVersion().hashCode();
      }
      if (getTombstonesCount() > 0) {
        hash = (37 * hash) + TOMBSTONES_FIELD_NUMBER;
        hash = (53 * hash) + getTombstonesList().hashCode();
      }
      if (getAllAppVersionsCount() > 0) {
        hash = (37 * hash) + ALLAPPVERSIONS_FIELD_NUMBER;
        hash = (53 * hash) + getAllAppVersionsList().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Gossip
     * </pre>
     *
     * Protobuf type {@code Gossip}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Gossip)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Gossip_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Gossip_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getAllAddressesFieldBuilder();
          getMembersFieldBuilder();
          getOverviewFieldBuilder();
          getVersionFieldBuilder();
          getTombstonesFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (allAddressesBuilder_ == null) {
          allAddresses_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
        } else {
          allAddressesBuilder_.clear();
        }
        allRoles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        allHashes_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000004);
        if (membersBuilder_ == null) {
          members_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000008);
        } else {
          membersBuilder_.clear();
        }
        if (overviewBuilder_ == null) {
          overview_ = null;
        } else {
          overviewBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000010);
        if (versionBuilder_ == null) {
          version_ = null;
        } else {
          versionBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000020);
        if (tombstonesBuilder_ == null) {
          tombstones_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000040);
        } else {
          tombstonesBuilder_.clear();
        }
        allAppVersions_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000080);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Gossip_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (allAddressesBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0)) {
            allAddresses_ = java.util.Collections.unmodifiableList(allAddresses_);
            bitField0_ = (bitField0_ & ~0x00000001);
          }
          result.allAddresses_ = allAddresses_;
        } else {
          result.allAddresses_ = allAddressesBuilder_.build();
        }
        if (((bitField0_ & 0x00000002) != 0)) {
          allRoles_ = allRoles_.getUnmodifiableView();
          bitField0_ = (bitField0_ & ~0x00000002);
        }
        result.allRoles_ = allRoles_;
        if (((bitField0_ & 0x00000004) != 0)) {
          allHashes_ = allHashes_.getUnmodifiableView();
          bitField0_ = (bitField0_ & ~0x00000004);
        }
        result.allHashes_ = allHashes_;
        if (membersBuilder_ == null) {
          if (((bitField0_ & 0x00000008) != 0)) {
            members_ = java.util.Collections.unmodifiableList(members_);
            bitField0_ = (bitField0_ & ~0x00000008);
          }
          result.members_ = members_;
        } else {
          result.members_ = membersBuilder_.build();
        }
        if (((from_bitField0_ & 0x00000010) != 0)) {
          if (overviewBuilder_ == null) {
            result.overview_ = overview_;
          } else {
            result.overview_ = overviewBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000020) != 0)) {
          if (versionBuilder_ == null) {
            result.version_ = version_;
          } else {
            result.version_ = versionBuilder_.build();
          }
          to_bitField0_ |= 0x00000002;
        }
        if (tombstonesBuilder_ == null) {
          if (((bitField0_ & 0x00000040) != 0)) {
            tombstones_ = java.util.Collections.unmodifiableList(tombstones_);
            bitField0_ = (bitField0_ & ~0x00000040);
          }
          result.tombstones_ = tombstones_;
        } else {
          result.tombstones_ = tombstonesBuilder_.build();
        }
        if (((bitField0_ & 0x00000080) != 0)) {
          allAppVersions_ = allAppVersions_.getUnmodifiableView();
          bitField0_ = (bitField0_ & ~0x00000080);
        }
        result.allAppVersions_ = allAppVersions_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip.getDefaultInstance()) return this;
        if (allAddressesBuilder_ == null) {
          if (!other.allAddresses_.isEmpty()) {
            if (allAddresses_.isEmpty()) {
              allAddresses_ = other.allAddresses_;
              bitField0_ = (bitField0_ & ~0x00000001);
            } else {
              ensureAllAddressesIsMutable();
              allAddresses_.addAll(other.allAddresses_);
            }
            onChanged();
          }
        } else {
          if (!other.allAddresses_.isEmpty()) {
            if (allAddressesBuilder_.isEmpty()) {
              allAddressesBuilder_.dispose();
              allAddressesBuilder_ = null;
              allAddresses_ = other.allAddresses_;
              bitField0_ = (bitField0_ & ~0x00000001);
              allAddressesBuilder_ = 
                org.apache.pekko.protobufv3.internal.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getAllAddressesFieldBuilder() : null;
            } else {
              allAddressesBuilder_.addAllMessages(other.allAddresses_);
            }
          }
        }
        if (!other.allRoles_.isEmpty()) {
          if (allRoles_.isEmpty()) {
            allRoles_ = other.allRoles_;
            bitField0_ = (bitField0_ & ~0x00000002);
          } else {
            ensureAllRolesIsMutable();
            allRoles_.addAll(other.allRoles_);
          }
          onChanged();
        }
        if (!other.allHashes_.isEmpty()) {
          if (allHashes_.isEmpty()) {
            allHashes_ = other.allHashes_;
            bitField0_ = (bitField0_ & ~0x00000004);
          } else {
            ensureAllHashesIsMutable();
            allHashes_.addAll(other.allHashes_);
          }
          onChanged();
        }
        if (membersBuilder_ == null) {
          if (!other.members_.isEmpty()) {
            if (members_.isEmpty()) {
              members_ = other.members_;
              bitField0_ = (bitField0_ & ~0x00000008);
            } else {
              ensureMembersIsMutable();
              members_.addAll(other.members_);
            }
            onChanged();
          }
        } else {
          if (!other.members_.isEmpty()) {
            if (membersBuilder_.isEmpty()) {
              membersBuilder_.dispose();
              membersBuilder_ = null;
              members_ = other.members_;
              bitField0_ = (bitField0_ & ~0x00000008);
              membersBuilder_ = 
                org.apache.pekko.protobufv3.internal.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getMembersFieldBuilder() : null;
            } else {
              membersBuilder_.addAllMessages(other.members_);
            }
          }
        }
        if (other.hasOverview()) {
          mergeOverview(other.getOverview());
        }
        if (other.hasVersion()) {
          mergeVersion(other.getVersion());
        }
        if (tombstonesBuilder_ == null) {
          if (!other.tombstones_.isEmpty()) {
            if (tombstones_.isEmpty()) {
              tombstones_ = other.tombstones_;
              bitField0_ = (bitField0_ & ~0x00000040);
            } else {
              ensureTombstonesIsMutable();
              tombstones_.addAll(other.tombstones_);
            }
            onChanged();
          }
        } else {
          if (!other.tombstones_.isEmpty()) {
            if (tombstonesBuilder_.isEmpty()) {
              tombstonesBuilder_.dispose();
              tombstonesBuilder_ = null;
              tombstones_ = other.tombstones_;
              bitField0_ = (bitField0_ & ~0x00000040);
              tombstonesBuilder_ = 
                org.apache.pekko.protobufv3.internal.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getTombstonesFieldBuilder() : null;
            } else {
              tombstonesBuilder_.addAllMessages(other.tombstones_);
            }
          }
        }
        if (!other.allAppVersions_.isEmpty()) {
          if (allAppVersions_.isEmpty()) {
            allAppVersions_ = other.allAppVersions_;
            bitField0_ = (bitField0_ & ~0x00000080);
          } else {
            ensureAllAppVersionsIsMutable();
            allAppVersions_.addAll(other.allAppVersions_);
          }
          onChanged();
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasOverview()) {
          return false;
        }
        if (!hasVersion()) {
          return false;
        }
        for (int i = 0; i < getAllAddressesCount(); i++) {
          if (!getAllAddresses(i).isInitialized()) {
            return false;
          }
        }
        for (int i = 0; i < getMembersCount(); i++) {
          if (!getMembers(i).isInitialized()) {
            return false;
          }
        }
        if (!getOverview().isInitialized()) {
          return false;
        }
        if (!getVersion().isInitialized()) {
          return false;
        }
        for (int i = 0; i < getTombstonesCount(); i++) {
          if (!getTombstones(i).isInitialized()) {
            return false;
          }
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress> allAddresses_ =
        java.util.Collections.emptyList();
      private void ensureAllAddressesIsMutable() {
        if (!((bitField0_ & 0x00000001) != 0)) {
          allAddresses_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress>(allAddresses_);
          bitField0_ |= 0x00000001;
         }
      }

      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> allAddressesBuilder_;

      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress> getAllAddressesList() {
        if (allAddressesBuilder_ == null) {
          return java.util.Collections.unmodifiableList(allAddresses_);
        } else {
          return allAddressesBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public int getAllAddressesCount() {
        if (allAddressesBuilder_ == null) {
          return allAddresses_.size();
        } else {
          return allAddressesBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getAllAddresses(int index) {
        if (allAddressesBuilder_ == null) {
          return allAddresses_.get(index);
        } else {
          return allAddressesBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public Builder setAllAddresses(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (allAddressesBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureAllAddressesIsMutable();
          allAddresses_.set(index, value);
          onChanged();
        } else {
          allAddressesBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public Builder setAllAddresses(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder builderForValue) {
        if (allAddressesBuilder_ == null) {
          ensureAllAddressesIsMutable();
          allAddresses_.set(index, builderForValue.build());
          onChanged();
        } else {
          allAddressesBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public Builder addAllAddresses(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (allAddressesBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureAllAddressesIsMutable();
          allAddresses_.add(value);
          onChanged();
        } else {
          allAddressesBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public Builder addAllAddresses(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress value) {
        if (allAddressesBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureAllAddressesIsMutable();
          allAddresses_.add(index, value);
          onChanged();
        } else {
          allAddressesBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public Builder addAllAddresses(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder builderForValue) {
        if (allAddressesBuilder_ == null) {
          ensureAllAddressesIsMutable();
          allAddresses_.add(builderForValue.build());
          onChanged();
        } else {
          allAddressesBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public Builder addAllAddresses(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder builderForValue) {
        if (allAddressesBuilder_ == null) {
          ensureAllAddressesIsMutable();
          allAddresses_.add(index, builderForValue.build());
          onChanged();
        } else {
          allAddressesBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public Builder addAllAllAddresses(
          java.lang.Iterable<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress> values) {
        if (allAddressesBuilder_ == null) {
          ensureAllAddressesIsMutable();
          org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
              values, allAddresses_);
          onChanged();
        } else {
          allAddressesBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public Builder clearAllAddresses() {
        if (allAddressesBuilder_ == null) {
          allAddresses_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000001);
          onChanged();
        } else {
          allAddressesBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public Builder removeAllAddresses(int index) {
        if (allAddressesBuilder_ == null) {
          ensureAllAddressesIsMutable();
          allAddresses_.remove(index);
          onChanged();
        } else {
          allAddressesBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder getAllAddressesBuilder(
          int index) {
        return getAllAddressesFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder getAllAddressesOrBuilder(
          int index) {
        if (allAddressesBuilder_ == null) {
          return allAddresses_.get(index);  } else {
          return allAddressesBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
           getAllAddressesOrBuilderList() {
        if (allAddressesBuilder_ != null) {
          return allAddressesBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(allAddresses_);
        }
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder addAllAddressesBuilder() {
        return getAllAddressesFieldBuilder().addBuilder(
            org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance());
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder addAllAddressesBuilder(
          int index) {
        return getAllAddressesFieldBuilder().addBuilder(
            index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance());
      }
      /**
       * <code>repeated .UniqueAddress allAddresses = 1;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder> 
           getAllAddressesBuilderList() {
        return getAllAddressesFieldBuilder().getBuilderList();
      }
      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder> 
          getAllAddressesFieldBuilder() {
        if (allAddressesBuilder_ == null) {
          allAddressesBuilder_ = new org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder>(
                  allAddresses_,
                  ((bitField0_ & 0x00000001) != 0),
                  getParentForChildren(),
                  isClean());
          allAddresses_ = null;
        }
        return allAddressesBuilder_;
      }

      private org.apache.pekko.protobufv3.internal.LazyStringList allRoles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      private void ensureAllRolesIsMutable() {
        if (!((bitField0_ & 0x00000002) != 0)) {
          allRoles_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList(allRoles_);
          bitField0_ |= 0x00000002;
         }
      }
      /**
       * <code>repeated string allRoles = 2;</code>
       * @return A list containing the allRoles.
       */
      public org.apache.pekko.protobufv3.internal.ProtocolStringList
          getAllRolesList() {
        return allRoles_.getUnmodifiableView();
      }
      /**
       * <code>repeated string allRoles = 2;</code>
       * @return The count of allRoles.
       */
      public int getAllRolesCount() {
        return allRoles_.size();
      }
      /**
       * <code>repeated string allRoles = 2;</code>
       * @param index The index of the element to return.
       * @return The allRoles at the given index.
       */
      public java.lang.String getAllRoles(int index) {
        return allRoles_.get(index);
      }
      /**
       * <code>repeated string allRoles = 2;</code>
       * @param index The index of the value to return.
       * @return The bytes of the allRoles at the given index.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getAllRolesBytes(int index) {
        return allRoles_.getByteString(index);
      }
      /**
       * <code>repeated string allRoles = 2;</code>
       * @param index The index to set the value at.
       * @param value The allRoles to set.
       * @return This builder for chaining.
       */
      public Builder setAllRoles(
          int index, java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllRolesIsMutable();
        allRoles_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allRoles = 2;</code>
       * @param value The allRoles to add.
       * @return This builder for chaining.
       */
      public Builder addAllRoles(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllRolesIsMutable();
        allRoles_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allRoles = 2;</code>
       * @param values The allRoles to add.
       * @return This builder for chaining.
       */
      public Builder addAllAllRoles(
          java.lang.Iterable<java.lang.String> values) {
        ensureAllRolesIsMutable();
        org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
            values, allRoles_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allRoles = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearAllRoles() {
        allRoles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000002);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allRoles = 2;</code>
       * @param value The bytes of the allRoles to add.
       * @return This builder for chaining.
       */
      public Builder addAllRolesBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllRolesIsMutable();
        allRoles_.add(value);
        onChanged();
        return this;
      }

      private org.apache.pekko.protobufv3.internal.LazyStringList allHashes_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      private void ensureAllHashesIsMutable() {
        if (!((bitField0_ & 0x00000004) != 0)) {
          allHashes_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList(allHashes_);
          bitField0_ |= 0x00000004;
         }
      }
      /**
       * <code>repeated string allHashes = 3;</code>
       * @return A list containing the allHashes.
       */
      public org.apache.pekko.protobufv3.internal.ProtocolStringList
          getAllHashesList() {
        return allHashes_.getUnmodifiableView();
      }
      /**
       * <code>repeated string allHashes = 3;</code>
       * @return The count of allHashes.
       */
      public int getAllHashesCount() {
        return allHashes_.size();
      }
      /**
       * <code>repeated string allHashes = 3;</code>
       * @param index The index of the element to return.
       * @return The allHashes at the given index.
       */
      public java.lang.String getAllHashes(int index) {
        return allHashes_.get(index);
      }
      /**
       * <code>repeated string allHashes = 3;</code>
       * @param index The index of the value to return.
       * @return The bytes of the allHashes at the given index.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getAllHashesBytes(int index) {
        return allHashes_.getByteString(index);
      }
      /**
       * <code>repeated string allHashes = 3;</code>
       * @param index The index to set the value at.
       * @param value The allHashes to set.
       * @return This builder for chaining.
       */
      public Builder setAllHashes(
          int index, java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllHashesIsMutable();
        allHashes_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allHashes = 3;</code>
       * @param value The allHashes to add.
       * @return This builder for chaining.
       */
      public Builder addAllHashes(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllHashesIsMutable();
        allHashes_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allHashes = 3;</code>
       * @param values The allHashes to add.
       * @return This builder for chaining.
       */
      public Builder addAllAllHashes(
          java.lang.Iterable<java.lang.String> values) {
        ensureAllHashesIsMutable();
        org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
            values, allHashes_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allHashes = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearAllHashes() {
        allHashes_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000004);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allHashes = 3;</code>
       * @param value The bytes of the allHashes to add.
       * @return This builder for chaining.
       */
      public Builder addAllHashesBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllHashesIsMutable();
        allHashes_.add(value);
        onChanged();
        return this;
      }

      private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member> members_ =
        java.util.Collections.emptyList();
      private void ensureMembersIsMutable() {
        if (!((bitField0_ & 0x00000008) != 0)) {
          members_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member>(members_);
          bitField0_ |= 0x00000008;
         }
      }

      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder> membersBuilder_;

      /**
       * <code>repeated .Member members = 4;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member> getMembersList() {
        if (membersBuilder_ == null) {
          return java.util.Collections.unmodifiableList(members_);
        } else {
          return membersBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public int getMembersCount() {
        if (membersBuilder_ == null) {
          return members_.size();
        } else {
          return membersBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member getMembers(int index) {
        if (membersBuilder_ == null) {
          return members_.get(index);
        } else {
          return membersBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public Builder setMembers(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member value) {
        if (membersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureMembersIsMutable();
          members_.set(index, value);
          onChanged();
        } else {
          membersBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public Builder setMembers(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder builderForValue) {
        if (membersBuilder_ == null) {
          ensureMembersIsMutable();
          members_.set(index, builderForValue.build());
          onChanged();
        } else {
          membersBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public Builder addMembers(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member value) {
        if (membersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureMembersIsMutable();
          members_.add(value);
          onChanged();
        } else {
          membersBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public Builder addMembers(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member value) {
        if (membersBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureMembersIsMutable();
          members_.add(index, value);
          onChanged();
        } else {
          membersBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public Builder addMembers(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder builderForValue) {
        if (membersBuilder_ == null) {
          ensureMembersIsMutable();
          members_.add(builderForValue.build());
          onChanged();
        } else {
          membersBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public Builder addMembers(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder builderForValue) {
        if (membersBuilder_ == null) {
          ensureMembersIsMutable();
          members_.add(index, builderForValue.build());
          onChanged();
        } else {
          membersBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public Builder addAllMembers(
          java.lang.Iterable<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member> values) {
        if (membersBuilder_ == null) {
          ensureMembersIsMutable();
          org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
              values, members_);
          onChanged();
        } else {
          membersBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public Builder clearMembers() {
        if (membersBuilder_ == null) {
          members_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000008);
          onChanged();
        } else {
          membersBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public Builder removeMembers(int index) {
        if (membersBuilder_ == null) {
          ensureMembersIsMutable();
          members_.remove(index);
          onChanged();
        } else {
          membersBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder getMembersBuilder(
          int index) {
        return getMembersFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder getMembersOrBuilder(
          int index) {
        if (membersBuilder_ == null) {
          return members_.get(index);  } else {
          return membersBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder> 
           getMembersOrBuilderList() {
        if (membersBuilder_ != null) {
          return membersBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(members_);
        }
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder addMembersBuilder() {
        return getMembersFieldBuilder().addBuilder(
            org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.getDefaultInstance());
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder addMembersBuilder(
          int index) {
        return getMembersFieldBuilder().addBuilder(
            index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.getDefaultInstance());
      }
      /**
       * <code>repeated .Member members = 4;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder> 
           getMembersBuilderList() {
        return getMembersFieldBuilder().getBuilderList();
      }
      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder> 
          getMembersFieldBuilder() {
        if (membersBuilder_ == null) {
          membersBuilder_ = new org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder>(
                  members_,
                  ((bitField0_ & 0x00000008) != 0),
                  getParentForChildren(),
                  isClean());
          members_ = null;
        }
        return membersBuilder_;
      }

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview overview_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverviewOrBuilder> overviewBuilder_;
      /**
       * <code>required .GossipOverview overview = 5;</code>
       * @return Whether the overview field is set.
       */
      public boolean hasOverview() {
        return ((bitField0_ & 0x00000010) != 0);
      }
      /**
       * <code>required .GossipOverview overview = 5;</code>
       * @return The overview.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview getOverview() {
        if (overviewBuilder_ == null) {
          return overview_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.getDefaultInstance() : overview_;
        } else {
          return overviewBuilder_.getMessage();
        }
      }
      /**
       * <code>required .GossipOverview overview = 5;</code>
       */
      public Builder setOverview(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview value) {
        if (overviewBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          overview_ = value;
          onChanged();
        } else {
          overviewBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000010;
        return this;
      }
      /**
       * <code>required .GossipOverview overview = 5;</code>
       */
      public Builder setOverview(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.Builder builderForValue) {
        if (overviewBuilder_ == null) {
          overview_ = builderForValue.build();
          onChanged();
        } else {
          overviewBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000010;
        return this;
      }
      /**
       * <code>required .GossipOverview overview = 5;</code>
       */
      public Builder mergeOverview(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview value) {
        if (overviewBuilder_ == null) {
          if (((bitField0_ & 0x00000010) != 0) &&
              overview_ != null &&
              overview_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.getDefaultInstance()) {
            overview_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.newBuilder(overview_).mergeFrom(value).buildPartial();
          } else {
            overview_ = value;
          }
          onChanged();
        } else {
          overviewBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000010;
        return this;
      }
      /**
       * <code>required .GossipOverview overview = 5;</code>
       */
      public Builder clearOverview() {
        if (overviewBuilder_ == null) {
          overview_ = null;
          onChanged();
        } else {
          overviewBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000010);
        return this;
      }
      /**
       * <code>required .GossipOverview overview = 5;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.Builder getOverviewBuilder() {
        bitField0_ |= 0x00000010;
        onChanged();
        return getOverviewFieldBuilder().getBuilder();
      }
      /**
       * <code>required .GossipOverview overview = 5;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverviewOrBuilder getOverviewOrBuilder() {
        if (overviewBuilder_ != null) {
          return overviewBuilder_.getMessageOrBuilder();
        } else {
          return overview_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.getDefaultInstance() : overview_;
        }
      }
      /**
       * <code>required .GossipOverview overview = 5;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverviewOrBuilder> 
          getOverviewFieldBuilder() {
        if (overviewBuilder_ == null) {
          overviewBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverviewOrBuilder>(
                  getOverview(),
                  getParentForChildren(),
                  isClean());
          overview_ = null;
        }
        return overviewBuilder_;
      }

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock version_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder> versionBuilder_;
      /**
       * <code>required .VectorClock version = 6;</code>
       * @return Whether the version field is set.
       */
      public boolean hasVersion() {
        return ((bitField0_ & 0x00000020) != 0);
      }
      /**
       * <code>required .VectorClock version = 6;</code>
       * @return The version.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock getVersion() {
        if (versionBuilder_ == null) {
          return version_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance() : version_;
        } else {
          return versionBuilder_.getMessage();
        }
      }
      /**
       * <code>required .VectorClock version = 6;</code>
       */
      public Builder setVersion(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock value) {
        if (versionBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          version_ = value;
          onChanged();
        } else {
          versionBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000020;
        return this;
      }
      /**
       * <code>required .VectorClock version = 6;</code>
       */
      public Builder setVersion(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder builderForValue) {
        if (versionBuilder_ == null) {
          version_ = builderForValue.build();
          onChanged();
        } else {
          versionBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000020;
        return this;
      }
      /**
       * <code>required .VectorClock version = 6;</code>
       */
      public Builder mergeVersion(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock value) {
        if (versionBuilder_ == null) {
          if (((bitField0_ & 0x00000020) != 0) &&
              version_ != null &&
              version_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance()) {
            version_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.newBuilder(version_).mergeFrom(value).buildPartial();
          } else {
            version_ = value;
          }
          onChanged();
        } else {
          versionBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000020;
        return this;
      }
      /**
       * <code>required .VectorClock version = 6;</code>
       */
      public Builder clearVersion() {
        if (versionBuilder_ == null) {
          version_ = null;
          onChanged();
        } else {
          versionBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000020);
        return this;
      }
      /**
       * <code>required .VectorClock version = 6;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder getVersionBuilder() {
        bitField0_ |= 0x00000020;
        onChanged();
        return getVersionFieldBuilder().getBuilder();
      }
      /**
       * <code>required .VectorClock version = 6;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder getVersionOrBuilder() {
        if (versionBuilder_ != null) {
          return versionBuilder_.getMessageOrBuilder();
        } else {
          return version_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance() : version_;
        }
      }
      /**
       * <code>required .VectorClock version = 6;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder> 
          getVersionFieldBuilder() {
        if (versionBuilder_ == null) {
          versionBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder>(
                  getVersion(),
                  getParentForChildren(),
                  isClean());
          version_ = null;
        }
        return versionBuilder_;
      }

      private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone> tombstones_ =
        java.util.Collections.emptyList();
      private void ensureTombstonesIsMutable() {
        if (!((bitField0_ & 0x00000040) != 0)) {
          tombstones_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone>(tombstones_);
          bitField0_ |= 0x00000040;
         }
      }

      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder> tombstonesBuilder_;

      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone> getTombstonesList() {
        if (tombstonesBuilder_ == null) {
          return java.util.Collections.unmodifiableList(tombstones_);
        } else {
          return tombstonesBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public int getTombstonesCount() {
        if (tombstonesBuilder_ == null) {
          return tombstones_.size();
        } else {
          return tombstonesBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone getTombstones(int index) {
        if (tombstonesBuilder_ == null) {
          return tombstones_.get(index);
        } else {
          return tombstonesBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public Builder setTombstones(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone value) {
        if (tombstonesBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureTombstonesIsMutable();
          tombstones_.set(index, value);
          onChanged();
        } else {
          tombstonesBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public Builder setTombstones(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder builderForValue) {
        if (tombstonesBuilder_ == null) {
          ensureTombstonesIsMutable();
          tombstones_.set(index, builderForValue.build());
          onChanged();
        } else {
          tombstonesBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public Builder addTombstones(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone value) {
        if (tombstonesBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureTombstonesIsMutable();
          tombstones_.add(value);
          onChanged();
        } else {
          tombstonesBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public Builder addTombstones(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone value) {
        if (tombstonesBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureTombstonesIsMutable();
          tombstones_.add(index, value);
          onChanged();
        } else {
          tombstonesBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public Builder addTombstones(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder builderForValue) {
        if (tombstonesBuilder_ == null) {
          ensureTombstonesIsMutable();
          tombstones_.add(builderForValue.build());
          onChanged();
        } else {
          tombstonesBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public Builder addTombstones(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder builderForValue) {
        if (tombstonesBuilder_ == null) {
          ensureTombstonesIsMutable();
          tombstones_.add(index, builderForValue.build());
          onChanged();
        } else {
          tombstonesBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public Builder addAllTombstones(
          java.lang.Iterable<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone> values) {
        if (tombstonesBuilder_ == null) {
          ensureTombstonesIsMutable();
          org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
              values, tombstones_);
          onChanged();
        } else {
          tombstonesBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public Builder clearTombstones() {
        if (tombstonesBuilder_ == null) {
          tombstones_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000040);
          onChanged();
        } else {
          tombstonesBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public Builder removeTombstones(int index) {
        if (tombstonesBuilder_ == null) {
          ensureTombstonesIsMutable();
          tombstones_.remove(index);
          onChanged();
        } else {
          tombstonesBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder getTombstonesBuilder(
          int index) {
        return getTombstonesFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder getTombstonesOrBuilder(
          int index) {
        if (tombstonesBuilder_ == null) {
          return tombstones_.get(index);  } else {
          return tombstonesBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder> 
           getTombstonesOrBuilderList() {
        if (tombstonesBuilder_ != null) {
          return tombstonesBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(tombstones_);
        }
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder addTombstonesBuilder() {
        return getTombstonesFieldBuilder().addBuilder(
            org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.getDefaultInstance());
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder addTombstonesBuilder(
          int index) {
        return getTombstonesFieldBuilder().addBuilder(
            index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.getDefaultInstance());
      }
      /**
       * <code>repeated .Tombstone tombstones = 7;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder> 
           getTombstonesBuilderList() {
        return getTombstonesFieldBuilder().getBuilderList();
      }
      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder> 
          getTombstonesFieldBuilder() {
        if (tombstonesBuilder_ == null) {
          tombstonesBuilder_ = new org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder>(
                  tombstones_,
                  ((bitField0_ & 0x00000040) != 0),
                  getParentForChildren(),
                  isClean());
          tombstones_ = null;
        }
        return tombstonesBuilder_;
      }

      private org.apache.pekko.protobufv3.internal.LazyStringList allAppVersions_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      private void ensureAllAppVersionsIsMutable() {
        if (!((bitField0_ & 0x00000080) != 0)) {
          allAppVersions_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList(allAppVersions_);
          bitField0_ |= 0x00000080;
         }
      }
      /**
       * <code>repeated string allAppVersions = 8;</code>
       * @return A list containing the allAppVersions.
       */
      public org.apache.pekko.protobufv3.internal.ProtocolStringList
          getAllAppVersionsList() {
        return allAppVersions_.getUnmodifiableView();
      }
      /**
       * <code>repeated string allAppVersions = 8;</code>
       * @return The count of allAppVersions.
       */
      public int getAllAppVersionsCount() {
        return allAppVersions_.size();
      }
      /**
       * <code>repeated string allAppVersions = 8;</code>
       * @param index The index of the element to return.
       * @return The allAppVersions at the given index.
       */
      public java.lang.String getAllAppVersions(int index) {
        return allAppVersions_.get(index);
      }
      /**
       * <code>repeated string allAppVersions = 8;</code>
       * @param index The index of the value to return.
       * @return The bytes of the allAppVersions at the given index.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getAllAppVersionsBytes(int index) {
        return allAppVersions_.getByteString(index);
      }
      /**
       * <code>repeated string allAppVersions = 8;</code>
       * @param index The index to set the value at.
       * @param value The allAppVersions to set.
       * @return This builder for chaining.
       */
      public Builder setAllAppVersions(
          int index, java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllAppVersionsIsMutable();
        allAppVersions_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allAppVersions = 8;</code>
       * @param value The allAppVersions to add.
       * @return This builder for chaining.
       */
      public Builder addAllAppVersions(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllAppVersionsIsMutable();
        allAppVersions_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allAppVersions = 8;</code>
       * @param values The allAppVersions to add.
       * @return This builder for chaining.
       */
      public Builder addAllAllAppVersions(
          java.lang.Iterable<java.lang.String> values) {
        ensureAllAppVersionsIsMutable();
        org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
            values, allAppVersions_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allAppVersions = 8;</code>
       * @return This builder for chaining.
       */
      public Builder clearAllAppVersions() {
        allAppVersions_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000080);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string allAppVersions = 8;</code>
       * @param value The bytes of the allAppVersions to add.
       * @return This builder for chaining.
       */
      public Builder addAllAppVersionsBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureAllAppVersionsIsMutable();
        allAppVersions_.add(value);
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Gossip)
    }

    // @@protoc_insertion_point(class_scope:Gossip)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Gossip>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Gossip>() {
      @java.lang.Override
      public Gossip parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new Gossip(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<Gossip> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<Gossip> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Gossip getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface GossipOverviewOrBuilder extends
      // @@protoc_insertion_point(interface_extends:GossipOverview)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <pre>
     * This is the address indexes for the nodes that have seen this gossip 
     * </pre>
     *
     * <code>repeated int32 seen = 1;</code>
     * @return A list containing the seen.
     */
    java.util.List<java.lang.Integer> getSeenList();
    /**
     * <pre>
     * This is the address indexes for the nodes that have seen this gossip 
     * </pre>
     *
     * <code>repeated int32 seen = 1;</code>
     * @return The count of seen.
     */
    int getSeenCount();
    /**
     * <pre>
     * This is the address indexes for the nodes that have seen this gossip 
     * </pre>
     *
     * <code>repeated int32 seen = 1;</code>
     * @param index The index of the element to return.
     * @return The seen at the given index.
     */
    int getSeen(int index);

    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability> 
        getObserverReachabilityList();
    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability getObserverReachability(int index);
    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    int getObserverReachabilityCount();
    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder> 
        getObserverReachabilityOrBuilderList();
    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder getObserverReachabilityOrBuilder(
        int index);
  }
  /**
   * <pre>
   **
   * Gossip Overview
   * </pre>
   *
   * Protobuf type {@code GossipOverview}
   */
  public  static final class GossipOverview extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:GossipOverview)
      GossipOverviewOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use GossipOverview.newBuilder() to construct.
    private GossipOverview(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private GossipOverview() {
      seen_ = emptyIntList();
      observerReachability_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new GossipOverview();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private GossipOverview(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              if (!((mutable_bitField0_ & 0x00000001) != 0)) {
                seen_ = newIntList();
                mutable_bitField0_ |= 0x00000001;
              }
              seen_.addInt(input.readInt32());
              break;
            }
            case 10: {
              int length = input.readRawVarint32();
              int limit = input.pushLimit(length);
              if (!((mutable_bitField0_ & 0x00000001) != 0) && input.getBytesUntilLimit() > 0) {
                seen_ = newIntList();
                mutable_bitField0_ |= 0x00000001;
              }
              while (input.getBytesUntilLimit() > 0) {
                seen_.addInt(input.readInt32());
              }
              input.popLimit(limit);
              break;
            }
            case 18: {
              if (!((mutable_bitField0_ & 0x00000002) != 0)) {
                observerReachability_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability>();
                mutable_bitField0_ |= 0x00000002;
              }
              observerReachability_.add(
                  input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.PARSER, extensionRegistry));
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000001) != 0)) {
          seen_.makeImmutable(); // C
        }
        if (((mutable_bitField0_ & 0x00000002) != 0)) {
          observerReachability_ = java.util.Collections.unmodifiableList(observerReachability_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipOverview_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipOverview_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.Builder.class);
    }

    public static final int SEEN_FIELD_NUMBER = 1;
    private org.apache.pekko.protobufv3.internal.Internal.IntList seen_;
    /**
     * <pre>
     * This is the address indexes for the nodes that have seen this gossip 
     * </pre>
     *
     * <code>repeated int32 seen = 1;</code>
     * @return A list containing the seen.
     */
    public java.util.List<java.lang.Integer>
        getSeenList() {
      return seen_;
    }
    /**
     * <pre>
     * This is the address indexes for the nodes that have seen this gossip 
     * </pre>
     *
     * <code>repeated int32 seen = 1;</code>
     * @return The count of seen.
     */
    public int getSeenCount() {
      return seen_.size();
    }
    /**
     * <pre>
     * This is the address indexes for the nodes that have seen this gossip 
     * </pre>
     *
     * <code>repeated int32 seen = 1;</code>
     * @param index The index of the element to return.
     * @return The seen at the given index.
     */
    public int getSeen(int index) {
      return seen_.getInt(index);
    }

    public static final int OBSERVERREACHABILITY_FIELD_NUMBER = 2;
    private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability> observerReachability_;
    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability> getObserverReachabilityList() {
      return observerReachability_;
    }
    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder> 
        getObserverReachabilityOrBuilderList() {
      return observerReachability_;
    }
    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    public int getObserverReachabilityCount() {
      return observerReachability_.size();
    }
    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability getObserverReachability(int index) {
      return observerReachability_.get(index);
    }
    /**
     * <code>repeated .ObserverReachability observerReachability = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder getObserverReachabilityOrBuilder(
        int index) {
      return observerReachability_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      for (int i = 0; i < getObserverReachabilityCount(); i++) {
        if (!getObserverReachability(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      for (int i = 0; i < seen_.size(); i++) {
        output.writeInt32(1, seen_.getInt(i));
      }
      for (int i = 0; i < observerReachability_.size(); i++) {
        output.writeMessage(2, observerReachability_.get(i));
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      {
        int dataSize = 0;
        for (int i = 0; i < seen_.size(); i++) {
          dataSize += org.apache.pekko.protobufv3.internal.CodedOutputStream
            .computeInt32SizeNoTag(seen_.getInt(i));
        }
        size += dataSize;
        size += 1 * getSeenList().size();
      }
      for (int i = 0; i < observerReachability_.size(); i++) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(2, observerReachability_.get(i));
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview) obj;

      if (!getSeenList()
          .equals(other.getSeenList())) return false;
      if (!getObserverReachabilityList()
          .equals(other.getObserverReachabilityList())) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (getSeenCount() > 0) {
        hash = (37 * hash) + SEEN_FIELD_NUMBER;
        hash = (53 * hash) + getSeenList().hashCode();
      }
      if (getObserverReachabilityCount() > 0) {
        hash = (37 * hash) + OBSERVERREACHABILITY_FIELD_NUMBER;
        hash = (53 * hash) + getObserverReachabilityList().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Gossip Overview
     * </pre>
     *
     * Protobuf type {@code GossipOverview}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:GossipOverview)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverviewOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipOverview_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipOverview_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getObserverReachabilityFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        seen_ = emptyIntList();
        bitField0_ = (bitField0_ & ~0x00000001);
        if (observerReachabilityBuilder_ == null) {
          observerReachability_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000002);
        } else {
          observerReachabilityBuilder_.clear();
        }
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_GossipOverview_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview(this);
        int from_bitField0_ = bitField0_;
        if (((bitField0_ & 0x00000001) != 0)) {
          seen_.makeImmutable();
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.seen_ = seen_;
        if (observerReachabilityBuilder_ == null) {
          if (((bitField0_ & 0x00000002) != 0)) {
            observerReachability_ = java.util.Collections.unmodifiableList(observerReachability_);
            bitField0_ = (bitField0_ & ~0x00000002);
          }
          result.observerReachability_ = observerReachability_;
        } else {
          result.observerReachability_ = observerReachabilityBuilder_.build();
        }
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview.getDefaultInstance()) return this;
        if (!other.seen_.isEmpty()) {
          if (seen_.isEmpty()) {
            seen_ = other.seen_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureSeenIsMutable();
            seen_.addAll(other.seen_);
          }
          onChanged();
        }
        if (observerReachabilityBuilder_ == null) {
          if (!other.observerReachability_.isEmpty()) {
            if (observerReachability_.isEmpty()) {
              observerReachability_ = other.observerReachability_;
              bitField0_ = (bitField0_ & ~0x00000002);
            } else {
              ensureObserverReachabilityIsMutable();
              observerReachability_.addAll(other.observerReachability_);
            }
            onChanged();
          }
        } else {
          if (!other.observerReachability_.isEmpty()) {
            if (observerReachabilityBuilder_.isEmpty()) {
              observerReachabilityBuilder_.dispose();
              observerReachabilityBuilder_ = null;
              observerReachability_ = other.observerReachability_;
              bitField0_ = (bitField0_ & ~0x00000002);
              observerReachabilityBuilder_ = 
                org.apache.pekko.protobufv3.internal.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getObserverReachabilityFieldBuilder() : null;
            } else {
              observerReachabilityBuilder_.addAllMessages(other.observerReachability_);
            }
          }
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        for (int i = 0; i < getObserverReachabilityCount(); i++) {
          if (!getObserverReachability(i).isInitialized()) {
            return false;
          }
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.protobufv3.internal.Internal.IntList seen_ = emptyIntList();
      private void ensureSeenIsMutable() {
        if (!((bitField0_ & 0x00000001) != 0)) {
          seen_ = mutableCopy(seen_);
          bitField0_ |= 0x00000001;
         }
      }
      /**
       * <pre>
       * This is the address indexes for the nodes that have seen this gossip 
       * </pre>
       *
       * <code>repeated int32 seen = 1;</code>
       * @return A list containing the seen.
       */
      public java.util.List<java.lang.Integer>
          getSeenList() {
        return ((bitField0_ & 0x00000001) != 0) ?
                 java.util.Collections.unmodifiableList(seen_) : seen_;
      }
      /**
       * <pre>
       * This is the address indexes for the nodes that have seen this gossip 
       * </pre>
       *
       * <code>repeated int32 seen = 1;</code>
       * @return The count of seen.
       */
      public int getSeenCount() {
        return seen_.size();
      }
      /**
       * <pre>
       * This is the address indexes for the nodes that have seen this gossip 
       * </pre>
       *
       * <code>repeated int32 seen = 1;</code>
       * @param index The index of the element to return.
       * @return The seen at the given index.
       */
      public int getSeen(int index) {
        return seen_.getInt(index);
      }
      /**
       * <pre>
       * This is the address indexes for the nodes that have seen this gossip 
       * </pre>
       *
       * <code>repeated int32 seen = 1;</code>
       * @param index The index to set the value at.
       * @param value The seen to set.
       * @return This builder for chaining.
       */
      public Builder setSeen(
          int index, int value) {
        ensureSeenIsMutable();
        seen_.setInt(index, value);
        onChanged();
        return this;
      }
      /**
       * <pre>
       * This is the address indexes for the nodes that have seen this gossip 
       * </pre>
       *
       * <code>repeated int32 seen = 1;</code>
       * @param value The seen to add.
       * @return This builder for chaining.
       */
      public Builder addSeen(int value) {
        ensureSeenIsMutable();
        seen_.addInt(value);
        onChanged();
        return this;
      }
      /**
       * <pre>
       * This is the address indexes for the nodes that have seen this gossip 
       * </pre>
       *
       * <code>repeated int32 seen = 1;</code>
       * @param values The seen to add.
       * @return This builder for chaining.
       */
      public Builder addAllSeen(
          java.lang.Iterable<? extends java.lang.Integer> values) {
        ensureSeenIsMutable();
        org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
            values, seen_);
        onChanged();
        return this;
      }
      /**
       * <pre>
       * This is the address indexes for the nodes that have seen this gossip 
       * </pre>
       *
       * <code>repeated int32 seen = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearSeen() {
        seen_ = emptyIntList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
        return this;
      }

      private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability> observerReachability_ =
        java.util.Collections.emptyList();
      private void ensureObserverReachabilityIsMutable() {
        if (!((bitField0_ & 0x00000002) != 0)) {
          observerReachability_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability>(observerReachability_);
          bitField0_ |= 0x00000002;
         }
      }

      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder> observerReachabilityBuilder_;

      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability> getObserverReachabilityList() {
        if (observerReachabilityBuilder_ == null) {
          return java.util.Collections.unmodifiableList(observerReachability_);
        } else {
          return observerReachabilityBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public int getObserverReachabilityCount() {
        if (observerReachabilityBuilder_ == null) {
          return observerReachability_.size();
        } else {
          return observerReachabilityBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability getObserverReachability(int index) {
        if (observerReachabilityBuilder_ == null) {
          return observerReachability_.get(index);
        } else {
          return observerReachabilityBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public Builder setObserverReachability(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability value) {
        if (observerReachabilityBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureObserverReachabilityIsMutable();
          observerReachability_.set(index, value);
          onChanged();
        } else {
          observerReachabilityBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public Builder setObserverReachability(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder builderForValue) {
        if (observerReachabilityBuilder_ == null) {
          ensureObserverReachabilityIsMutable();
          observerReachability_.set(index, builderForValue.build());
          onChanged();
        } else {
          observerReachabilityBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public Builder addObserverReachability(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability value) {
        if (observerReachabilityBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureObserverReachabilityIsMutable();
          observerReachability_.add(value);
          onChanged();
        } else {
          observerReachabilityBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public Builder addObserverReachability(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability value) {
        if (observerReachabilityBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureObserverReachabilityIsMutable();
          observerReachability_.add(index, value);
          onChanged();
        } else {
          observerReachabilityBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public Builder addObserverReachability(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder builderForValue) {
        if (observerReachabilityBuilder_ == null) {
          ensureObserverReachabilityIsMutable();
          observerReachability_.add(builderForValue.build());
          onChanged();
        } else {
          observerReachabilityBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public Builder addObserverReachability(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder builderForValue) {
        if (observerReachabilityBuilder_ == null) {
          ensureObserverReachabilityIsMutable();
          observerReachability_.add(index, builderForValue.build());
          onChanged();
        } else {
          observerReachabilityBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public Builder addAllObserverReachability(
          java.lang.Iterable<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability> values) {
        if (observerReachabilityBuilder_ == null) {
          ensureObserverReachabilityIsMutable();
          org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
              values, observerReachability_);
          onChanged();
        } else {
          observerReachabilityBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public Builder clearObserverReachability() {
        if (observerReachabilityBuilder_ == null) {
          observerReachability_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000002);
          onChanged();
        } else {
          observerReachabilityBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public Builder removeObserverReachability(int index) {
        if (observerReachabilityBuilder_ == null) {
          ensureObserverReachabilityIsMutable();
          observerReachability_.remove(index);
          onChanged();
        } else {
          observerReachabilityBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder getObserverReachabilityBuilder(
          int index) {
        return getObserverReachabilityFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder getObserverReachabilityOrBuilder(
          int index) {
        if (observerReachabilityBuilder_ == null) {
          return observerReachability_.get(index);  } else {
          return observerReachabilityBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder> 
           getObserverReachabilityOrBuilderList() {
        if (observerReachabilityBuilder_ != null) {
          return observerReachabilityBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(observerReachability_);
        }
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder addObserverReachabilityBuilder() {
        return getObserverReachabilityFieldBuilder().addBuilder(
            org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.getDefaultInstance());
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder addObserverReachabilityBuilder(
          int index) {
        return getObserverReachabilityFieldBuilder().addBuilder(
            index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.getDefaultInstance());
      }
      /**
       * <code>repeated .ObserverReachability observerReachability = 2;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder> 
           getObserverReachabilityBuilderList() {
        return getObserverReachabilityFieldBuilder().getBuilderList();
      }
      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder> 
          getObserverReachabilityFieldBuilder() {
        if (observerReachabilityBuilder_ == null) {
          observerReachabilityBuilder_ = new org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder>(
                  observerReachability_,
                  ((bitField0_ & 0x00000002) != 0),
                  getParentForChildren(),
                  isClean());
          observerReachability_ = null;
        }
        return observerReachabilityBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:GossipOverview)
    }

    // @@protoc_insertion_point(class_scope:GossipOverview)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<GossipOverview>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<GossipOverview>() {
      @java.lang.Override
      public GossipOverview parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new GossipOverview(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<GossipOverview> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<GossipOverview> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.GossipOverview getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ObserverReachabilityOrBuilder extends
      // @@protoc_insertion_point(interface_extends:ObserverReachability)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return Whether the addressIndex field is set.
     */
    boolean hasAddressIndex();
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return The addressIndex.
     */
    int getAddressIndex();

    /**
     * <code>required int64 version = 4;</code>
     * @return Whether the version field is set.
     */
    boolean hasVersion();
    /**
     * <code>required int64 version = 4;</code>
     * @return The version.
     */
    long getVersion();

    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability> 
        getSubjectReachabilityList();
    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability getSubjectReachability(int index);
    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    int getSubjectReachabilityCount();
    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder> 
        getSubjectReachabilityOrBuilderList();
    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder getSubjectReachabilityOrBuilder(
        int index);
  }
  /**
   * <pre>
   **
   * Reachability
   * </pre>
   *
   * Protobuf type {@code ObserverReachability}
   */
  public  static final class ObserverReachability extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:ObserverReachability)
      ObserverReachabilityOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ObserverReachability.newBuilder() to construct.
    private ObserverReachability(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ObserverReachability() {
      subjectReachability_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new ObserverReachability();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private ObserverReachability(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              bitField0_ |= 0x00000001;
              addressIndex_ = input.readInt32();
              break;
            }
            case 18: {
              if (!((mutable_bitField0_ & 0x00000004) != 0)) {
                subjectReachability_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability>();
                mutable_bitField0_ |= 0x00000004;
              }
              subjectReachability_.add(
                  input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.PARSER, extensionRegistry));
              break;
            }
            case 32: {
              bitField0_ |= 0x00000002;
              version_ = input.readInt64();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000004) != 0)) {
          subjectReachability_ = java.util.Collections.unmodifiableList(subjectReachability_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ObserverReachability_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ObserverReachability_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder.class);
    }

    private int bitField0_;
    public static final int ADDRESSINDEX_FIELD_NUMBER = 1;
    private int addressIndex_;
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return Whether the addressIndex field is set.
     */
    public boolean hasAddressIndex() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return The addressIndex.
     */
    public int getAddressIndex() {
      return addressIndex_;
    }

    public static final int VERSION_FIELD_NUMBER = 4;
    private long version_;
    /**
     * <code>required int64 version = 4;</code>
     * @return Whether the version field is set.
     */
    public boolean hasVersion() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required int64 version = 4;</code>
     * @return The version.
     */
    public long getVersion() {
      return version_;
    }

    public static final int SUBJECTREACHABILITY_FIELD_NUMBER = 2;
    private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability> subjectReachability_;
    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability> getSubjectReachabilityList() {
      return subjectReachability_;
    }
    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder> 
        getSubjectReachabilityOrBuilderList() {
      return subjectReachability_;
    }
    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    public int getSubjectReachabilityCount() {
      return subjectReachability_.size();
    }
    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability getSubjectReachability(int index) {
      return subjectReachability_.get(index);
    }
    /**
     * <code>repeated .SubjectReachability subjectReachability = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder getSubjectReachabilityOrBuilder(
        int index) {
      return subjectReachability_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasAddressIndex()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasVersion()) {
        memoizedIsInitialized = 0;
        return false;
      }
      for (int i = 0; i < getSubjectReachabilityCount(); i++) {
        if (!getSubjectReachability(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeInt32(1, addressIndex_);
      }
      for (int i = 0; i < subjectReachability_.size(); i++) {
        output.writeMessage(2, subjectReachability_.get(i));
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeInt64(4, version_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt32Size(1, addressIndex_);
      }
      for (int i = 0; i < subjectReachability_.size(); i++) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(2, subjectReachability_.get(i));
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt64Size(4, version_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability) obj;

      if (hasAddressIndex() != other.hasAddressIndex()) return false;
      if (hasAddressIndex()) {
        if (getAddressIndex()
            != other.getAddressIndex()) return false;
      }
      if (hasVersion() != other.hasVersion()) return false;
      if (hasVersion()) {
        if (getVersion()
            != other.getVersion()) return false;
      }
      if (!getSubjectReachabilityList()
          .equals(other.getSubjectReachabilityList())) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasAddressIndex()) {
        hash = (37 * hash) + ADDRESSINDEX_FIELD_NUMBER;
        hash = (53 * hash) + getAddressIndex();
      }
      if (hasVersion()) {
        hash = (37 * hash) + VERSION_FIELD_NUMBER;
        hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashLong(
            getVersion());
      }
      if (getSubjectReachabilityCount() > 0) {
        hash = (37 * hash) + SUBJECTREACHABILITY_FIELD_NUMBER;
        hash = (53 * hash) + getSubjectReachabilityList().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Reachability
     * </pre>
     *
     * Protobuf type {@code ObserverReachability}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:ObserverReachability)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachabilityOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ObserverReachability_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ObserverReachability_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getSubjectReachabilityFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        addressIndex_ = 0;
        bitField0_ = (bitField0_ & ~0x00000001);
        version_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000002);
        if (subjectReachabilityBuilder_ == null) {
          subjectReachability_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000004);
        } else {
          subjectReachabilityBuilder_.clear();
        }
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ObserverReachability_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.addressIndex_ = addressIndex_;
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.version_ = version_;
          to_bitField0_ |= 0x00000002;
        }
        if (subjectReachabilityBuilder_ == null) {
          if (((bitField0_ & 0x00000004) != 0)) {
            subjectReachability_ = java.util.Collections.unmodifiableList(subjectReachability_);
            bitField0_ = (bitField0_ & ~0x00000004);
          }
          result.subjectReachability_ = subjectReachability_;
        } else {
          result.subjectReachability_ = subjectReachabilityBuilder_.build();
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability.getDefaultInstance()) return this;
        if (other.hasAddressIndex()) {
          setAddressIndex(other.getAddressIndex());
        }
        if (other.hasVersion()) {
          setVersion(other.getVersion());
        }
        if (subjectReachabilityBuilder_ == null) {
          if (!other.subjectReachability_.isEmpty()) {
            if (subjectReachability_.isEmpty()) {
              subjectReachability_ = other.subjectReachability_;
              bitField0_ = (bitField0_ & ~0x00000004);
            } else {
              ensureSubjectReachabilityIsMutable();
              subjectReachability_.addAll(other.subjectReachability_);
            }
            onChanged();
          }
        } else {
          if (!other.subjectReachability_.isEmpty()) {
            if (subjectReachabilityBuilder_.isEmpty()) {
              subjectReachabilityBuilder_.dispose();
              subjectReachabilityBuilder_ = null;
              subjectReachability_ = other.subjectReachability_;
              bitField0_ = (bitField0_ & ~0x00000004);
              subjectReachabilityBuilder_ = 
                org.apache.pekko.protobufv3.internal.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getSubjectReachabilityFieldBuilder() : null;
            } else {
              subjectReachabilityBuilder_.addAllMessages(other.subjectReachability_);
            }
          }
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasAddressIndex()) {
          return false;
        }
        if (!hasVersion()) {
          return false;
        }
        for (int i = 0; i < getSubjectReachabilityCount(); i++) {
          if (!getSubjectReachability(i).isInitialized()) {
            return false;
          }
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private int addressIndex_ ;
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return Whether the addressIndex field is set.
       */
      public boolean hasAddressIndex() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return The addressIndex.
       */
      public int getAddressIndex() {
        return addressIndex_;
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @param value The addressIndex to set.
       * @return This builder for chaining.
       */
      public Builder setAddressIndex(int value) {
        bitField0_ |= 0x00000001;
        addressIndex_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearAddressIndex() {
        bitField0_ = (bitField0_ & ~0x00000001);
        addressIndex_ = 0;
        onChanged();
        return this;
      }

      private long version_ ;
      /**
       * <code>required int64 version = 4;</code>
       * @return Whether the version field is set.
       */
      public boolean hasVersion() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required int64 version = 4;</code>
       * @return The version.
       */
      public long getVersion() {
        return version_;
      }
      /**
       * <code>required int64 version = 4;</code>
       * @param value The version to set.
       * @return This builder for chaining.
       */
      public Builder setVersion(long value) {
        bitField0_ |= 0x00000002;
        version_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int64 version = 4;</code>
       * @return This builder for chaining.
       */
      public Builder clearVersion() {
        bitField0_ = (bitField0_ & ~0x00000002);
        version_ = 0L;
        onChanged();
        return this;
      }

      private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability> subjectReachability_ =
        java.util.Collections.emptyList();
      private void ensureSubjectReachabilityIsMutable() {
        if (!((bitField0_ & 0x00000004) != 0)) {
          subjectReachability_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability>(subjectReachability_);
          bitField0_ |= 0x00000004;
         }
      }

      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder> subjectReachabilityBuilder_;

      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability> getSubjectReachabilityList() {
        if (subjectReachabilityBuilder_ == null) {
          return java.util.Collections.unmodifiableList(subjectReachability_);
        } else {
          return subjectReachabilityBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public int getSubjectReachabilityCount() {
        if (subjectReachabilityBuilder_ == null) {
          return subjectReachability_.size();
        } else {
          return subjectReachabilityBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability getSubjectReachability(int index) {
        if (subjectReachabilityBuilder_ == null) {
          return subjectReachability_.get(index);
        } else {
          return subjectReachabilityBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public Builder setSubjectReachability(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability value) {
        if (subjectReachabilityBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSubjectReachabilityIsMutable();
          subjectReachability_.set(index, value);
          onChanged();
        } else {
          subjectReachabilityBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public Builder setSubjectReachability(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder builderForValue) {
        if (subjectReachabilityBuilder_ == null) {
          ensureSubjectReachabilityIsMutable();
          subjectReachability_.set(index, builderForValue.build());
          onChanged();
        } else {
          subjectReachabilityBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public Builder addSubjectReachability(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability value) {
        if (subjectReachabilityBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSubjectReachabilityIsMutable();
          subjectReachability_.add(value);
          onChanged();
        } else {
          subjectReachabilityBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public Builder addSubjectReachability(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability value) {
        if (subjectReachabilityBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureSubjectReachabilityIsMutable();
          subjectReachability_.add(index, value);
          onChanged();
        } else {
          subjectReachabilityBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public Builder addSubjectReachability(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder builderForValue) {
        if (subjectReachabilityBuilder_ == null) {
          ensureSubjectReachabilityIsMutable();
          subjectReachability_.add(builderForValue.build());
          onChanged();
        } else {
          subjectReachabilityBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public Builder addSubjectReachability(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder builderForValue) {
        if (subjectReachabilityBuilder_ == null) {
          ensureSubjectReachabilityIsMutable();
          subjectReachability_.add(index, builderForValue.build());
          onChanged();
        } else {
          subjectReachabilityBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public Builder addAllSubjectReachability(
          java.lang.Iterable<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability> values) {
        if (subjectReachabilityBuilder_ == null) {
          ensureSubjectReachabilityIsMutable();
          org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
              values, subjectReachability_);
          onChanged();
        } else {
          subjectReachabilityBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public Builder clearSubjectReachability() {
        if (subjectReachabilityBuilder_ == null) {
          subjectReachability_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000004);
          onChanged();
        } else {
          subjectReachabilityBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public Builder removeSubjectReachability(int index) {
        if (subjectReachabilityBuilder_ == null) {
          ensureSubjectReachabilityIsMutable();
          subjectReachability_.remove(index);
          onChanged();
        } else {
          subjectReachabilityBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder getSubjectReachabilityBuilder(
          int index) {
        return getSubjectReachabilityFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder getSubjectReachabilityOrBuilder(
          int index) {
        if (subjectReachabilityBuilder_ == null) {
          return subjectReachability_.get(index);  } else {
          return subjectReachabilityBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder> 
           getSubjectReachabilityOrBuilderList() {
        if (subjectReachabilityBuilder_ != null) {
          return subjectReachabilityBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(subjectReachability_);
        }
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder addSubjectReachabilityBuilder() {
        return getSubjectReachabilityFieldBuilder().addBuilder(
            org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.getDefaultInstance());
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder addSubjectReachabilityBuilder(
          int index) {
        return getSubjectReachabilityFieldBuilder().addBuilder(
            index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.getDefaultInstance());
      }
      /**
       * <code>repeated .SubjectReachability subjectReachability = 2;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder> 
           getSubjectReachabilityBuilderList() {
        return getSubjectReachabilityFieldBuilder().getBuilderList();
      }
      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder> 
          getSubjectReachabilityFieldBuilder() {
        if (subjectReachabilityBuilder_ == null) {
          subjectReachabilityBuilder_ = new org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder>(
                  subjectReachability_,
                  ((bitField0_ & 0x00000004) != 0),
                  getParentForChildren(),
                  isClean());
          subjectReachability_ = null;
        }
        return subjectReachabilityBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:ObserverReachability)
    }

    // @@protoc_insertion_point(class_scope:ObserverReachability)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<ObserverReachability>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<ObserverReachability>() {
      @java.lang.Override
      public ObserverReachability parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new ObserverReachability(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<ObserverReachability> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<ObserverReachability> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ObserverReachability getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface SubjectReachabilityOrBuilder extends
      // @@protoc_insertion_point(interface_extends:SubjectReachability)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return Whether the addressIndex field is set.
     */
    boolean hasAddressIndex();
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return The addressIndex.
     */
    int getAddressIndex();

    /**
     * <code>required .ReachabilityStatus status = 3;</code>
     * @return Whether the status field is set.
     */
    boolean hasStatus();
    /**
     * <code>required .ReachabilityStatus status = 3;</code>
     * @return The status.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus getStatus();

    /**
     * <code>required int64 version = 4;</code>
     * @return Whether the version field is set.
     */
    boolean hasVersion();
    /**
     * <code>required int64 version = 4;</code>
     * @return The version.
     */
    long getVersion();
  }
  /**
   * Protobuf type {@code SubjectReachability}
   */
  public  static final class SubjectReachability extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:SubjectReachability)
      SubjectReachabilityOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use SubjectReachability.newBuilder() to construct.
    private SubjectReachability(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private SubjectReachability() {
      status_ = 0;
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new SubjectReachability();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private SubjectReachability(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              bitField0_ |= 0x00000001;
              addressIndex_ = input.readInt32();
              break;
            }
            case 24: {
              int rawValue = input.readEnum();
                @SuppressWarnings("deprecation")
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus value = org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(3, rawValue);
              } else {
                bitField0_ |= 0x00000002;
                status_ = rawValue;
              }
              break;
            }
            case 32: {
              bitField0_ |= 0x00000004;
              version_ = input.readInt64();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_SubjectReachability_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_SubjectReachability_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder.class);
    }

    private int bitField0_;
    public static final int ADDRESSINDEX_FIELD_NUMBER = 1;
    private int addressIndex_;
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return Whether the addressIndex field is set.
     */
    public boolean hasAddressIndex() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return The addressIndex.
     */
    public int getAddressIndex() {
      return addressIndex_;
    }

    public static final int STATUS_FIELD_NUMBER = 3;
    private int status_;
    /**
     * <code>required .ReachabilityStatus status = 3;</code>
     * @return Whether the status field is set.
     */
    public boolean hasStatus() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required .ReachabilityStatus status = 3;</code>
     * @return The status.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus getStatus() {
      @SuppressWarnings("deprecation")
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus result = org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus.valueOf(status_);
      return result == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus.Reachable : result;
    }

    public static final int VERSION_FIELD_NUMBER = 4;
    private long version_;
    /**
     * <code>required int64 version = 4;</code>
     * @return Whether the version field is set.
     */
    public boolean hasVersion() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <code>required int64 version = 4;</code>
     * @return The version.
     */
    public long getVersion() {
      return version_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasAddressIndex()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasStatus()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasVersion()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeInt32(1, addressIndex_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeEnum(3, status_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeInt64(4, version_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt32Size(1, addressIndex_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeEnumSize(3, status_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt64Size(4, version_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability) obj;

      if (hasAddressIndex() != other.hasAddressIndex()) return false;
      if (hasAddressIndex()) {
        if (getAddressIndex()
            != other.getAddressIndex()) return false;
      }
      if (hasStatus() != other.hasStatus()) return false;
      if (hasStatus()) {
        if (status_ != other.status_) return false;
      }
      if (hasVersion() != other.hasVersion()) return false;
      if (hasVersion()) {
        if (getVersion()
            != other.getVersion()) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasAddressIndex()) {
        hash = (37 * hash) + ADDRESSINDEX_FIELD_NUMBER;
        hash = (53 * hash) + getAddressIndex();
      }
      if (hasStatus()) {
        hash = (37 * hash) + STATUS_FIELD_NUMBER;
        hash = (53 * hash) + status_;
      }
      if (hasVersion()) {
        hash = (37 * hash) + VERSION_FIELD_NUMBER;
        hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashLong(
            getVersion());
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code SubjectReachability}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:SubjectReachability)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachabilityOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_SubjectReachability_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_SubjectReachability_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        addressIndex_ = 0;
        bitField0_ = (bitField0_ & ~0x00000001);
        status_ = 0;
        bitField0_ = (bitField0_ & ~0x00000002);
        version_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_SubjectReachability_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.addressIndex_ = addressIndex_;
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          to_bitField0_ |= 0x00000002;
        }
        result.status_ = status_;
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.version_ = version_;
          to_bitField0_ |= 0x00000004;
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability.getDefaultInstance()) return this;
        if (other.hasAddressIndex()) {
          setAddressIndex(other.getAddressIndex());
        }
        if (other.hasStatus()) {
          setStatus(other.getStatus());
        }
        if (other.hasVersion()) {
          setVersion(other.getVersion());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasAddressIndex()) {
          return false;
        }
        if (!hasStatus()) {
          return false;
        }
        if (!hasVersion()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private int addressIndex_ ;
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return Whether the addressIndex field is set.
       */
      public boolean hasAddressIndex() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return The addressIndex.
       */
      public int getAddressIndex() {
        return addressIndex_;
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @param value The addressIndex to set.
       * @return This builder for chaining.
       */
      public Builder setAddressIndex(int value) {
        bitField0_ |= 0x00000001;
        addressIndex_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearAddressIndex() {
        bitField0_ = (bitField0_ & ~0x00000001);
        addressIndex_ = 0;
        onChanged();
        return this;
      }

      private int status_ = 0;
      /**
       * <code>required .ReachabilityStatus status = 3;</code>
       * @return Whether the status field is set.
       */
      public boolean hasStatus() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required .ReachabilityStatus status = 3;</code>
       * @return The status.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus getStatus() {
        @SuppressWarnings("deprecation")
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus result = org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus.valueOf(status_);
        return result == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus.Reachable : result;
      }
      /**
       * <code>required .ReachabilityStatus status = 3;</code>
       * @param value The status to set.
       * @return This builder for chaining.
       */
      public Builder setStatus(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ReachabilityStatus value) {
        if (value == null) {
          throw new NullPointerException();
        }
        bitField0_ |= 0x00000002;
        status_ = value.getNumber();
        onChanged();
        return this;
      }
      /**
       * <code>required .ReachabilityStatus status = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearStatus() {
        bitField0_ = (bitField0_ & ~0x00000002);
        status_ = 0;
        onChanged();
        return this;
      }

      private long version_ ;
      /**
       * <code>required int64 version = 4;</code>
       * @return Whether the version field is set.
       */
      public boolean hasVersion() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>required int64 version = 4;</code>
       * @return The version.
       */
      public long getVersion() {
        return version_;
      }
      /**
       * <code>required int64 version = 4;</code>
       * @param value The version to set.
       * @return This builder for chaining.
       */
      public Builder setVersion(long value) {
        bitField0_ |= 0x00000004;
        version_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int64 version = 4;</code>
       * @return This builder for chaining.
       */
      public Builder clearVersion() {
        bitField0_ = (bitField0_ & ~0x00000004);
        version_ = 0L;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:SubjectReachability)
    }

    // @@protoc_insertion_point(class_scope:SubjectReachability)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<SubjectReachability>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<SubjectReachability>() {
      @java.lang.Override
      public SubjectReachability parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new SubjectReachability(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<SubjectReachability> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<SubjectReachability> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.SubjectReachability getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface TombstoneOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Tombstone)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return Whether the addressIndex field is set.
     */
    boolean hasAddressIndex();
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return The addressIndex.
     */
    int getAddressIndex();

    /**
     * <code>required int64 timestamp = 2;</code>
     * @return Whether the timestamp field is set.
     */
    boolean hasTimestamp();
    /**
     * <code>required int64 timestamp = 2;</code>
     * @return The timestamp.
     */
    long getTimestamp();
  }
  /**
   * Protobuf type {@code Tombstone}
   */
  public  static final class Tombstone extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Tombstone)
      TombstoneOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Tombstone.newBuilder() to construct.
    private Tombstone(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Tombstone() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new Tombstone();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Tombstone(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              bitField0_ |= 0x00000001;
              addressIndex_ = input.readInt32();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              timestamp_ = input.readInt64();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Tombstone_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Tombstone_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder.class);
    }

    private int bitField0_;
    public static final int ADDRESSINDEX_FIELD_NUMBER = 1;
    private int addressIndex_;
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return Whether the addressIndex field is set.
     */
    public boolean hasAddressIndex() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return The addressIndex.
     */
    public int getAddressIndex() {
      return addressIndex_;
    }

    public static final int TIMESTAMP_FIELD_NUMBER = 2;
    private long timestamp_;
    /**
     * <code>required int64 timestamp = 2;</code>
     * @return Whether the timestamp field is set.
     */
    public boolean hasTimestamp() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required int64 timestamp = 2;</code>
     * @return The timestamp.
     */
    public long getTimestamp() {
      return timestamp_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasAddressIndex()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasTimestamp()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeInt32(1, addressIndex_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeInt64(2, timestamp_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt32Size(1, addressIndex_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt64Size(2, timestamp_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone) obj;

      if (hasAddressIndex() != other.hasAddressIndex()) return false;
      if (hasAddressIndex()) {
        if (getAddressIndex()
            != other.getAddressIndex()) return false;
      }
      if (hasTimestamp() != other.hasTimestamp()) return false;
      if (hasTimestamp()) {
        if (getTimestamp()
            != other.getTimestamp()) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasAddressIndex()) {
        hash = (37 * hash) + ADDRESSINDEX_FIELD_NUMBER;
        hash = (53 * hash) + getAddressIndex();
      }
      if (hasTimestamp()) {
        hash = (37 * hash) + TIMESTAMP_FIELD_NUMBER;
        hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashLong(
            getTimestamp());
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code Tombstone}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Tombstone)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.TombstoneOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Tombstone_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Tombstone_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        addressIndex_ = 0;
        bitField0_ = (bitField0_ & ~0x00000001);
        timestamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Tombstone_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.addressIndex_ = addressIndex_;
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.timestamp_ = timestamp_;
          to_bitField0_ |= 0x00000002;
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone.getDefaultInstance()) return this;
        if (other.hasAddressIndex()) {
          setAddressIndex(other.getAddressIndex());
        }
        if (other.hasTimestamp()) {
          setTimestamp(other.getTimestamp());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasAddressIndex()) {
          return false;
        }
        if (!hasTimestamp()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private int addressIndex_ ;
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return Whether the addressIndex field is set.
       */
      public boolean hasAddressIndex() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return The addressIndex.
       */
      public int getAddressIndex() {
        return addressIndex_;
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @param value The addressIndex to set.
       * @return This builder for chaining.
       */
      public Builder setAddressIndex(int value) {
        bitField0_ |= 0x00000001;
        addressIndex_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearAddressIndex() {
        bitField0_ = (bitField0_ & ~0x00000001);
        addressIndex_ = 0;
        onChanged();
        return this;
      }

      private long timestamp_ ;
      /**
       * <code>required int64 timestamp = 2;</code>
       * @return Whether the timestamp field is set.
       */
      public boolean hasTimestamp() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required int64 timestamp = 2;</code>
       * @return The timestamp.
       */
      public long getTimestamp() {
        return timestamp_;
      }
      /**
       * <code>required int64 timestamp = 2;</code>
       * @param value The timestamp to set.
       * @return This builder for chaining.
       */
      public Builder setTimestamp(long value) {
        bitField0_ |= 0x00000002;
        timestamp_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int64 timestamp = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearTimestamp() {
        bitField0_ = (bitField0_ & ~0x00000002);
        timestamp_ = 0L;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Tombstone)
    }

    // @@protoc_insertion_point(class_scope:Tombstone)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Tombstone>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Tombstone>() {
      @java.lang.Override
      public Tombstone parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new Tombstone(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<Tombstone> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<Tombstone> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Tombstone getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface MemberOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Member)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return Whether the addressIndex field is set.
     */
    boolean hasAddressIndex();
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return The addressIndex.
     */
    int getAddressIndex();

    /**
     * <code>required int32 upNumber = 2;</code>
     * @return Whether the upNumber field is set.
     */
    boolean hasUpNumber();
    /**
     * <code>required int32 upNumber = 2;</code>
     * @return The upNumber.
     */
    int getUpNumber();

    /**
     * <code>required .MemberStatus status = 3;</code>
     * @return Whether the status field is set.
     */
    boolean hasStatus();
    /**
     * <code>required .MemberStatus status = 3;</code>
     * @return The status.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus getStatus();

    /**
     * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
     * @return A list containing the rolesIndexes.
     */
    java.util.List<java.lang.Integer> getRolesIndexesList();
    /**
     * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
     * @return The count of rolesIndexes.
     */
    int getRolesIndexesCount();
    /**
     * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
     * @param index The index of the element to return.
     * @return The rolesIndexes at the given index.
     */
    int getRolesIndexes(int index);

    /**
     * <code>optional int32 appVersionIndex = 5;</code>
     * @return Whether the appVersionIndex field is set.
     */
    boolean hasAppVersionIndex();
    /**
     * <code>optional int32 appVersionIndex = 5;</code>
     * @return The appVersionIndex.
     */
    int getAppVersionIndex();
  }
  /**
   * <pre>
   **
   * Member
   * </pre>
   *
   * Protobuf type {@code Member}
   */
  public  static final class Member extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Member)
      MemberOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Member.newBuilder() to construct.
    private Member(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Member() {
      status_ = 0;
      rolesIndexes_ = emptyIntList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new Member();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Member(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              bitField0_ |= 0x00000001;
              addressIndex_ = input.readInt32();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              upNumber_ = input.readInt32();
              break;
            }
            case 24: {
              int rawValue = input.readEnum();
                @SuppressWarnings("deprecation")
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus value = org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus.valueOf(rawValue);
              if (value == null) {
                unknownFields.mergeVarintField(3, rawValue);
              } else {
                bitField0_ |= 0x00000004;
                status_ = rawValue;
              }
              break;
            }
            case 32: {
              if (!((mutable_bitField0_ & 0x00000008) != 0)) {
                rolesIndexes_ = newIntList();
                mutable_bitField0_ |= 0x00000008;
              }
              rolesIndexes_.addInt(input.readInt32());
              break;
            }
            case 34: {
              int length = input.readRawVarint32();
              int limit = input.pushLimit(length);
              if (!((mutable_bitField0_ & 0x00000008) != 0) && input.getBytesUntilLimit() > 0) {
                rolesIndexes_ = newIntList();
                mutable_bitField0_ |= 0x00000008;
              }
              while (input.getBytesUntilLimit() > 0) {
                rolesIndexes_.addInt(input.readInt32());
              }
              input.popLimit(limit);
              break;
            }
            case 40: {
              bitField0_ |= 0x00000008;
              appVersionIndex_ = input.readInt32();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000008) != 0)) {
          rolesIndexes_.makeImmutable(); // C
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Member_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Member_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder.class);
    }

    private int bitField0_;
    public static final int ADDRESSINDEX_FIELD_NUMBER = 1;
    private int addressIndex_;
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return Whether the addressIndex field is set.
     */
    public boolean hasAddressIndex() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required int32 addressIndex = 1;</code>
     * @return The addressIndex.
     */
    public int getAddressIndex() {
      return addressIndex_;
    }

    public static final int UPNUMBER_FIELD_NUMBER = 2;
    private int upNumber_;
    /**
     * <code>required int32 upNumber = 2;</code>
     * @return Whether the upNumber field is set.
     */
    public boolean hasUpNumber() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required int32 upNumber = 2;</code>
     * @return The upNumber.
     */
    public int getUpNumber() {
      return upNumber_;
    }

    public static final int STATUS_FIELD_NUMBER = 3;
    private int status_;
    /**
     * <code>required .MemberStatus status = 3;</code>
     * @return Whether the status field is set.
     */
    public boolean hasStatus() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <code>required .MemberStatus status = 3;</code>
     * @return The status.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus getStatus() {
      @SuppressWarnings("deprecation")
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus result = org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus.valueOf(status_);
      return result == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus.Joining : result;
    }

    public static final int ROLESINDEXES_FIELD_NUMBER = 4;
    private org.apache.pekko.protobufv3.internal.Internal.IntList rolesIndexes_;
    /**
     * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
     * @return A list containing the rolesIndexes.
     */
    public java.util.List<java.lang.Integer>
        getRolesIndexesList() {
      return rolesIndexes_;
    }
    /**
     * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
     * @return The count of rolesIndexes.
     */
    public int getRolesIndexesCount() {
      return rolesIndexes_.size();
    }
    /**
     * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
     * @param index The index of the element to return.
     * @return The rolesIndexes at the given index.
     */
    public int getRolesIndexes(int index) {
      return rolesIndexes_.getInt(index);
    }
    private int rolesIndexesMemoizedSerializedSize = -1;

    public static final int APPVERSIONINDEX_FIELD_NUMBER = 5;
    private int appVersionIndex_;
    /**
     * <code>optional int32 appVersionIndex = 5;</code>
     * @return Whether the appVersionIndex field is set.
     */
    public boolean hasAppVersionIndex() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <code>optional int32 appVersionIndex = 5;</code>
     * @return The appVersionIndex.
     */
    public int getAppVersionIndex() {
      return appVersionIndex_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasAddressIndex()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasUpNumber()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasStatus()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeInt32(1, addressIndex_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeInt32(2, upNumber_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeEnum(3, status_);
      }
      if (getRolesIndexesList().size() > 0) {
        output.writeUInt32NoTag(34);
        output.writeUInt32NoTag(rolesIndexesMemoizedSerializedSize);
      }
      for (int i = 0; i < rolesIndexes_.size(); i++) {
        output.writeInt32NoTag(rolesIndexes_.getInt(i));
      }
      if (((bitField0_ & 0x00000008) != 0)) {
        output.writeInt32(5, appVersionIndex_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt32Size(1, addressIndex_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt32Size(2, upNumber_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeEnumSize(3, status_);
      }
      {
        int dataSize = 0;
        for (int i = 0; i < rolesIndexes_.size(); i++) {
          dataSize += org.apache.pekko.protobufv3.internal.CodedOutputStream
            .computeInt32SizeNoTag(rolesIndexes_.getInt(i));
        }
        size += dataSize;
        if (!getRolesIndexesList().isEmpty()) {
          size += 1;
          size += org.apache.pekko.protobufv3.internal.CodedOutputStream
              .computeInt32SizeNoTag(dataSize);
        }
        rolesIndexesMemoizedSerializedSize = dataSize;
      }
      if (((bitField0_ & 0x00000008) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt32Size(5, appVersionIndex_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member) obj;

      if (hasAddressIndex() != other.hasAddressIndex()) return false;
      if (hasAddressIndex()) {
        if (getAddressIndex()
            != other.getAddressIndex()) return false;
      }
      if (hasUpNumber() != other.hasUpNumber()) return false;
      if (hasUpNumber()) {
        if (getUpNumber()
            != other.getUpNumber()) return false;
      }
      if (hasStatus() != other.hasStatus()) return false;
      if (hasStatus()) {
        if (status_ != other.status_) return false;
      }
      if (!getRolesIndexesList()
          .equals(other.getRolesIndexesList())) return false;
      if (hasAppVersionIndex() != other.hasAppVersionIndex()) return false;
      if (hasAppVersionIndex()) {
        if (getAppVersionIndex()
            != other.getAppVersionIndex()) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasAddressIndex()) {
        hash = (37 * hash) + ADDRESSINDEX_FIELD_NUMBER;
        hash = (53 * hash) + getAddressIndex();
      }
      if (hasUpNumber()) {
        hash = (37 * hash) + UPNUMBER_FIELD_NUMBER;
        hash = (53 * hash) + getUpNumber();
      }
      if (hasStatus()) {
        hash = (37 * hash) + STATUS_FIELD_NUMBER;
        hash = (53 * hash) + status_;
      }
      if (getRolesIndexesCount() > 0) {
        hash = (37 * hash) + ROLESINDEXES_FIELD_NUMBER;
        hash = (53 * hash) + getRolesIndexesList().hashCode();
      }
      if (hasAppVersionIndex()) {
        hash = (37 * hash) + APPVERSIONINDEX_FIELD_NUMBER;
        hash = (53 * hash) + getAppVersionIndex();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Member
     * </pre>
     *
     * Protobuf type {@code Member}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Member)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Member_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Member_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        addressIndex_ = 0;
        bitField0_ = (bitField0_ & ~0x00000001);
        upNumber_ = 0;
        bitField0_ = (bitField0_ & ~0x00000002);
        status_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        rolesIndexes_ = emptyIntList();
        bitField0_ = (bitField0_ & ~0x00000008);
        appVersionIndex_ = 0;
        bitField0_ = (bitField0_ & ~0x00000010);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Member_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.addressIndex_ = addressIndex_;
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.upNumber_ = upNumber_;
          to_bitField0_ |= 0x00000002;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          to_bitField0_ |= 0x00000004;
        }
        result.status_ = status_;
        if (((bitField0_ & 0x00000008) != 0)) {
          rolesIndexes_.makeImmutable();
          bitField0_ = (bitField0_ & ~0x00000008);
        }
        result.rolesIndexes_ = rolesIndexes_;
        if (((from_bitField0_ & 0x00000010) != 0)) {
          result.appVersionIndex_ = appVersionIndex_;
          to_bitField0_ |= 0x00000008;
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member.getDefaultInstance()) return this;
        if (other.hasAddressIndex()) {
          setAddressIndex(other.getAddressIndex());
        }
        if (other.hasUpNumber()) {
          setUpNumber(other.getUpNumber());
        }
        if (other.hasStatus()) {
          setStatus(other.getStatus());
        }
        if (!other.rolesIndexes_.isEmpty()) {
          if (rolesIndexes_.isEmpty()) {
            rolesIndexes_ = other.rolesIndexes_;
            bitField0_ = (bitField0_ & ~0x00000008);
          } else {
            ensureRolesIndexesIsMutable();
            rolesIndexes_.addAll(other.rolesIndexes_);
          }
          onChanged();
        }
        if (other.hasAppVersionIndex()) {
          setAppVersionIndex(other.getAppVersionIndex());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasAddressIndex()) {
          return false;
        }
        if (!hasUpNumber()) {
          return false;
        }
        if (!hasStatus()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private int addressIndex_ ;
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return Whether the addressIndex field is set.
       */
      public boolean hasAddressIndex() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return The addressIndex.
       */
      public int getAddressIndex() {
        return addressIndex_;
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @param value The addressIndex to set.
       * @return This builder for chaining.
       */
      public Builder setAddressIndex(int value) {
        bitField0_ |= 0x00000001;
        addressIndex_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int32 addressIndex = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearAddressIndex() {
        bitField0_ = (bitField0_ & ~0x00000001);
        addressIndex_ = 0;
        onChanged();
        return this;
      }

      private int upNumber_ ;
      /**
       * <code>required int32 upNumber = 2;</code>
       * @return Whether the upNumber field is set.
       */
      public boolean hasUpNumber() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required int32 upNumber = 2;</code>
       * @return The upNumber.
       */
      public int getUpNumber() {
        return upNumber_;
      }
      /**
       * <code>required int32 upNumber = 2;</code>
       * @param value The upNumber to set.
       * @return This builder for chaining.
       */
      public Builder setUpNumber(int value) {
        bitField0_ |= 0x00000002;
        upNumber_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required int32 upNumber = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearUpNumber() {
        bitField0_ = (bitField0_ & ~0x00000002);
        upNumber_ = 0;
        onChanged();
        return this;
      }

      private int status_ = 0;
      /**
       * <code>required .MemberStatus status = 3;</code>
       * @return Whether the status field is set.
       */
      public boolean hasStatus() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>required .MemberStatus status = 3;</code>
       * @return The status.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus getStatus() {
        @SuppressWarnings("deprecation")
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus result = org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus.valueOf(status_);
        return result == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus.Joining : result;
      }
      /**
       * <code>required .MemberStatus status = 3;</code>
       * @param value The status to set.
       * @return This builder for chaining.
       */
      public Builder setStatus(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.MemberStatus value) {
        if (value == null) {
          throw new NullPointerException();
        }
        bitField0_ |= 0x00000004;
        status_ = value.getNumber();
        onChanged();
        return this;
      }
      /**
       * <code>required .MemberStatus status = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearStatus() {
        bitField0_ = (bitField0_ & ~0x00000004);
        status_ = 0;
        onChanged();
        return this;
      }

      private org.apache.pekko.protobufv3.internal.Internal.IntList rolesIndexes_ = emptyIntList();
      private void ensureRolesIndexesIsMutable() {
        if (!((bitField0_ & 0x00000008) != 0)) {
          rolesIndexes_ = mutableCopy(rolesIndexes_);
          bitField0_ |= 0x00000008;
         }
      }
      /**
       * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
       * @return A list containing the rolesIndexes.
       */
      public java.util.List<java.lang.Integer>
          getRolesIndexesList() {
        return ((bitField0_ & 0x00000008) != 0) ?
                 java.util.Collections.unmodifiableList(rolesIndexes_) : rolesIndexes_;
      }
      /**
       * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
       * @return The count of rolesIndexes.
       */
      public int getRolesIndexesCount() {
        return rolesIndexes_.size();
      }
      /**
       * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
       * @param index The index of the element to return.
       * @return The rolesIndexes at the given index.
       */
      public int getRolesIndexes(int index) {
        return rolesIndexes_.getInt(index);
      }
      /**
       * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
       * @param index The index to set the value at.
       * @param value The rolesIndexes to set.
       * @return This builder for chaining.
       */
      public Builder setRolesIndexes(
          int index, int value) {
        ensureRolesIndexesIsMutable();
        rolesIndexes_.setInt(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
       * @param value The rolesIndexes to add.
       * @return This builder for chaining.
       */
      public Builder addRolesIndexes(int value) {
        ensureRolesIndexesIsMutable();
        rolesIndexes_.addInt(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
       * @param values The rolesIndexes to add.
       * @return This builder for chaining.
       */
      public Builder addAllRolesIndexes(
          java.lang.Iterable<? extends java.lang.Integer> values) {
        ensureRolesIndexesIsMutable();
        org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
            values, rolesIndexes_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated int32 rolesIndexes = 4 [packed = true];</code>
       * @return This builder for chaining.
       */
      public Builder clearRolesIndexes() {
        rolesIndexes_ = emptyIntList();
        bitField0_ = (bitField0_ & ~0x00000008);
        onChanged();
        return this;
      }

      private int appVersionIndex_ ;
      /**
       * <code>optional int32 appVersionIndex = 5;</code>
       * @return Whether the appVersionIndex field is set.
       */
      public boolean hasAppVersionIndex() {
        return ((bitField0_ & 0x00000010) != 0);
      }
      /**
       * <code>optional int32 appVersionIndex = 5;</code>
       * @return The appVersionIndex.
       */
      public int getAppVersionIndex() {
        return appVersionIndex_;
      }
      /**
       * <code>optional int32 appVersionIndex = 5;</code>
       * @param value The appVersionIndex to set.
       * @return This builder for chaining.
       */
      public Builder setAppVersionIndex(int value) {
        bitField0_ |= 0x00000010;
        appVersionIndex_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional int32 appVersionIndex = 5;</code>
       * @return This builder for chaining.
       */
      public Builder clearAppVersionIndex() {
        bitField0_ = (bitField0_ & ~0x00000010);
        appVersionIndex_ = 0;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Member)
    }

    // @@protoc_insertion_point(class_scope:Member)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Member>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Member>() {
      @java.lang.Override
      public Member parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new Member(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<Member> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<Member> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Member getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface VectorClockOrBuilder extends
      // @@protoc_insertion_point(interface_extends:VectorClock)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <pre>
     * the timestamp could be removed but left for test data compatibility
     * </pre>
     *
     * <code>optional int64 timestamp = 1;</code>
     * @return Whether the timestamp field is set.
     */
    boolean hasTimestamp();
    /**
     * <pre>
     * the timestamp could be removed but left for test data compatibility
     * </pre>
     *
     * <code>optional int64 timestamp = 1;</code>
     * @return The timestamp.
     */
    long getTimestamp();

    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version> 
        getVersionsList();
    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version getVersions(int index);
    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    int getVersionsCount();
    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder> 
        getVersionsOrBuilderList();
    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder getVersionsOrBuilder(
        int index);
  }
  /**
   * <pre>
   **
   * Vector Clock
   * </pre>
   *
   * Protobuf type {@code VectorClock}
   */
  public  static final class VectorClock extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:VectorClock)
      VectorClockOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use VectorClock.newBuilder() to construct.
    private VectorClock(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private VectorClock() {
      versions_ = java.util.Collections.emptyList();
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new VectorClock();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private VectorClock(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              bitField0_ |= 0x00000001;
              timestamp_ = input.readInt64();
              break;
            }
            case 18: {
              if (!((mutable_bitField0_ & 0x00000002) != 0)) {
                versions_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version>();
                mutable_bitField0_ |= 0x00000002;
              }
              versions_.add(
                  input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.PARSER, extensionRegistry));
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000002) != 0)) {
          versions_ = java.util.Collections.unmodifiableList(versions_);
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder.class);
    }

    public interface VersionOrBuilder extends
        // @@protoc_insertion_point(interface_extends:VectorClock.Version)
        org.apache.pekko.protobufv3.internal.MessageOrBuilder {

      /**
       * <code>required int32 hashIndex = 1;</code>
       * @return Whether the hashIndex field is set.
       */
      boolean hasHashIndex();
      /**
       * <code>required int32 hashIndex = 1;</code>
       * @return The hashIndex.
       */
      int getHashIndex();

      /**
       * <code>required int64 timestamp = 2;</code>
       * @return Whether the timestamp field is set.
       */
      boolean hasTimestamp();
      /**
       * <code>required int64 timestamp = 2;</code>
       * @return The timestamp.
       */
      long getTimestamp();
    }
    /**
     * Protobuf type {@code VectorClock.Version}
     */
    public  static final class Version extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
        // @@protoc_insertion_point(message_implements:VectorClock.Version)
        VersionOrBuilder {
    private static final long serialVersionUID = 0L;
      // Use Version.newBuilder() to construct.
      private Version(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
        super(builder);
      }
      private Version() {
      }

      @java.lang.Override
      @SuppressWarnings({"unused"})
      protected java.lang.Object newInstance(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
        return new Version();
      }

      @java.lang.Override
      public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
      getUnknownFields() {
        return this.unknownFields;
      }
      private Version(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        this();
        if (extensionRegistry == null) {
          throw new java.lang.NullPointerException();
        }
        int mutable_bitField0_ = 0;
        org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
            org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
        try {
          boolean done = false;
          while (!done) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                done = true;
                break;
              case 8: {
                bitField0_ |= 0x00000001;
                hashIndex_ = input.readInt32();
                break;
              }
              case 16: {
                bitField0_ |= 0x00000002;
                timestamp_ = input.readInt64();
                break;
              }
              default: {
                if (!parseUnknownField(
                    input, unknownFields, extensionRegistry, tag)) {
                  done = true;
                }
                break;
              }
            }
          }
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          throw e.setUnfinishedMessage(this);
        } catch (java.io.IOException e) {
          throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
              e).setUnfinishedMessage(this);
        } finally {
          this.unknownFields = unknownFields.build();
          makeExtensionsImmutable();
        }
      }
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_Version_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_Version_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder.class);
      }

      private int bitField0_;
      public static final int HASHINDEX_FIELD_NUMBER = 1;
      private int hashIndex_;
      /**
       * <code>required int32 hashIndex = 1;</code>
       * @return Whether the hashIndex field is set.
       */
      public boolean hasHashIndex() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required int32 hashIndex = 1;</code>
       * @return The hashIndex.
       */
      public int getHashIndex() {
        return hashIndex_;
      }

      public static final int TIMESTAMP_FIELD_NUMBER = 2;
      private long timestamp_;
      /**
       * <code>required int64 timestamp = 2;</code>
       * @return Whether the timestamp field is set.
       */
      public boolean hasTimestamp() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required int64 timestamp = 2;</code>
       * @return The timestamp.
       */
      public long getTimestamp() {
        return timestamp_;
      }

      private byte memoizedIsInitialized = -1;
      @java.lang.Override
      public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized == 1) return true;
        if (isInitialized == 0) return false;

        if (!hasHashIndex()) {
          memoizedIsInitialized = 0;
          return false;
        }
        if (!hasTimestamp()) {
          memoizedIsInitialized = 0;
          return false;
        }
        memoizedIsInitialized = 1;
        return true;
      }

      @java.lang.Override
      public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                          throws java.io.IOException {
        if (((bitField0_ & 0x00000001) != 0)) {
          output.writeInt32(1, hashIndex_);
        }
        if (((bitField0_ & 0x00000002) != 0)) {
          output.writeInt64(2, timestamp_);
        }
        unknownFields.writeTo(output);
      }

      @java.lang.Override
      public int getSerializedSize() {
        int size = memoizedSize;
        if (size != -1) return size;

        size = 0;
        if (((bitField0_ & 0x00000001) != 0)) {
          size += org.apache.pekko.protobufv3.internal.CodedOutputStream
            .computeInt32Size(1, hashIndex_);
        }
        if (((bitField0_ & 0x00000002) != 0)) {
          size += org.apache.pekko.protobufv3.internal.CodedOutputStream
            .computeInt64Size(2, timestamp_);
        }
        size += unknownFields.getSerializedSize();
        memoizedSize = size;
        return size;
      }

      @java.lang.Override
      public boolean equals(final java.lang.Object obj) {
        if (obj == this) {
         return true;
        }
        if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version)) {
          return super.equals(obj);
        }
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version) obj;

        if (hasHashIndex() != other.hasHashIndex()) return false;
        if (hasHashIndex()) {
          if (getHashIndex()
              != other.getHashIndex()) return false;
        }
        if (hasTimestamp() != other.hasTimestamp()) return false;
        if (hasTimestamp()) {
          if (getTimestamp()
              != other.getTimestamp()) return false;
        }
        if (!unknownFields.equals(other.unknownFields)) return false;
        return true;
      }

      @java.lang.Override
      public int hashCode() {
        if (memoizedHashCode != 0) {
          return memoizedHashCode;
        }
        int hash = 41;
        hash = (19 * hash) + getDescriptor().hashCode();
        if (hasHashIndex()) {
          hash = (37 * hash) + HASHINDEX_FIELD_NUMBER;
          hash = (53 * hash) + getHashIndex();
        }
        if (hasTimestamp()) {
          hash = (37 * hash) + TIMESTAMP_FIELD_NUMBER;
          hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashLong(
              getTimestamp());
        }
        hash = (29 * hash) + unknownFields.hashCode();
        memoizedHashCode = hash;
        return hash;
      }

      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(
          java.nio.ByteBuffer data)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(
          java.nio.ByteBuffer data,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(
          org.apache.pekko.protobufv3.internal.ByteString data)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(
          org.apache.pekko.protobufv3.internal.ByteString data,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(byte[] data)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return PARSER.parseFrom(data);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(
          byte[] data,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return PARSER.parseFrom(data, extensionRegistry);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
            .parseWithIOException(PARSER, input);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(
          java.io.InputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
            .parseWithIOException(PARSER, input, extensionRegistry);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
            .parseDelimitedWithIOException(PARSER, input);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseDelimitedFrom(
          java.io.InputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
            .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input)
          throws java.io.IOException {
        return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
            .parseWithIOException(PARSER, input);
      }
      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parseFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
            .parseWithIOException(PARSER, input, extensionRegistry);
      }

      @java.lang.Override
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder() {
        return DEFAULT_INSTANCE.toBuilder();
      }
      public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version prototype) {
        return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
      }
      @java.lang.Override
      public Builder toBuilder() {
        return this == DEFAULT_INSTANCE
            ? new Builder() : new Builder().mergeFrom(this);
      }

      @java.lang.Override
      protected Builder newBuilderForType(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
      }
      /**
       * Protobuf type {@code VectorClock.Version}
       */
      public static final class Builder extends
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
          // @@protoc_insertion_point(builder_implements:VectorClock.Version)
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder {
        public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
            getDescriptor() {
          return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_Version_descriptor;
        }

        @java.lang.Override
        protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_Version_fieldAccessorTable
              .ensureFieldAccessorsInitialized(
                  org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder.class);
        }

        // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.newBuilder()
        private Builder() {
          maybeForceBuilderInitialization();
        }

        private Builder(
            org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
          super(parent);
          maybeForceBuilderInitialization();
        }
        private void maybeForceBuilderInitialization() {
          if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                  .alwaysUseFieldBuilders) {
          }
        }
        @java.lang.Override
        public Builder clear() {
          super.clear();
          hashIndex_ = 0;
          bitField0_ = (bitField0_ & ~0x00000001);
          timestamp_ = 0L;
          bitField0_ = (bitField0_ & ~0x00000002);
          return this;
        }

        @java.lang.Override
        public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
            getDescriptorForType() {
          return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_Version_descriptor;
        }

        @java.lang.Override
        public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version getDefaultInstanceForType() {
          return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.getDefaultInstance();
        }

        @java.lang.Override
        public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version build() {
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return result;
        }

        @java.lang.Override
        public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version buildPartial() {
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version(this);
          int from_bitField0_ = bitField0_;
          int to_bitField0_ = 0;
          if (((from_bitField0_ & 0x00000001) != 0)) {
            result.hashIndex_ = hashIndex_;
            to_bitField0_ |= 0x00000001;
          }
          if (((from_bitField0_ & 0x00000002) != 0)) {
            result.timestamp_ = timestamp_;
            to_bitField0_ |= 0x00000002;
          }
          result.bitField0_ = to_bitField0_;
          onBuilt();
          return result;
        }

        @java.lang.Override
        public Builder clone() {
          return super.clone();
        }
        @java.lang.Override
        public Builder setField(
            org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
            java.lang.Object value) {
          return super.setField(field, value);
        }
        @java.lang.Override
        public Builder clearField(
            org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
          return super.clearField(field);
        }
        @java.lang.Override
        public Builder clearOneof(
            org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
          return super.clearOneof(oneof);
        }
        @java.lang.Override
        public Builder setRepeatedField(
            org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
            int index, java.lang.Object value) {
          return super.setRepeatedField(field, index, value);
        }
        @java.lang.Override
        public Builder addRepeatedField(
            org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
            java.lang.Object value) {
          return super.addRepeatedField(field, value);
        }
        @java.lang.Override
        public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
          if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version) {
            return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }

        public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version other) {
          if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.getDefaultInstance()) return this;
          if (other.hasHashIndex()) {
            setHashIndex(other.getHashIndex());
          }
          if (other.hasTimestamp()) {
            setTimestamp(other.getTimestamp());
          }
          this.mergeUnknownFields(other.unknownFields);
          onChanged();
          return this;
        }

        @java.lang.Override
        public final boolean isInitialized() {
          if (!hasHashIndex()) {
            return false;
          }
          if (!hasTimestamp()) {
            return false;
          }
          return true;
        }

        @java.lang.Override
        public Builder mergeFrom(
            org.apache.pekko.protobufv3.internal.CodedInputStream input,
            org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version parsedMessage = null;
          try {
            parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
          } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
            parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version) e.getUnfinishedMessage();
            throw e.unwrapIOException();
          } finally {
            if (parsedMessage != null) {
              mergeFrom(parsedMessage);
            }
          }
          return this;
        }
        private int bitField0_;

        private int hashIndex_ ;
        /**
         * <code>required int32 hashIndex = 1;</code>
         * @return Whether the hashIndex field is set.
         */
        public boolean hasHashIndex() {
          return ((bitField0_ & 0x00000001) != 0);
        }
        /**
         * <code>required int32 hashIndex = 1;</code>
         * @return The hashIndex.
         */
        public int getHashIndex() {
          return hashIndex_;
        }
        /**
         * <code>required int32 hashIndex = 1;</code>
         * @param value The hashIndex to set.
         * @return This builder for chaining.
         */
        public Builder setHashIndex(int value) {
          bitField0_ |= 0x00000001;
          hashIndex_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>required int32 hashIndex = 1;</code>
         * @return This builder for chaining.
         */
        public Builder clearHashIndex() {
          bitField0_ = (bitField0_ & ~0x00000001);
          hashIndex_ = 0;
          onChanged();
          return this;
        }

        private long timestamp_ ;
        /**
         * <code>required int64 timestamp = 2;</code>
         * @return Whether the timestamp field is set.
         */
        public boolean hasTimestamp() {
          return ((bitField0_ & 0x00000002) != 0);
        }
        /**
         * <code>required int64 timestamp = 2;</code>
         * @return The timestamp.
         */
        public long getTimestamp() {
          return timestamp_;
        }
        /**
         * <code>required int64 timestamp = 2;</code>
         * @param value The timestamp to set.
         * @return This builder for chaining.
         */
        public Builder setTimestamp(long value) {
          bitField0_ |= 0x00000002;
          timestamp_ = value;
          onChanged();
          return this;
        }
        /**
         * <code>required int64 timestamp = 2;</code>
         * @return This builder for chaining.
         */
        public Builder clearTimestamp() {
          bitField0_ = (bitField0_ & ~0x00000002);
          timestamp_ = 0L;
          onChanged();
          return this;
        }
        @java.lang.Override
        public final Builder setUnknownFields(
            final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
          return super.setUnknownFields(unknownFields);
        }

        @java.lang.Override
        public final Builder mergeUnknownFields(
            final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
          return super.mergeUnknownFields(unknownFields);
        }


        // @@protoc_insertion_point(builder_scope:VectorClock.Version)
      }

      // @@protoc_insertion_point(class_scope:VectorClock.Version)
      private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version DEFAULT_INSTANCE;
      static {
        DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version();
      }

      public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version getDefaultInstance() {
        return DEFAULT_INSTANCE;
      }

      @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Version>
          PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Version>() {
        @java.lang.Override
        public Version parsePartialFrom(
            org.apache.pekko.protobufv3.internal.CodedInputStream input,
            org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
            throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
          return new Version(input, extensionRegistry);
        }
      };

      public static org.apache.pekko.protobufv3.internal.Parser<Version> parser() {
        return PARSER;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Parser<Version> getParserForType() {
        return PARSER;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version getDefaultInstanceForType() {
        return DEFAULT_INSTANCE;
      }

    }

    private int bitField0_;
    public static final int TIMESTAMP_FIELD_NUMBER = 1;
    private long timestamp_;
    /**
     * <pre>
     * the timestamp could be removed but left for test data compatibility
     * </pre>
     *
     * <code>optional int64 timestamp = 1;</code>
     * @return Whether the timestamp field is set.
     */
    public boolean hasTimestamp() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * the timestamp could be removed but left for test data compatibility
     * </pre>
     *
     * <code>optional int64 timestamp = 1;</code>
     * @return The timestamp.
     */
    public long getTimestamp() {
      return timestamp_;
    }

    public static final int VERSIONS_FIELD_NUMBER = 2;
    private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version> versions_;
    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version> getVersionsList() {
      return versions_;
    }
    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder> 
        getVersionsOrBuilderList() {
      return versions_;
    }
    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    public int getVersionsCount() {
      return versions_.size();
    }
    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version getVersions(int index) {
      return versions_.get(index);
    }
    /**
     * <code>repeated .VectorClock.Version versions = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder getVersionsOrBuilder(
        int index) {
      return versions_.get(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      for (int i = 0; i < getVersionsCount(); i++) {
        if (!getVersions(i).isInitialized()) {
          memoizedIsInitialized = 0;
          return false;
        }
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeInt64(1, timestamp_);
      }
      for (int i = 0; i < versions_.size(); i++) {
        output.writeMessage(2, versions_.get(i));
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeInt64Size(1, timestamp_);
      }
      for (int i = 0; i < versions_.size(); i++) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(2, versions_.get(i));
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock) obj;

      if (hasTimestamp() != other.hasTimestamp()) return false;
      if (hasTimestamp()) {
        if (getTimestamp()
            != other.getTimestamp()) return false;
      }
      if (!getVersionsList()
          .equals(other.getVersionsList())) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasTimestamp()) {
        hash = (37 * hash) + TIMESTAMP_FIELD_NUMBER;
        hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashLong(
            getTimestamp());
      }
      if (getVersionsCount() > 0) {
        hash = (37 * hash) + VERSIONS_FIELD_NUMBER;
        hash = (53 * hash) + getVersionsList().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Vector Clock
     * </pre>
     *
     * Protobuf type {@code VectorClock}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:VectorClock)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClockOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getVersionsFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        timestamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        if (versionsBuilder_ == null) {
          versions_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000002);
        } else {
          versionsBuilder_.clear();
        }
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_VectorClock_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.timestamp_ = timestamp_;
          to_bitField0_ |= 0x00000001;
        }
        if (versionsBuilder_ == null) {
          if (((bitField0_ & 0x00000002) != 0)) {
            versions_ = java.util.Collections.unmodifiableList(versions_);
            bitField0_ = (bitField0_ & ~0x00000002);
          }
          result.versions_ = versions_;
        } else {
          result.versions_ = versionsBuilder_.build();
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.getDefaultInstance()) return this;
        if (other.hasTimestamp()) {
          setTimestamp(other.getTimestamp());
        }
        if (versionsBuilder_ == null) {
          if (!other.versions_.isEmpty()) {
            if (versions_.isEmpty()) {
              versions_ = other.versions_;
              bitField0_ = (bitField0_ & ~0x00000002);
            } else {
              ensureVersionsIsMutable();
              versions_.addAll(other.versions_);
            }
            onChanged();
          }
        } else {
          if (!other.versions_.isEmpty()) {
            if (versionsBuilder_.isEmpty()) {
              versionsBuilder_.dispose();
              versionsBuilder_ = null;
              versions_ = other.versions_;
              bitField0_ = (bitField0_ & ~0x00000002);
              versionsBuilder_ = 
                org.apache.pekko.protobufv3.internal.GeneratedMessageV3.alwaysUseFieldBuilders ?
                   getVersionsFieldBuilder() : null;
            } else {
              versionsBuilder_.addAllMessages(other.versions_);
            }
          }
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        for (int i = 0; i < getVersionsCount(); i++) {
          if (!getVersions(i).isInitialized()) {
            return false;
          }
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private long timestamp_ ;
      /**
       * <pre>
       * the timestamp could be removed but left for test data compatibility
       * </pre>
       *
       * <code>optional int64 timestamp = 1;</code>
       * @return Whether the timestamp field is set.
       */
      public boolean hasTimestamp() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <pre>
       * the timestamp could be removed but left for test data compatibility
       * </pre>
       *
       * <code>optional int64 timestamp = 1;</code>
       * @return The timestamp.
       */
      public long getTimestamp() {
        return timestamp_;
      }
      /**
       * <pre>
       * the timestamp could be removed but left for test data compatibility
       * </pre>
       *
       * <code>optional int64 timestamp = 1;</code>
       * @param value The timestamp to set.
       * @return This builder for chaining.
       */
      public Builder setTimestamp(long value) {
        bitField0_ |= 0x00000001;
        timestamp_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * the timestamp could be removed but left for test data compatibility
       * </pre>
       *
       * <code>optional int64 timestamp = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearTimestamp() {
        bitField0_ = (bitField0_ & ~0x00000001);
        timestamp_ = 0L;
        onChanged();
        return this;
      }

      private java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version> versions_ =
        java.util.Collections.emptyList();
      private void ensureVersionsIsMutable() {
        if (!((bitField0_ & 0x00000002) != 0)) {
          versions_ = new java.util.ArrayList<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version>(versions_);
          bitField0_ |= 0x00000002;
         }
      }

      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder> versionsBuilder_;

      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version> getVersionsList() {
        if (versionsBuilder_ == null) {
          return java.util.Collections.unmodifiableList(versions_);
        } else {
          return versionsBuilder_.getMessageList();
        }
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public int getVersionsCount() {
        if (versionsBuilder_ == null) {
          return versions_.size();
        } else {
          return versionsBuilder_.getCount();
        }
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version getVersions(int index) {
        if (versionsBuilder_ == null) {
          return versions_.get(index);
        } else {
          return versionsBuilder_.getMessage(index);
        }
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public Builder setVersions(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version value) {
        if (versionsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureVersionsIsMutable();
          versions_.set(index, value);
          onChanged();
        } else {
          versionsBuilder_.setMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public Builder setVersions(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder builderForValue) {
        if (versionsBuilder_ == null) {
          ensureVersionsIsMutable();
          versions_.set(index, builderForValue.build());
          onChanged();
        } else {
          versionsBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public Builder addVersions(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version value) {
        if (versionsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureVersionsIsMutable();
          versions_.add(value);
          onChanged();
        } else {
          versionsBuilder_.addMessage(value);
        }
        return this;
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public Builder addVersions(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version value) {
        if (versionsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureVersionsIsMutable();
          versions_.add(index, value);
          onChanged();
        } else {
          versionsBuilder_.addMessage(index, value);
        }
        return this;
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public Builder addVersions(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder builderForValue) {
        if (versionsBuilder_ == null) {
          ensureVersionsIsMutable();
          versions_.add(builderForValue.build());
          onChanged();
        } else {
          versionsBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public Builder addVersions(
          int index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder builderForValue) {
        if (versionsBuilder_ == null) {
          ensureVersionsIsMutable();
          versions_.add(index, builderForValue.build());
          onChanged();
        } else {
          versionsBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public Builder addAllVersions(
          java.lang.Iterable<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version> values) {
        if (versionsBuilder_ == null) {
          ensureVersionsIsMutable();
          org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
              values, versions_);
          onChanged();
        } else {
          versionsBuilder_.addAllMessages(values);
        }
        return this;
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public Builder clearVersions() {
        if (versionsBuilder_ == null) {
          versions_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000002);
          onChanged();
        } else {
          versionsBuilder_.clear();
        }
        return this;
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public Builder removeVersions(int index) {
        if (versionsBuilder_ == null) {
          ensureVersionsIsMutable();
          versions_.remove(index);
          onChanged();
        } else {
          versionsBuilder_.remove(index);
        }
        return this;
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder getVersionsBuilder(
          int index) {
        return getVersionsFieldBuilder().getBuilder(index);
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder getVersionsOrBuilder(
          int index) {
        if (versionsBuilder_ == null) {
          return versions_.get(index);  } else {
          return versionsBuilder_.getMessageOrBuilder(index);
        }
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public java.util.List<? extends org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder> 
           getVersionsOrBuilderList() {
        if (versionsBuilder_ != null) {
          return versionsBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(versions_);
        }
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder addVersionsBuilder() {
        return getVersionsFieldBuilder().addBuilder(
            org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.getDefaultInstance());
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder addVersionsBuilder(
          int index) {
        return getVersionsFieldBuilder().addBuilder(
            index, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.getDefaultInstance());
      }
      /**
       * <code>repeated .VectorClock.Version versions = 2;</code>
       */
      public java.util.List<org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder> 
           getVersionsBuilderList() {
        return getVersionsFieldBuilder().getBuilderList();
      }
      private org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder> 
          getVersionsFieldBuilder() {
        if (versionsBuilder_ == null) {
          versionsBuilder_ = new org.apache.pekko.protobufv3.internal.RepeatedFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.Version.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock.VersionOrBuilder>(
                  versions_,
                  ((bitField0_ & 0x00000002) != 0),
                  getParentForChildren(),
                  isClean());
          versions_ = null;
        }
        return versionsBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:VectorClock)
    }

    // @@protoc_insertion_point(class_scope:VectorClock)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<VectorClock>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<VectorClock>() {
      @java.lang.Override
      public VectorClock parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new VectorClock(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<VectorClock> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<VectorClock> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.VectorClock getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface EmptyOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Empty)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {
  }
  /**
   * <pre>
   **
   * An empty message
   * </pre>
   *
   * Protobuf type {@code Empty}
   */
  public  static final class Empty extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Empty)
      EmptyOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Empty.newBuilder() to construct.
    private Empty(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Empty() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new Empty();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Empty(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Empty_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Empty_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty.Builder.class);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty) obj;

      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * An empty message
     * </pre>
     *
     * Protobuf type {@code Empty}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Empty)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.EmptyOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Empty_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Empty_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Empty_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty(this);
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty.getDefaultInstance()) return this;
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Empty)
    }

    // @@protoc_insertion_point(class_scope:Empty)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Empty>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Empty>() {
      @java.lang.Override
      public Empty parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new Empty(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<Empty> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<Empty> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Empty getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface AddressOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Address)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required string system = 1;</code>
     * @return Whether the system field is set.
     */
    boolean hasSystem();
    /**
     * <code>required string system = 1;</code>
     * @return The system.
     */
    java.lang.String getSystem();
    /**
     * <code>required string system = 1;</code>
     * @return The bytes for system.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getSystemBytes();

    /**
     * <code>required string hostname = 2;</code>
     * @return Whether the hostname field is set.
     */
    boolean hasHostname();
    /**
     * <code>required string hostname = 2;</code>
     * @return The hostname.
     */
    java.lang.String getHostname();
    /**
     * <code>required string hostname = 2;</code>
     * @return The bytes for hostname.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getHostnameBytes();

    /**
     * <code>required uint32 port = 3;</code>
     * @return Whether the port field is set.
     */
    boolean hasPort();
    /**
     * <code>required uint32 port = 3;</code>
     * @return The port.
     */
    int getPort();

    /**
     * <code>optional string protocol = 4;</code>
     * @return Whether the protocol field is set.
     */
    boolean hasProtocol();
    /**
     * <code>optional string protocol = 4;</code>
     * @return The protocol.
     */
    java.lang.String getProtocol();
    /**
     * <code>optional string protocol = 4;</code>
     * @return The bytes for protocol.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getProtocolBytes();
  }
  /**
   * <pre>
   **
   * Defines a remote address.
   * </pre>
   *
   * Protobuf type {@code Address}
   */
  public  static final class Address extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Address)
      AddressOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Address.newBuilder() to construct.
    private Address(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Address() {
      system_ = "";
      hostname_ = "";
      protocol_ = "";
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new Address();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Address(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000001;
              system_ = bs;
              break;
            }
            case 18: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000002;
              hostname_ = bs;
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              port_ = input.readUInt32();
              break;
            }
            case 34: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000008;
              protocol_ = bs;
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Address_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Address_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder.class);
    }

    private int bitField0_;
    public static final int SYSTEM_FIELD_NUMBER = 1;
    private volatile java.lang.Object system_;
    /**
     * <code>required string system = 1;</code>
     * @return Whether the system field is set.
     */
    public boolean hasSystem() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required string system = 1;</code>
     * @return The system.
     */
    public java.lang.String getSystem() {
      java.lang.Object ref = system_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.pekko.protobufv3.internal.ByteString bs = 
            (org.apache.pekko.protobufv3.internal.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          system_ = s;
        }
        return s;
      }
    }
    /**
     * <code>required string system = 1;</code>
     * @return The bytes for system.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getSystemBytes() {
      java.lang.Object ref = system_;
      if (ref instanceof java.lang.String) {
        org.apache.pekko.protobufv3.internal.ByteString b = 
            org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        system_ = b;
        return b;
      } else {
        return (org.apache.pekko.protobufv3.internal.ByteString) ref;
      }
    }

    public static final int HOSTNAME_FIELD_NUMBER = 2;
    private volatile java.lang.Object hostname_;
    /**
     * <code>required string hostname = 2;</code>
     * @return Whether the hostname field is set.
     */
    public boolean hasHostname() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required string hostname = 2;</code>
     * @return The hostname.
     */
    public java.lang.String getHostname() {
      java.lang.Object ref = hostname_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.pekko.protobufv3.internal.ByteString bs = 
            (org.apache.pekko.protobufv3.internal.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          hostname_ = s;
        }
        return s;
      }
    }
    /**
     * <code>required string hostname = 2;</code>
     * @return The bytes for hostname.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getHostnameBytes() {
      java.lang.Object ref = hostname_;
      if (ref instanceof java.lang.String) {
        org.apache.pekko.protobufv3.internal.ByteString b = 
            org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        hostname_ = b;
        return b;
      } else {
        return (org.apache.pekko.protobufv3.internal.ByteString) ref;
      }
    }

    public static final int PORT_FIELD_NUMBER = 3;
    private int port_;
    /**
     * <code>required uint32 port = 3;</code>
     * @return Whether the port field is set.
     */
    public boolean hasPort() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <code>required uint32 port = 3;</code>
     * @return The port.
     */
    public int getPort() {
      return port_;
    }

    public static final int PROTOCOL_FIELD_NUMBER = 4;
    private volatile java.lang.Object protocol_;
    /**
     * <code>optional string protocol = 4;</code>
     * @return Whether the protocol field is set.
     */
    public boolean hasProtocol() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <code>optional string protocol = 4;</code>
     * @return The protocol.
     */
    public java.lang.String getProtocol() {
      java.lang.Object ref = protocol_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.pekko.protobufv3.internal.ByteString bs = 
            (org.apache.pekko.protobufv3.internal.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          protocol_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string protocol = 4;</code>
     * @return The bytes for protocol.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getProtocolBytes() {
      java.lang.Object ref = protocol_;
      if (ref instanceof java.lang.String) {
        org.apache.pekko.protobufv3.internal.ByteString b = 
            org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        protocol_ = b;
        return b;
      } else {
        return (org.apache.pekko.protobufv3.internal.ByteString) ref;
      }
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasSystem()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasHostname()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasPort()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 1, system_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 2, hostname_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeUInt32(3, port_);
      }
      if (((bitField0_ & 0x00000008) != 0)) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 4, protocol_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.GeneratedMessageV3.computeStringSize(1, system_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.GeneratedMessageV3.computeStringSize(2, hostname_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeUInt32Size(3, port_);
      }
      if (((bitField0_ & 0x00000008) != 0)) {
        size += org.apache.pekko.protobufv3.internal.GeneratedMessageV3.computeStringSize(4, protocol_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address) obj;

      if (hasSystem() != other.hasSystem()) return false;
      if (hasSystem()) {
        if (!getSystem()
            .equals(other.getSystem())) return false;
      }
      if (hasHostname() != other.hasHostname()) return false;
      if (hasHostname()) {
        if (!getHostname()
            .equals(other.getHostname())) return false;
      }
      if (hasPort() != other.hasPort()) return false;
      if (hasPort()) {
        if (getPort()
            != other.getPort()) return false;
      }
      if (hasProtocol() != other.hasProtocol()) return false;
      if (hasProtocol()) {
        if (!getProtocol()
            .equals(other.getProtocol())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasSystem()) {
        hash = (37 * hash) + SYSTEM_FIELD_NUMBER;
        hash = (53 * hash) + getSystem().hashCode();
      }
      if (hasHostname()) {
        hash = (37 * hash) + HOSTNAME_FIELD_NUMBER;
        hash = (53 * hash) + getHostname().hashCode();
      }
      if (hasPort()) {
        hash = (37 * hash) + PORT_FIELD_NUMBER;
        hash = (53 * hash) + getPort();
      }
      if (hasProtocol()) {
        hash = (37 * hash) + PROTOCOL_FIELD_NUMBER;
        hash = (53 * hash) + getProtocol().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Defines a remote address.
     * </pre>
     *
     * Protobuf type {@code Address}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Address)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Address_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Address_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        system_ = "";
        bitField0_ = (bitField0_ & ~0x00000001);
        hostname_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        port_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        protocol_ = "";
        bitField0_ = (bitField0_ & ~0x00000008);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Address_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          to_bitField0_ |= 0x00000001;
        }
        result.system_ = system_;
        if (((from_bitField0_ & 0x00000002) != 0)) {
          to_bitField0_ |= 0x00000002;
        }
        result.hostname_ = hostname_;
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.port_ = port_;
          to_bitField0_ |= 0x00000004;
        }
        if (((from_bitField0_ & 0x00000008) != 0)) {
          to_bitField0_ |= 0x00000008;
        }
        result.protocol_ = protocol_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance()) return this;
        if (other.hasSystem()) {
          bitField0_ |= 0x00000001;
          system_ = other.system_;
          onChanged();
        }
        if (other.hasHostname()) {
          bitField0_ |= 0x00000002;
          hostname_ = other.hostname_;
          onChanged();
        }
        if (other.hasPort()) {
          setPort(other.getPort());
        }
        if (other.hasProtocol()) {
          bitField0_ |= 0x00000008;
          protocol_ = other.protocol_;
          onChanged();
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasSystem()) {
          return false;
        }
        if (!hasHostname()) {
          return false;
        }
        if (!hasPort()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private java.lang.Object system_ = "";
      /**
       * <code>required string system = 1;</code>
       * @return Whether the system field is set.
       */
      public boolean hasSystem() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required string system = 1;</code>
       * @return The system.
       */
      public java.lang.String getSystem() {
        java.lang.Object ref = system_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.pekko.protobufv3.internal.ByteString bs =
              (org.apache.pekko.protobufv3.internal.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            system_ = s;
          }
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>required string system = 1;</code>
       * @return The bytes for system.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getSystemBytes() {
        java.lang.Object ref = system_;
        if (ref instanceof String) {
          org.apache.pekko.protobufv3.internal.ByteString b = 
              org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          system_ = b;
          return b;
        } else {
          return (org.apache.pekko.protobufv3.internal.ByteString) ref;
        }
      }
      /**
       * <code>required string system = 1;</code>
       * @param value The system to set.
       * @return This builder for chaining.
       */
      public Builder setSystem(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        system_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required string system = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearSystem() {
        bitField0_ = (bitField0_ & ~0x00000001);
        system_ = getDefaultInstance().getSystem();
        onChanged();
        return this;
      }
      /**
       * <code>required string system = 1;</code>
       * @param value The bytes for system to set.
       * @return This builder for chaining.
       */
      public Builder setSystemBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000001;
        system_ = value;
        onChanged();
        return this;
      }

      private java.lang.Object hostname_ = "";
      /**
       * <code>required string hostname = 2;</code>
       * @return Whether the hostname field is set.
       */
      public boolean hasHostname() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required string hostname = 2;</code>
       * @return The hostname.
       */
      public java.lang.String getHostname() {
        java.lang.Object ref = hostname_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.pekko.protobufv3.internal.ByteString bs =
              (org.apache.pekko.protobufv3.internal.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            hostname_ = s;
          }
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>required string hostname = 2;</code>
       * @return The bytes for hostname.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getHostnameBytes() {
        java.lang.Object ref = hostname_;
        if (ref instanceof String) {
          org.apache.pekko.protobufv3.internal.ByteString b = 
              org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          hostname_ = b;
          return b;
        } else {
          return (org.apache.pekko.protobufv3.internal.ByteString) ref;
        }
      }
      /**
       * <code>required string hostname = 2;</code>
       * @param value The hostname to set.
       * @return This builder for chaining.
       */
      public Builder setHostname(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        hostname_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required string hostname = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearHostname() {
        bitField0_ = (bitField0_ & ~0x00000002);
        hostname_ = getDefaultInstance().getHostname();
        onChanged();
        return this;
      }
      /**
       * <code>required string hostname = 2;</code>
       * @param value The bytes for hostname to set.
       * @return This builder for chaining.
       */
      public Builder setHostnameBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        hostname_ = value;
        onChanged();
        return this;
      }

      private int port_ ;
      /**
       * <code>required uint32 port = 3;</code>
       * @return Whether the port field is set.
       */
      public boolean hasPort() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>required uint32 port = 3;</code>
       * @return The port.
       */
      public int getPort() {
        return port_;
      }
      /**
       * <code>required uint32 port = 3;</code>
       * @param value The port to set.
       * @return This builder for chaining.
       */
      public Builder setPort(int value) {
        bitField0_ |= 0x00000004;
        port_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required uint32 port = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearPort() {
        bitField0_ = (bitField0_ & ~0x00000004);
        port_ = 0;
        onChanged();
        return this;
      }

      private java.lang.Object protocol_ = "";
      /**
       * <code>optional string protocol = 4;</code>
       * @return Whether the protocol field is set.
       */
      public boolean hasProtocol() {
        return ((bitField0_ & 0x00000008) != 0);
      }
      /**
       * <code>optional string protocol = 4;</code>
       * @return The protocol.
       */
      public java.lang.String getProtocol() {
        java.lang.Object ref = protocol_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.pekko.protobufv3.internal.ByteString bs =
              (org.apache.pekko.protobufv3.internal.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            protocol_ = s;
          }
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string protocol = 4;</code>
       * @return The bytes for protocol.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getProtocolBytes() {
        java.lang.Object ref = protocol_;
        if (ref instanceof String) {
          org.apache.pekko.protobufv3.internal.ByteString b = 
              org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          protocol_ = b;
          return b;
        } else {
          return (org.apache.pekko.protobufv3.internal.ByteString) ref;
        }
      }
      /**
       * <code>optional string protocol = 4;</code>
       * @param value The protocol to set.
       * @return This builder for chaining.
       */
      public Builder setProtocol(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        protocol_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string protocol = 4;</code>
       * @return This builder for chaining.
       */
      public Builder clearProtocol() {
        bitField0_ = (bitField0_ & ~0x00000008);
        protocol_ = getDefaultInstance().getProtocol();
        onChanged();
        return this;
      }
      /**
       * <code>optional string protocol = 4;</code>
       * @param value The bytes for protocol to set.
       * @return This builder for chaining.
       */
      public Builder setProtocolBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        protocol_ = value;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Address)
    }

    // @@protoc_insertion_point(class_scope:Address)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Address>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Address>() {
      @java.lang.Override
      public Address parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new Address(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<Address> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<Address> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface UniqueAddressOrBuilder extends
      // @@protoc_insertion_point(interface_extends:UniqueAddress)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .Address address = 1;</code>
     * @return Whether the address field is set.
     */
    boolean hasAddress();
    /**
     * <code>required .Address address = 1;</code>
     * @return The address.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getAddress();
    /**
     * <code>required .Address address = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder getAddressOrBuilder();

    /**
     * <code>required uint32 uid = 2;</code>
     * @return Whether the uid field is set.
     */
    boolean hasUid();
    /**
     * <code>required uint32 uid = 2;</code>
     * @return The uid.
     */
    int getUid();

    /**
     * <pre>
     * 64 bit uids but with backward wire compatibility
     * </pre>
     *
     * <code>optional uint32 uid2 = 3;</code>
     * @return Whether the uid2 field is set.
     */
    boolean hasUid2();
    /**
     * <pre>
     * 64 bit uids but with backward wire compatibility
     * </pre>
     *
     * <code>optional uint32 uid2 = 3;</code>
     * @return The uid2.
     */
    int getUid2();
  }
  /**
   * <pre>
   **
   * Defines a remote address with uid.
   * </pre>
   *
   * Protobuf type {@code UniqueAddress}
   */
  public  static final class UniqueAddress extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:UniqueAddress)
      UniqueAddressOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use UniqueAddress.newBuilder() to construct.
    private UniqueAddress(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private UniqueAddress() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new UniqueAddress();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private UniqueAddress(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = address_.toBuilder();
              }
              address_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(address_);
                address_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              uid_ = input.readUInt32();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              uid2_ = input.readUInt32();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_UniqueAddress_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_UniqueAddress_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder.class);
    }

    private int bitField0_;
    public static final int ADDRESS_FIELD_NUMBER = 1;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address address_;
    /**
     * <code>required .Address address = 1;</code>
     * @return Whether the address field is set.
     */
    public boolean hasAddress() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .Address address = 1;</code>
     * @return The address.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getAddress() {
      return address_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : address_;
    }
    /**
     * <code>required .Address address = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder getAddressOrBuilder() {
      return address_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : address_;
    }

    public static final int UID_FIELD_NUMBER = 2;
    private int uid_;
    /**
     * <code>required uint32 uid = 2;</code>
     * @return Whether the uid field is set.
     */
    public boolean hasUid() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required uint32 uid = 2;</code>
     * @return The uid.
     */
    public int getUid() {
      return uid_;
    }

    public static final int UID2_FIELD_NUMBER = 3;
    private int uid2_;
    /**
     * <pre>
     * 64 bit uids but with backward wire compatibility
     * </pre>
     *
     * <code>optional uint32 uid2 = 3;</code>
     * @return Whether the uid2 field is set.
     */
    public boolean hasUid2() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * 64 bit uids but with backward wire compatibility
     * </pre>
     *
     * <code>optional uint32 uid2 = 3;</code>
     * @return The uid2.
     */
    public int getUid2() {
      return uid2_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasAddress()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasUid()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getAddress().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(1, getAddress());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeUInt32(2, uid_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeUInt32(3, uid2_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, getAddress());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeUInt32Size(2, uid_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeUInt32Size(3, uid2_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress) obj;

      if (hasAddress() != other.hasAddress()) return false;
      if (hasAddress()) {
        if (!getAddress()
            .equals(other.getAddress())) return false;
      }
      if (hasUid() != other.hasUid()) return false;
      if (hasUid()) {
        if (getUid()
            != other.getUid()) return false;
      }
      if (hasUid2() != other.hasUid2()) return false;
      if (hasUid2()) {
        if (getUid2()
            != other.getUid2()) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasAddress()) {
        hash = (37 * hash) + ADDRESS_FIELD_NUMBER;
        hash = (53 * hash) + getAddress().hashCode();
      }
      if (hasUid()) {
        hash = (37 * hash) + UID_FIELD_NUMBER;
        hash = (53 * hash) + getUid();
      }
      if (hasUid2()) {
        hash = (37 * hash) + UID2_FIELD_NUMBER;
        hash = (53 * hash) + getUid2();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     **
     * Defines a remote address with uid.
     * </pre>
     *
     * Protobuf type {@code UniqueAddress}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:UniqueAddress)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddressOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_UniqueAddress_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_UniqueAddress_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getAddressFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (addressBuilder_ == null) {
          address_ = null;
        } else {
          addressBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        uid_ = 0;
        bitField0_ = (bitField0_ & ~0x00000002);
        uid2_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_UniqueAddress_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          if (addressBuilder_ == null) {
            result.address_ = address_;
          } else {
            result.address_ = addressBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.uid_ = uid_;
          to_bitField0_ |= 0x00000002;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.uid2_ = uid2_;
          to_bitField0_ |= 0x00000004;
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress.getDefaultInstance()) return this;
        if (other.hasAddress()) {
          mergeAddress(other.getAddress());
        }
        if (other.hasUid()) {
          setUid(other.getUid());
        }
        if (other.hasUid2()) {
          setUid2(other.getUid2());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasAddress()) {
          return false;
        }
        if (!hasUid()) {
          return false;
        }
        if (!getAddress().isInitialized()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address address_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder> addressBuilder_;
      /**
       * <code>required .Address address = 1;</code>
       * @return Whether the address field is set.
       */
      public boolean hasAddress() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .Address address = 1;</code>
       * @return The address.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address getAddress() {
        if (addressBuilder_ == null) {
          return address_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : address_;
        } else {
          return addressBuilder_.getMessage();
        }
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public Builder setAddress(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address value) {
        if (addressBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          address_ = value;
          onChanged();
        } else {
          addressBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public Builder setAddress(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder builderForValue) {
        if (addressBuilder_ == null) {
          address_ = builderForValue.build();
          onChanged();
        } else {
          addressBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public Builder mergeAddress(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address value) {
        if (addressBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0) &&
              address_ != null &&
              address_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance()) {
            address_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.newBuilder(address_).mergeFrom(value).buildPartial();
          } else {
            address_ = value;
          }
          onChanged();
        } else {
          addressBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public Builder clearAddress() {
        if (addressBuilder_ == null) {
          address_ = null;
          onChanged();
        } else {
          addressBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder getAddressBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getAddressFieldBuilder().getBuilder();
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder getAddressOrBuilder() {
        if (addressBuilder_ != null) {
          return addressBuilder_.getMessageOrBuilder();
        } else {
          return address_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.getDefaultInstance() : address_;
        }
      }
      /**
       * <code>required .Address address = 1;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder> 
          getAddressFieldBuilder() {
        if (addressBuilder_ == null) {
          addressBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Address.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.AddressOrBuilder>(
                  getAddress(),
                  getParentForChildren(),
                  isClean());
          address_ = null;
        }
        return addressBuilder_;
      }

      private int uid_ ;
      /**
       * <code>required uint32 uid = 2;</code>
       * @return Whether the uid field is set.
       */
      public boolean hasUid() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required uint32 uid = 2;</code>
       * @return The uid.
       */
      public int getUid() {
        return uid_;
      }
      /**
       * <code>required uint32 uid = 2;</code>
       * @param value The uid to set.
       * @return This builder for chaining.
       */
      public Builder setUid(int value) {
        bitField0_ |= 0x00000002;
        uid_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required uint32 uid = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearUid() {
        bitField0_ = (bitField0_ & ~0x00000002);
        uid_ = 0;
        onChanged();
        return this;
      }

      private int uid2_ ;
      /**
       * <pre>
       * 64 bit uids but with backward wire compatibility
       * </pre>
       *
       * <code>optional uint32 uid2 = 3;</code>
       * @return Whether the uid2 field is set.
       */
      public boolean hasUid2() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <pre>
       * 64 bit uids but with backward wire compatibility
       * </pre>
       *
       * <code>optional uint32 uid2 = 3;</code>
       * @return The uid2.
       */
      public int getUid2() {
        return uid2_;
      }
      /**
       * <pre>
       * 64 bit uids but with backward wire compatibility
       * </pre>
       *
       * <code>optional uint32 uid2 = 3;</code>
       * @param value The uid2 to set.
       * @return This builder for chaining.
       */
      public Builder setUid2(int value) {
        bitField0_ |= 0x00000004;
        uid2_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * 64 bit uids but with backward wire compatibility
       * </pre>
       *
       * <code>optional uint32 uid2 = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearUid2() {
        bitField0_ = (bitField0_ & ~0x00000004);
        uid2_ = 0;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:UniqueAddress)
    }

    // @@protoc_insertion_point(class_scope:UniqueAddress)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<UniqueAddress>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<UniqueAddress>() {
      @java.lang.Override
      public UniqueAddress parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new UniqueAddress(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<UniqueAddress> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<UniqueAddress> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.UniqueAddress getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ClusterRouterPoolOrBuilder extends
      // @@protoc_insertion_point(interface_extends:ClusterRouterPool)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required .Pool pool = 1;</code>
     * @return Whether the pool field is set.
     */
    boolean hasPool();
    /**
     * <code>required .Pool pool = 1;</code>
     * @return The pool.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool getPool();
    /**
     * <code>required .Pool pool = 1;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.PoolOrBuilder getPoolOrBuilder();

    /**
     * <code>required .ClusterRouterPoolSettings settings = 2;</code>
     * @return Whether the settings field is set.
     */
    boolean hasSettings();
    /**
     * <code>required .ClusterRouterPoolSettings settings = 2;</code>
     * @return The settings.
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings getSettings();
    /**
     * <code>required .ClusterRouterPoolSettings settings = 2;</code>
     */
    org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettingsOrBuilder getSettingsOrBuilder();
  }
  /**
   * Protobuf type {@code ClusterRouterPool}
   */
  public  static final class ClusterRouterPool extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:ClusterRouterPool)
      ClusterRouterPoolOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ClusterRouterPool.newBuilder() to construct.
    private ClusterRouterPool(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ClusterRouterPool() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new ClusterRouterPool();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private ClusterRouterPool(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.Builder subBuilder = null;
              if (((bitField0_ & 0x00000001) != 0)) {
                subBuilder = pool_.toBuilder();
              }
              pool_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(pool_);
                pool_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000001;
              break;
            }
            case 18: {
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.Builder subBuilder = null;
              if (((bitField0_ & 0x00000002) != 0)) {
                subBuilder = settings_.toBuilder();
              }
              settings_ = input.readMessage(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.PARSER, extensionRegistry);
              if (subBuilder != null) {
                subBuilder.mergeFrom(settings_);
                settings_ = subBuilder.buildPartial();
              }
              bitField0_ |= 0x00000002;
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPool_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPool_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool.Builder.class);
    }

    private int bitField0_;
    public static final int POOL_FIELD_NUMBER = 1;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool pool_;
    /**
     * <code>required .Pool pool = 1;</code>
     * @return Whether the pool field is set.
     */
    public boolean hasPool() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required .Pool pool = 1;</code>
     * @return The pool.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool getPool() {
      return pool_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.getDefaultInstance() : pool_;
    }
    /**
     * <code>required .Pool pool = 1;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.PoolOrBuilder getPoolOrBuilder() {
      return pool_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.getDefaultInstance() : pool_;
    }

    public static final int SETTINGS_FIELD_NUMBER = 2;
    private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings settings_;
    /**
     * <code>required .ClusterRouterPoolSettings settings = 2;</code>
     * @return Whether the settings field is set.
     */
    public boolean hasSettings() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required .ClusterRouterPoolSettings settings = 2;</code>
     * @return The settings.
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings getSettings() {
      return settings_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.getDefaultInstance() : settings_;
    }
    /**
     * <code>required .ClusterRouterPoolSettings settings = 2;</code>
     */
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettingsOrBuilder getSettingsOrBuilder() {
      return settings_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.getDefaultInstance() : settings_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasPool()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasSettings()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getPool().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!getSettings().isInitialized()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeMessage(1, getPool());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeMessage(2, getSettings());
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(1, getPool());
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeMessageSize(2, getSettings());
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool) obj;

      if (hasPool() != other.hasPool()) return false;
      if (hasPool()) {
        if (!getPool()
            .equals(other.getPool())) return false;
      }
      if (hasSettings() != other.hasSettings()) return false;
      if (hasSettings()) {
        if (!getSettings()
            .equals(other.getSettings())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasPool()) {
        hash = (37 * hash) + POOL_FIELD_NUMBER;
        hash = (53 * hash) + getPool().hashCode();
      }
      if (hasSettings()) {
        hash = (37 * hash) + SETTINGS_FIELD_NUMBER;
        hash = (53 * hash) + getSettings().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code ClusterRouterPool}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:ClusterRouterPool)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPool_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPool_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
          getPoolFieldBuilder();
          getSettingsFieldBuilder();
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        if (poolBuilder_ == null) {
          pool_ = null;
        } else {
          poolBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        if (settingsBuilder_ == null) {
          settings_ = null;
        } else {
          settingsBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPool_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          if (poolBuilder_ == null) {
            result.pool_ = pool_;
          } else {
            result.pool_ = poolBuilder_.build();
          }
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          if (settingsBuilder_ == null) {
            result.settings_ = settings_;
          } else {
            result.settings_ = settingsBuilder_.build();
          }
          to_bitField0_ |= 0x00000002;
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool.getDefaultInstance()) return this;
        if (other.hasPool()) {
          mergePool(other.getPool());
        }
        if (other.hasSettings()) {
          mergeSettings(other.getSettings());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasPool()) {
          return false;
        }
        if (!hasSettings()) {
          return false;
        }
        if (!getPool().isInitialized()) {
          return false;
        }
        if (!getSettings().isInitialized()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool pool_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.PoolOrBuilder> poolBuilder_;
      /**
       * <code>required .Pool pool = 1;</code>
       * @return Whether the pool field is set.
       */
      public boolean hasPool() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required .Pool pool = 1;</code>
       * @return The pool.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool getPool() {
        if (poolBuilder_ == null) {
          return pool_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.getDefaultInstance() : pool_;
        } else {
          return poolBuilder_.getMessage();
        }
      }
      /**
       * <code>required .Pool pool = 1;</code>
       */
      public Builder setPool(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool value) {
        if (poolBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          pool_ = value;
          onChanged();
        } else {
          poolBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Pool pool = 1;</code>
       */
      public Builder setPool(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.Builder builderForValue) {
        if (poolBuilder_ == null) {
          pool_ = builderForValue.build();
          onChanged();
        } else {
          poolBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Pool pool = 1;</code>
       */
      public Builder mergePool(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool value) {
        if (poolBuilder_ == null) {
          if (((bitField0_ & 0x00000001) != 0) &&
              pool_ != null &&
              pool_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.getDefaultInstance()) {
            pool_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.newBuilder(pool_).mergeFrom(value).buildPartial();
          } else {
            pool_ = value;
          }
          onChanged();
        } else {
          poolBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000001;
        return this;
      }
      /**
       * <code>required .Pool pool = 1;</code>
       */
      public Builder clearPool() {
        if (poolBuilder_ == null) {
          pool_ = null;
          onChanged();
        } else {
          poolBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000001);
        return this;
      }
      /**
       * <code>required .Pool pool = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.Builder getPoolBuilder() {
        bitField0_ |= 0x00000001;
        onChanged();
        return getPoolFieldBuilder().getBuilder();
      }
      /**
       * <code>required .Pool pool = 1;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.PoolOrBuilder getPoolOrBuilder() {
        if (poolBuilder_ != null) {
          return poolBuilder_.getMessageOrBuilder();
        } else {
          return pool_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.getDefaultInstance() : pool_;
        }
      }
      /**
       * <code>required .Pool pool = 1;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.PoolOrBuilder> 
          getPoolFieldBuilder() {
        if (poolBuilder_ == null) {
          poolBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.PoolOrBuilder>(
                  getPool(),
                  getParentForChildren(),
                  isClean());
          pool_ = null;
        }
        return poolBuilder_;
      }

      private org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings settings_;
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettingsOrBuilder> settingsBuilder_;
      /**
       * <code>required .ClusterRouterPoolSettings settings = 2;</code>
       * @return Whether the settings field is set.
       */
      public boolean hasSettings() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required .ClusterRouterPoolSettings settings = 2;</code>
       * @return The settings.
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings getSettings() {
        if (settingsBuilder_ == null) {
          return settings_ == null ? org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.getDefaultInstance() : settings_;
        } else {
          return settingsBuilder_.getMessage();
        }
      }
      /**
       * <code>required .ClusterRouterPoolSettings settings = 2;</code>
       */
      public Builder setSettings(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings value) {
        if (settingsBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          settings_ = value;
          onChanged();
        } else {
          settingsBuilder_.setMessage(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .ClusterRouterPoolSettings settings = 2;</code>
       */
      public Builder setSettings(
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.Builder builderForValue) {
        if (settingsBuilder_ == null) {
          settings_ = builderForValue.build();
          onChanged();
        } else {
          settingsBuilder_.setMessage(builderForValue.build());
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .ClusterRouterPoolSettings settings = 2;</code>
       */
      public Builder mergeSettings(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings value) {
        if (settingsBuilder_ == null) {
          if (((bitField0_ & 0x00000002) != 0) &&
              settings_ != null &&
              settings_ != org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.getDefaultInstance()) {
            settings_ =
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.newBuilder(settings_).mergeFrom(value).buildPartial();
          } else {
            settings_ = value;
          }
          onChanged();
        } else {
          settingsBuilder_.mergeFrom(value);
        }
        bitField0_ |= 0x00000002;
        return this;
      }
      /**
       * <code>required .ClusterRouterPoolSettings settings = 2;</code>
       */
      public Builder clearSettings() {
        if (settingsBuilder_ == null) {
          settings_ = null;
          onChanged();
        } else {
          settingsBuilder_.clear();
        }
        bitField0_ = (bitField0_ & ~0x00000002);
        return this;
      }
      /**
       * <code>required .ClusterRouterPoolSettings settings = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.Builder getSettingsBuilder() {
        bitField0_ |= 0x00000002;
        onChanged();
        return getSettingsFieldBuilder().getBuilder();
      }
      /**
       * <code>required .ClusterRouterPoolSettings settings = 2;</code>
       */
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettingsOrBuilder getSettingsOrBuilder() {
        if (settingsBuilder_ != null) {
          return settingsBuilder_.getMessageOrBuilder();
        } else {
          return settings_ == null ?
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.getDefaultInstance() : settings_;
        }
      }
      /**
       * <code>required .ClusterRouterPoolSettings settings = 2;</code>
       */
      private org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
          org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettingsOrBuilder> 
          getSettingsFieldBuilder() {
        if (settingsBuilder_ == null) {
          settingsBuilder_ = new org.apache.pekko.protobufv3.internal.SingleFieldBuilderV3<
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.Builder, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettingsOrBuilder>(
                  getSettings(),
                  getParentForChildren(),
                  isClean());
          settings_ = null;
        }
        return settingsBuilder_;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:ClusterRouterPool)
    }

    // @@protoc_insertion_point(class_scope:ClusterRouterPool)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<ClusterRouterPool>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<ClusterRouterPool>() {
      @java.lang.Override
      public ClusterRouterPool parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new ClusterRouterPool(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<ClusterRouterPool> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<ClusterRouterPool> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPool getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface PoolOrBuilder extends
      // @@protoc_insertion_point(interface_extends:Pool)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required uint32 serializerId = 1;</code>
     * @return Whether the serializerId field is set.
     */
    boolean hasSerializerId();
    /**
     * <code>required uint32 serializerId = 1;</code>
     * @return The serializerId.
     */
    int getSerializerId();

    /**
     * <code>required string manifest = 2;</code>
     * @return Whether the manifest field is set.
     */
    boolean hasManifest();
    /**
     * <code>required string manifest = 2;</code>
     * @return The manifest.
     */
    java.lang.String getManifest();
    /**
     * <code>required string manifest = 2;</code>
     * @return The bytes for manifest.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getManifestBytes();

    /**
     * <code>required bytes data = 3;</code>
     * @return Whether the data field is set.
     */
    boolean hasData();
    /**
     * <code>required bytes data = 3;</code>
     * @return The data.
     */
    org.apache.pekko.protobufv3.internal.ByteString getData();
  }
  /**
   * Protobuf type {@code Pool}
   */
  public  static final class Pool extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:Pool)
      PoolOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Pool.newBuilder() to construct.
    private Pool(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Pool() {
      manifest_ = "";
      data_ = org.apache.pekko.protobufv3.internal.ByteString.EMPTY;
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new Pool();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Pool(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              bitField0_ |= 0x00000001;
              serializerId_ = input.readUInt32();
              break;
            }
            case 18: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000002;
              manifest_ = bs;
              break;
            }
            case 26: {
              bitField0_ |= 0x00000004;
              data_ = input.readBytes();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Pool_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Pool_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.Builder.class);
    }

    private int bitField0_;
    public static final int SERIALIZERID_FIELD_NUMBER = 1;
    private int serializerId_;
    /**
     * <code>required uint32 serializerId = 1;</code>
     * @return Whether the serializerId field is set.
     */
    public boolean hasSerializerId() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required uint32 serializerId = 1;</code>
     * @return The serializerId.
     */
    public int getSerializerId() {
      return serializerId_;
    }

    public static final int MANIFEST_FIELD_NUMBER = 2;
    private volatile java.lang.Object manifest_;
    /**
     * <code>required string manifest = 2;</code>
     * @return Whether the manifest field is set.
     */
    public boolean hasManifest() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required string manifest = 2;</code>
     * @return The manifest.
     */
    public java.lang.String getManifest() {
      java.lang.Object ref = manifest_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.pekko.protobufv3.internal.ByteString bs = 
            (org.apache.pekko.protobufv3.internal.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          manifest_ = s;
        }
        return s;
      }
    }
    /**
     * <code>required string manifest = 2;</code>
     * @return The bytes for manifest.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getManifestBytes() {
      java.lang.Object ref = manifest_;
      if (ref instanceof java.lang.String) {
        org.apache.pekko.protobufv3.internal.ByteString b = 
            org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        manifest_ = b;
        return b;
      } else {
        return (org.apache.pekko.protobufv3.internal.ByteString) ref;
      }
    }

    public static final int DATA_FIELD_NUMBER = 3;
    private org.apache.pekko.protobufv3.internal.ByteString data_;
    /**
     * <code>required bytes data = 3;</code>
     * @return Whether the data field is set.
     */
    public boolean hasData() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <code>required bytes data = 3;</code>
     * @return The data.
     */
    public org.apache.pekko.protobufv3.internal.ByteString getData() {
      return data_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasSerializerId()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasManifest()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasData()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeUInt32(1, serializerId_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 2, manifest_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeBytes(3, data_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeUInt32Size(1, serializerId_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.GeneratedMessageV3.computeStringSize(2, manifest_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeBytesSize(3, data_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool) obj;

      if (hasSerializerId() != other.hasSerializerId()) return false;
      if (hasSerializerId()) {
        if (getSerializerId()
            != other.getSerializerId()) return false;
      }
      if (hasManifest() != other.hasManifest()) return false;
      if (hasManifest()) {
        if (!getManifest()
            .equals(other.getManifest())) return false;
      }
      if (hasData() != other.hasData()) return false;
      if (hasData()) {
        if (!getData()
            .equals(other.getData())) return false;
      }
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasSerializerId()) {
        hash = (37 * hash) + SERIALIZERID_FIELD_NUMBER;
        hash = (53 * hash) + getSerializerId();
      }
      if (hasManifest()) {
        hash = (37 * hash) + MANIFEST_FIELD_NUMBER;
        hash = (53 * hash) + getManifest().hashCode();
      }
      if (hasData()) {
        hash = (37 * hash) + DATA_FIELD_NUMBER;
        hash = (53 * hash) + getData().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code Pool}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:Pool)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.PoolOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Pool_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Pool_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        serializerId_ = 0;
        bitField0_ = (bitField0_ & ~0x00000001);
        manifest_ = "";
        bitField0_ = (bitField0_ & ~0x00000002);
        data_ = org.apache.pekko.protobufv3.internal.ByteString.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000004);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_Pool_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.serializerId_ = serializerId_;
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          to_bitField0_ |= 0x00000002;
        }
        result.manifest_ = manifest_;
        if (((from_bitField0_ & 0x00000004) != 0)) {
          to_bitField0_ |= 0x00000004;
        }
        result.data_ = data_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool.getDefaultInstance()) return this;
        if (other.hasSerializerId()) {
          setSerializerId(other.getSerializerId());
        }
        if (other.hasManifest()) {
          bitField0_ |= 0x00000002;
          manifest_ = other.manifest_;
          onChanged();
        }
        if (other.hasData()) {
          setData(other.getData());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasSerializerId()) {
          return false;
        }
        if (!hasManifest()) {
          return false;
        }
        if (!hasData()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private int serializerId_ ;
      /**
       * <code>required uint32 serializerId = 1;</code>
       * @return Whether the serializerId field is set.
       */
      public boolean hasSerializerId() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required uint32 serializerId = 1;</code>
       * @return The serializerId.
       */
      public int getSerializerId() {
        return serializerId_;
      }
      /**
       * <code>required uint32 serializerId = 1;</code>
       * @param value The serializerId to set.
       * @return This builder for chaining.
       */
      public Builder setSerializerId(int value) {
        bitField0_ |= 0x00000001;
        serializerId_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required uint32 serializerId = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearSerializerId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        serializerId_ = 0;
        onChanged();
        return this;
      }

      private java.lang.Object manifest_ = "";
      /**
       * <code>required string manifest = 2;</code>
       * @return Whether the manifest field is set.
       */
      public boolean hasManifest() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required string manifest = 2;</code>
       * @return The manifest.
       */
      public java.lang.String getManifest() {
        java.lang.Object ref = manifest_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.pekko.protobufv3.internal.ByteString bs =
              (org.apache.pekko.protobufv3.internal.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            manifest_ = s;
          }
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>required string manifest = 2;</code>
       * @return The bytes for manifest.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getManifestBytes() {
        java.lang.Object ref = manifest_;
        if (ref instanceof String) {
          org.apache.pekko.protobufv3.internal.ByteString b = 
              org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          manifest_ = b;
          return b;
        } else {
          return (org.apache.pekko.protobufv3.internal.ByteString) ref;
        }
      }
      /**
       * <code>required string manifest = 2;</code>
       * @param value The manifest to set.
       * @return This builder for chaining.
       */
      public Builder setManifest(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        manifest_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required string manifest = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearManifest() {
        bitField0_ = (bitField0_ & ~0x00000002);
        manifest_ = getDefaultInstance().getManifest();
        onChanged();
        return this;
      }
      /**
       * <code>required string manifest = 2;</code>
       * @param value The bytes for manifest to set.
       * @return This builder for chaining.
       */
      public Builder setManifestBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000002;
        manifest_ = value;
        onChanged();
        return this;
      }

      private org.apache.pekko.protobufv3.internal.ByteString data_ = org.apache.pekko.protobufv3.internal.ByteString.EMPTY;
      /**
       * <code>required bytes data = 3;</code>
       * @return Whether the data field is set.
       */
      public boolean hasData() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>required bytes data = 3;</code>
       * @return The data.
       */
      public org.apache.pekko.protobufv3.internal.ByteString getData() {
        return data_;
      }
      /**
       * <code>required bytes data = 3;</code>
       * @param value The data to set.
       * @return This builder for chaining.
       */
      public Builder setData(org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000004;
        data_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required bytes data = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearData() {
        bitField0_ = (bitField0_ & ~0x00000004);
        data_ = getDefaultInstance().getData();
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:Pool)
    }

    // @@protoc_insertion_point(class_scope:Pool)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<Pool>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<Pool>() {
      @java.lang.Override
      public Pool parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new Pool(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<Pool> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<Pool> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.Pool getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  public interface ClusterRouterPoolSettingsOrBuilder extends
      // @@protoc_insertion_point(interface_extends:ClusterRouterPoolSettings)
      org.apache.pekko.protobufv3.internal.MessageOrBuilder {

    /**
     * <code>required uint32 totalInstances = 1;</code>
     * @return Whether the totalInstances field is set.
     */
    boolean hasTotalInstances();
    /**
     * <code>required uint32 totalInstances = 1;</code>
     * @return The totalInstances.
     */
    int getTotalInstances();

    /**
     * <code>required uint32 maxInstancesPerNode = 2;</code>
     * @return Whether the maxInstancesPerNode field is set.
     */
    boolean hasMaxInstancesPerNode();
    /**
     * <code>required uint32 maxInstancesPerNode = 2;</code>
     * @return The maxInstancesPerNode.
     */
    int getMaxInstancesPerNode();

    /**
     * <code>required bool allowLocalRoutees = 3;</code>
     * @return Whether the allowLocalRoutees field is set.
     */
    boolean hasAllowLocalRoutees();
    /**
     * <code>required bool allowLocalRoutees = 3;</code>
     * @return The allowLocalRoutees.
     */
    boolean getAllowLocalRoutees();

    /**
     * <code>optional string useRole = 4;</code>
     * @return Whether the useRole field is set.
     */
    boolean hasUseRole();
    /**
     * <code>optional string useRole = 4;</code>
     * @return The useRole.
     */
    java.lang.String getUseRole();
    /**
     * <code>optional string useRole = 4;</code>
     * @return The bytes for useRole.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getUseRoleBytes();

    /**
     * <code>repeated string useRoles = 5;</code>
     * @return A list containing the useRoles.
     */
    java.util.List<java.lang.String>
        getUseRolesList();
    /**
     * <code>repeated string useRoles = 5;</code>
     * @return The count of useRoles.
     */
    int getUseRolesCount();
    /**
     * <code>repeated string useRoles = 5;</code>
     * @param index The index of the element to return.
     * @return The useRoles at the given index.
     */
    java.lang.String getUseRoles(int index);
    /**
     * <code>repeated string useRoles = 5;</code>
     * @param index The index of the value to return.
     * @return The bytes of the useRoles at the given index.
     */
    org.apache.pekko.protobufv3.internal.ByteString
        getUseRolesBytes(int index);
  }
  /**
   * Protobuf type {@code ClusterRouterPoolSettings}
   */
  public  static final class ClusterRouterPoolSettings extends
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:ClusterRouterPoolSettings)
      ClusterRouterPoolSettingsOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use ClusterRouterPoolSettings.newBuilder() to construct.
    private ClusterRouterPoolSettings(org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private ClusterRouterPoolSettings() {
      useRole_ = "";
      useRoles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.UnusedPrivateParameter unused) {
      return new ClusterRouterPoolSettings();
    }

    @java.lang.Override
    public final org.apache.pekko.protobufv3.internal.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private ClusterRouterPoolSettings(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      int mutable_bitField0_ = 0;
      org.apache.pekko.protobufv3.internal.UnknownFieldSet.Builder unknownFields =
          org.apache.pekko.protobufv3.internal.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {
              bitField0_ |= 0x00000001;
              totalInstances_ = input.readUInt32();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              maxInstancesPerNode_ = input.readUInt32();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              allowLocalRoutees_ = input.readBool();
              break;
            }
            case 34: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              bitField0_ |= 0x00000008;
              useRole_ = bs;
              break;
            }
            case 42: {
              org.apache.pekko.protobufv3.internal.ByteString bs = input.readBytes();
              if (!((mutable_bitField0_ & 0x00000010) != 0)) {
                useRoles_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList();
                mutable_bitField0_ |= 0x00000010;
              }
              useRoles_.add(bs);
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        if (((mutable_bitField0_ & 0x00000010) != 0)) {
          useRoles_ = useRoles_.getUnmodifiableView();
        }
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
        getDescriptor() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPoolSettings_descriptor;
    }

    @java.lang.Override
    protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPoolSettings_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.Builder.class);
    }

    private int bitField0_;
    public static final int TOTALINSTANCES_FIELD_NUMBER = 1;
    private int totalInstances_;
    /**
     * <code>required uint32 totalInstances = 1;</code>
     * @return Whether the totalInstances field is set.
     */
    public boolean hasTotalInstances() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <code>required uint32 totalInstances = 1;</code>
     * @return The totalInstances.
     */
    public int getTotalInstances() {
      return totalInstances_;
    }

    public static final int MAXINSTANCESPERNODE_FIELD_NUMBER = 2;
    private int maxInstancesPerNode_;
    /**
     * <code>required uint32 maxInstancesPerNode = 2;</code>
     * @return Whether the maxInstancesPerNode field is set.
     */
    public boolean hasMaxInstancesPerNode() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <code>required uint32 maxInstancesPerNode = 2;</code>
     * @return The maxInstancesPerNode.
     */
    public int getMaxInstancesPerNode() {
      return maxInstancesPerNode_;
    }

    public static final int ALLOWLOCALROUTEES_FIELD_NUMBER = 3;
    private boolean allowLocalRoutees_;
    /**
     * <code>required bool allowLocalRoutees = 3;</code>
     * @return Whether the allowLocalRoutees field is set.
     */
    public boolean hasAllowLocalRoutees() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <code>required bool allowLocalRoutees = 3;</code>
     * @return The allowLocalRoutees.
     */
    public boolean getAllowLocalRoutees() {
      return allowLocalRoutees_;
    }

    public static final int USEROLE_FIELD_NUMBER = 4;
    private volatile java.lang.Object useRole_;
    /**
     * <code>optional string useRole = 4;</code>
     * @return Whether the useRole field is set.
     */
    public boolean hasUseRole() {
      return ((bitField0_ & 0x00000008) != 0);
    }
    /**
     * <code>optional string useRole = 4;</code>
     * @return The useRole.
     */
    public java.lang.String getUseRole() {
      java.lang.Object ref = useRole_;
      if (ref instanceof java.lang.String) {
        return (java.lang.String) ref;
      } else {
        org.apache.pekko.protobufv3.internal.ByteString bs = 
            (org.apache.pekko.protobufv3.internal.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        if (bs.isValidUtf8()) {
          useRole_ = s;
        }
        return s;
      }
    }
    /**
     * <code>optional string useRole = 4;</code>
     * @return The bytes for useRole.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getUseRoleBytes() {
      java.lang.Object ref = useRole_;
      if (ref instanceof java.lang.String) {
        org.apache.pekko.protobufv3.internal.ByteString b = 
            org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        useRole_ = b;
        return b;
      } else {
        return (org.apache.pekko.protobufv3.internal.ByteString) ref;
      }
    }

    public static final int USEROLES_FIELD_NUMBER = 5;
    private org.apache.pekko.protobufv3.internal.LazyStringList useRoles_;
    /**
     * <code>repeated string useRoles = 5;</code>
     * @return A list containing the useRoles.
     */
    public org.apache.pekko.protobufv3.internal.ProtocolStringList
        getUseRolesList() {
      return useRoles_;
    }
    /**
     * <code>repeated string useRoles = 5;</code>
     * @return The count of useRoles.
     */
    public int getUseRolesCount() {
      return useRoles_.size();
    }
    /**
     * <code>repeated string useRoles = 5;</code>
     * @param index The index of the element to return.
     * @return The useRoles at the given index.
     */
    public java.lang.String getUseRoles(int index) {
      return useRoles_.get(index);
    }
    /**
     * <code>repeated string useRoles = 5;</code>
     * @param index The index of the value to return.
     * @return The bytes of the useRoles at the given index.
     */
    public org.apache.pekko.protobufv3.internal.ByteString
        getUseRolesBytes(int index) {
      return useRoles_.getByteString(index);
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      if (!hasTotalInstances()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasMaxInstancesPerNode()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasAllowLocalRoutees()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(org.apache.pekko.protobufv3.internal.CodedOutputStream output)
                        throws java.io.IOException {
      if (((bitField0_ & 0x00000001) != 0)) {
        output.writeUInt32(1, totalInstances_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        output.writeUInt32(2, maxInstancesPerNode_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        output.writeBool(3, allowLocalRoutees_);
      }
      if (((bitField0_ & 0x00000008) != 0)) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 4, useRole_);
      }
      for (int i = 0; i < useRoles_.size(); i++) {
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.writeString(output, 5, useRoles_.getRaw(i));
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (((bitField0_ & 0x00000001) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeUInt32Size(1, totalInstances_);
      }
      if (((bitField0_ & 0x00000002) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeUInt32Size(2, maxInstancesPerNode_);
      }
      if (((bitField0_ & 0x00000004) != 0)) {
        size += org.apache.pekko.protobufv3.internal.CodedOutputStream
          .computeBoolSize(3, allowLocalRoutees_);
      }
      if (((bitField0_ & 0x00000008) != 0)) {
        size += org.apache.pekko.protobufv3.internal.GeneratedMessageV3.computeStringSize(4, useRole_);
      }
      {
        int dataSize = 0;
        for (int i = 0; i < useRoles_.size(); i++) {
          dataSize += computeStringSizeNoTag(useRoles_.getRaw(i));
        }
        size += dataSize;
        size += 1 * getUseRolesList().size();
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings)) {
        return super.equals(obj);
      }
      org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings other = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings) obj;

      if (hasTotalInstances() != other.hasTotalInstances()) return false;
      if (hasTotalInstances()) {
        if (getTotalInstances()
            != other.getTotalInstances()) return false;
      }
      if (hasMaxInstancesPerNode() != other.hasMaxInstancesPerNode()) return false;
      if (hasMaxInstancesPerNode()) {
        if (getMaxInstancesPerNode()
            != other.getMaxInstancesPerNode()) return false;
      }
      if (hasAllowLocalRoutees() != other.hasAllowLocalRoutees()) return false;
      if (hasAllowLocalRoutees()) {
        if (getAllowLocalRoutees()
            != other.getAllowLocalRoutees()) return false;
      }
      if (hasUseRole() != other.hasUseRole()) return false;
      if (hasUseRole()) {
        if (!getUseRole()
            .equals(other.getUseRole())) return false;
      }
      if (!getUseRolesList()
          .equals(other.getUseRolesList())) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      if (hasTotalInstances()) {
        hash = (37 * hash) + TOTALINSTANCES_FIELD_NUMBER;
        hash = (53 * hash) + getTotalInstances();
      }
      if (hasMaxInstancesPerNode()) {
        hash = (37 * hash) + MAXINSTANCESPERNODE_FIELD_NUMBER;
        hash = (53 * hash) + getMaxInstancesPerNode();
      }
      if (hasAllowLocalRoutees()) {
        hash = (37 * hash) + ALLOWLOCALROUTEES_FIELD_NUMBER;
        hash = (53 * hash) + org.apache.pekko.protobufv3.internal.Internal.hashBoolean(
            getAllowLocalRoutees());
      }
      if (hasUseRole()) {
        hash = (37 * hash) + USEROLE_FIELD_NUMBER;
        hash = (53 * hash) + getUseRole().hashCode();
      }
      if (getUseRolesCount() > 0) {
        hash = (37 * hash) + USEROLES_FIELD_NUMBER;
        hash = (53 * hash) + getUseRolesList().hashCode();
      }
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(
        java.nio.ByteBuffer data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(
        java.nio.ByteBuffer data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(
        org.apache.pekko.protobufv3.internal.ByteString data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(byte[] data)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(
        byte[] data,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseDelimitedFrom(
        java.io.InputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parseFrom(
        org.apache.pekko.protobufv3.internal.CodedInputStream input,
        org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return org.apache.pekko.protobufv3.internal.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * Protobuf type {@code ClusterRouterPoolSettings}
     */
    public static final class Builder extends
        org.apache.pekko.protobufv3.internal.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:ClusterRouterPoolSettings)
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettingsOrBuilder {
      public static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptor() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPoolSettings_descriptor;
      }

      @java.lang.Override
      protected org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPoolSettings_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.class, org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.Builder.class);
      }

      // Construct using org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          org.apache.pekko.protobufv3.internal.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (org.apache.pekko.protobufv3.internal.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        totalInstances_ = 0;
        bitField0_ = (bitField0_ & ~0x00000001);
        maxInstancesPerNode_ = 0;
        bitField0_ = (bitField0_ & ~0x00000002);
        allowLocalRoutees_ = false;
        bitField0_ = (bitField0_ & ~0x00000004);
        useRole_ = "";
        bitField0_ = (bitField0_ & ~0x00000008);
        useRoles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000010);
        return this;
      }

      @java.lang.Override
      public org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
          getDescriptorForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.internal_static_ClusterRouterPoolSettings_descriptor;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings getDefaultInstanceForType() {
        return org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.getDefaultInstance();
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings build() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings buildPartial() {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings result = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) != 0)) {
          result.totalInstances_ = totalInstances_;
          to_bitField0_ |= 0x00000001;
        }
        if (((from_bitField0_ & 0x00000002) != 0)) {
          result.maxInstancesPerNode_ = maxInstancesPerNode_;
          to_bitField0_ |= 0x00000002;
        }
        if (((from_bitField0_ & 0x00000004) != 0)) {
          result.allowLocalRoutees_ = allowLocalRoutees_;
          to_bitField0_ |= 0x00000004;
        }
        if (((from_bitField0_ & 0x00000008) != 0)) {
          to_bitField0_ |= 0x00000008;
        }
        result.useRole_ = useRole_;
        if (((bitField0_ & 0x00000010) != 0)) {
          useRoles_ = useRoles_.getUnmodifiableView();
          bitField0_ = (bitField0_ & ~0x00000010);
        }
        result.useRoles_ = useRoles_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          org.apache.pekko.protobufv3.internal.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          org.apache.pekko.protobufv3.internal.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(org.apache.pekko.protobufv3.internal.Message other) {
        if (other instanceof org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings) {
          return mergeFrom((org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings other) {
        if (other == org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings.getDefaultInstance()) return this;
        if (other.hasTotalInstances()) {
          setTotalInstances(other.getTotalInstances());
        }
        if (other.hasMaxInstancesPerNode()) {
          setMaxInstancesPerNode(other.getMaxInstancesPerNode());
        }
        if (other.hasAllowLocalRoutees()) {
          setAllowLocalRoutees(other.getAllowLocalRoutees());
        }
        if (other.hasUseRole()) {
          bitField0_ |= 0x00000008;
          useRole_ = other.useRole_;
          onChanged();
        }
        if (!other.useRoles_.isEmpty()) {
          if (useRoles_.isEmpty()) {
            useRoles_ = other.useRoles_;
            bitField0_ = (bitField0_ & ~0x00000010);
          } else {
            ensureUseRolesIsMutable();
            useRoles_.addAll(other.useRoles_);
          }
          onChanged();
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        if (!hasTotalInstances()) {
          return false;
        }
        if (!hasMaxInstancesPerNode()) {
          return false;
        }
        if (!hasAllowLocalRoutees()) {
          return false;
        }
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException e) {
          parsedMessage = (org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }
      private int bitField0_;

      private int totalInstances_ ;
      /**
       * <code>required uint32 totalInstances = 1;</code>
       * @return Whether the totalInstances field is set.
       */
      public boolean hasTotalInstances() {
        return ((bitField0_ & 0x00000001) != 0);
      }
      /**
       * <code>required uint32 totalInstances = 1;</code>
       * @return The totalInstances.
       */
      public int getTotalInstances() {
        return totalInstances_;
      }
      /**
       * <code>required uint32 totalInstances = 1;</code>
       * @param value The totalInstances to set.
       * @return This builder for chaining.
       */
      public Builder setTotalInstances(int value) {
        bitField0_ |= 0x00000001;
        totalInstances_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required uint32 totalInstances = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearTotalInstances() {
        bitField0_ = (bitField0_ & ~0x00000001);
        totalInstances_ = 0;
        onChanged();
        return this;
      }

      private int maxInstancesPerNode_ ;
      /**
       * <code>required uint32 maxInstancesPerNode = 2;</code>
       * @return Whether the maxInstancesPerNode field is set.
       */
      public boolean hasMaxInstancesPerNode() {
        return ((bitField0_ & 0x00000002) != 0);
      }
      /**
       * <code>required uint32 maxInstancesPerNode = 2;</code>
       * @return The maxInstancesPerNode.
       */
      public int getMaxInstancesPerNode() {
        return maxInstancesPerNode_;
      }
      /**
       * <code>required uint32 maxInstancesPerNode = 2;</code>
       * @param value The maxInstancesPerNode to set.
       * @return This builder for chaining.
       */
      public Builder setMaxInstancesPerNode(int value) {
        bitField0_ |= 0x00000002;
        maxInstancesPerNode_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required uint32 maxInstancesPerNode = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearMaxInstancesPerNode() {
        bitField0_ = (bitField0_ & ~0x00000002);
        maxInstancesPerNode_ = 0;
        onChanged();
        return this;
      }

      private boolean allowLocalRoutees_ ;
      /**
       * <code>required bool allowLocalRoutees = 3;</code>
       * @return Whether the allowLocalRoutees field is set.
       */
      public boolean hasAllowLocalRoutees() {
        return ((bitField0_ & 0x00000004) != 0);
      }
      /**
       * <code>required bool allowLocalRoutees = 3;</code>
       * @return The allowLocalRoutees.
       */
      public boolean getAllowLocalRoutees() {
        return allowLocalRoutees_;
      }
      /**
       * <code>required bool allowLocalRoutees = 3;</code>
       * @param value The allowLocalRoutees to set.
       * @return This builder for chaining.
       */
      public Builder setAllowLocalRoutees(boolean value) {
        bitField0_ |= 0x00000004;
        allowLocalRoutees_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>required bool allowLocalRoutees = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearAllowLocalRoutees() {
        bitField0_ = (bitField0_ & ~0x00000004);
        allowLocalRoutees_ = false;
        onChanged();
        return this;
      }

      private java.lang.Object useRole_ = "";
      /**
       * <code>optional string useRole = 4;</code>
       * @return Whether the useRole field is set.
       */
      public boolean hasUseRole() {
        return ((bitField0_ & 0x00000008) != 0);
      }
      /**
       * <code>optional string useRole = 4;</code>
       * @return The useRole.
       */
      public java.lang.String getUseRole() {
        java.lang.Object ref = useRole_;
        if (!(ref instanceof java.lang.String)) {
          org.apache.pekko.protobufv3.internal.ByteString bs =
              (org.apache.pekko.protobufv3.internal.ByteString) ref;
          java.lang.String s = bs.toStringUtf8();
          if (bs.isValidUtf8()) {
            useRole_ = s;
          }
          return s;
        } else {
          return (java.lang.String) ref;
        }
      }
      /**
       * <code>optional string useRole = 4;</code>
       * @return The bytes for useRole.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getUseRoleBytes() {
        java.lang.Object ref = useRole_;
        if (ref instanceof String) {
          org.apache.pekko.protobufv3.internal.ByteString b = 
              org.apache.pekko.protobufv3.internal.ByteString.copyFromUtf8(
                  (java.lang.String) ref);
          useRole_ = b;
          return b;
        } else {
          return (org.apache.pekko.protobufv3.internal.ByteString) ref;
        }
      }
      /**
       * <code>optional string useRole = 4;</code>
       * @param value The useRole to set.
       * @return This builder for chaining.
       */
      public Builder setUseRole(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        useRole_ = value;
        onChanged();
        return this;
      }
      /**
       * <code>optional string useRole = 4;</code>
       * @return This builder for chaining.
       */
      public Builder clearUseRole() {
        bitField0_ = (bitField0_ & ~0x00000008);
        useRole_ = getDefaultInstance().getUseRole();
        onChanged();
        return this;
      }
      /**
       * <code>optional string useRole = 4;</code>
       * @param value The bytes for useRole to set.
       * @return This builder for chaining.
       */
      public Builder setUseRoleBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  bitField0_ |= 0x00000008;
        useRole_ = value;
        onChanged();
        return this;
      }

      private org.apache.pekko.protobufv3.internal.LazyStringList useRoles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
      private void ensureUseRolesIsMutable() {
        if (!((bitField0_ & 0x00000010) != 0)) {
          useRoles_ = new org.apache.pekko.protobufv3.internal.LazyStringArrayList(useRoles_);
          bitField0_ |= 0x00000010;
         }
      }
      /**
       * <code>repeated string useRoles = 5;</code>
       * @return A list containing the useRoles.
       */
      public org.apache.pekko.protobufv3.internal.ProtocolStringList
          getUseRolesList() {
        return useRoles_.getUnmodifiableView();
      }
      /**
       * <code>repeated string useRoles = 5;</code>
       * @return The count of useRoles.
       */
      public int getUseRolesCount() {
        return useRoles_.size();
      }
      /**
       * <code>repeated string useRoles = 5;</code>
       * @param index The index of the element to return.
       * @return The useRoles at the given index.
       */
      public java.lang.String getUseRoles(int index) {
        return useRoles_.get(index);
      }
      /**
       * <code>repeated string useRoles = 5;</code>
       * @param index The index of the value to return.
       * @return The bytes of the useRoles at the given index.
       */
      public org.apache.pekko.protobufv3.internal.ByteString
          getUseRolesBytes(int index) {
        return useRoles_.getByteString(index);
      }
      /**
       * <code>repeated string useRoles = 5;</code>
       * @param index The index to set the value at.
       * @param value The useRoles to set.
       * @return This builder for chaining.
       */
      public Builder setUseRoles(
          int index, java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureUseRolesIsMutable();
        useRoles_.set(index, value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string useRoles = 5;</code>
       * @param value The useRoles to add.
       * @return This builder for chaining.
       */
      public Builder addUseRoles(
          java.lang.String value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureUseRolesIsMutable();
        useRoles_.add(value);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string useRoles = 5;</code>
       * @param values The useRoles to add.
       * @return This builder for chaining.
       */
      public Builder addAllUseRoles(
          java.lang.Iterable<java.lang.String> values) {
        ensureUseRolesIsMutable();
        org.apache.pekko.protobufv3.internal.AbstractMessageLite.Builder.addAll(
            values, useRoles_);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string useRoles = 5;</code>
       * @return This builder for chaining.
       */
      public Builder clearUseRoles() {
        useRoles_ = org.apache.pekko.protobufv3.internal.LazyStringArrayList.EMPTY;
        bitField0_ = (bitField0_ & ~0x00000010);
        onChanged();
        return this;
      }
      /**
       * <code>repeated string useRoles = 5;</code>
       * @param value The bytes of the useRoles to add.
       * @return This builder for chaining.
       */
      public Builder addUseRolesBytes(
          org.apache.pekko.protobufv3.internal.ByteString value) {
        if (value == null) {
    throw new NullPointerException();
  }
  ensureUseRolesIsMutable();
        useRoles_.add(value);
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final org.apache.pekko.protobufv3.internal.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:ClusterRouterPoolSettings)
    }

    // @@protoc_insertion_point(class_scope:ClusterRouterPoolSettings)
    private static final org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings();
    }

    public static org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    @java.lang.Deprecated public static final org.apache.pekko.protobufv3.internal.Parser<ClusterRouterPoolSettings>
        PARSER = new org.apache.pekko.protobufv3.internal.AbstractParser<ClusterRouterPoolSettings>() {
      @java.lang.Override
      public ClusterRouterPoolSettings parsePartialFrom(
          org.apache.pekko.protobufv3.internal.CodedInputStream input,
          org.apache.pekko.protobufv3.internal.ExtensionRegistryLite extensionRegistry)
          throws org.apache.pekko.protobufv3.internal.InvalidProtocolBufferException {
        return new ClusterRouterPoolSettings(input, extensionRegistry);
      }
    };

    public static org.apache.pekko.protobufv3.internal.Parser<ClusterRouterPoolSettings> parser() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.protobufv3.internal.Parser<ClusterRouterPoolSettings> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public org.apache.pekko.cluster.protobuf.msg.ClusterMessages.ClusterRouterPoolSettings getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_Join_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_Join_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_Welcome_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_Welcome_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_InitJoin_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_InitJoin_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_InitJoinAck_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_InitJoinAck_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_ConfigCheck_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_ConfigCheck_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_Heartbeat_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_Heartbeat_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_HeartBeatResponse_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_HeartBeatResponse_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_GossipEnvelope_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_GossipEnvelope_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_GossipStatus_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_GossipStatus_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_Gossip_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_Gossip_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_GossipOverview_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_GossipOverview_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_ObserverReachability_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_ObserverReachability_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_SubjectReachability_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_SubjectReachability_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_Tombstone_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_Tombstone_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_Member_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_Member_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_VectorClock_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_VectorClock_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_VectorClock_Version_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_VectorClock_Version_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_Empty_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_Empty_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_Address_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_Address_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_UniqueAddress_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_UniqueAddress_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_ClusterRouterPool_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_ClusterRouterPool_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_Pool_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_Pool_fieldAccessorTable;
  private static final org.apache.pekko.protobufv3.internal.Descriptors.Descriptor
    internal_static_ClusterRouterPoolSettings_descriptor;
  private static final 
    org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable
      internal_static_ClusterRouterPoolSettings_fieldAccessorTable;

  public static org.apache.pekko.protobufv3.internal.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static  org.apache.pekko.protobufv3.internal.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\025ClusterMessages.proto\"G\n\004Join\022\034\n\004node\030" +
      "\001 \002(\0132\016.UniqueAddress\022\r\n\005roles\030\002 \003(\t\022\022\n\n" +
      "appVersion\030\003 \001(\t\"@\n\007Welcome\022\034\n\004from\030\001 \002(" +
      "\0132\016.UniqueAddress\022\027\n\006gossip\030\002 \002(\0132\007.Goss" +
      "ip\"!\n\010InitJoin\022\025\n\rcurrentConfig\030\001 \001(\t\"K\n" +
      "\013InitJoinAck\022\031\n\007address\030\001 \002(\0132\010.Address\022" +
      "!\n\013configCheck\030\002 \002(\0132\014.ConfigCheck\"\220\001\n\013C" +
      "onfigCheck\022\037\n\004type\030\001 \002(\0162\021.ConfigCheck.T" +
      "ype\022\025\n\rclusterConfig\030\002 \001(\t\"I\n\004Type\022\023\n\017Un" +
      "checkedConfig\020\001\022\026\n\022IncompatibleConfig\020\002\022" +
      "\024\n\020CompatibleConfig\020\003\"M\n\tHeartbeat\022\026\n\004fr" +
      "om\030\001 \002(\0132\010.Address\022\022\n\nsequenceNr\030\002 \001(\003\022\024" +
      "\n\014creationTime\030\003 \001(\022\"[\n\021HeartBeatRespons" +
      "e\022\034\n\004from\030\001 \002(\0132\016.UniqueAddress\022\022\n\nseque" +
      "nceNr\030\002 \001(\003\022\024\n\014creationTime\030\003 \001(\003\"d\n\016Gos" +
      "sipEnvelope\022\034\n\004from\030\001 \002(\0132\016.UniqueAddres" +
      "s\022\032\n\002to\030\002 \002(\0132\016.UniqueAddress\022\030\n\020seriali" +
      "zedGossip\030\003 \002(\014\"r\n\014GossipStatus\022\034\n\004from\030" +
      "\001 \002(\0132\016.UniqueAddress\022\021\n\tallHashes\030\002 \003(\t" +
      "\022\035\n\007version\030\003 \002(\0132\014.VectorClock\022\022\n\nseenD" +
      "igest\030\004 \001(\014\"\347\001\n\006Gossip\022$\n\014allAddresses\030\001" +
      " \003(\0132\016.UniqueAddress\022\020\n\010allRoles\030\002 \003(\t\022\021" +
      "\n\tallHashes\030\003 \003(\t\022\030\n\007members\030\004 \003(\0132\007.Mem" +
      "ber\022!\n\010overview\030\005 \002(\0132\017.GossipOverview\022\035" +
      "\n\007version\030\006 \002(\0132\014.VectorClock\022\036\n\ntombsto" +
      "nes\030\007 \003(\0132\n.Tombstone\022\026\n\016allAppVersions\030" +
      "\010 \003(\t\"S\n\016GossipOverview\022\014\n\004seen\030\001 \003(\005\0223\n" +
      "\024observerReachability\030\002 \003(\0132\025.ObserverRe" +
      "achability\"p\n\024ObserverReachability\022\024\n\014ad" +
      "dressIndex\030\001 \002(\005\022\017\n\007version\030\004 \002(\003\0221\n\023sub" +
      "jectReachability\030\002 \003(\0132\024.SubjectReachabi" +
      "lity\"a\n\023SubjectReachability\022\024\n\014addressIn" +
      "dex\030\001 \002(\005\022#\n\006status\030\003 \002(\0162\023.Reachability" +
      "Status\022\017\n\007version\030\004 \002(\003\"4\n\tTombstone\022\024\n\014" +
      "addressIndex\030\001 \002(\005\022\021\n\ttimestamp\030\002 \002(\003\"\202\001" +
      "\n\006Member\022\024\n\014addressIndex\030\001 \002(\005\022\020\n\010upNumb" +
      "er\030\002 \002(\005\022\035\n\006status\030\003 \002(\0162\r.MemberStatus\022" +
      "\030\n\014rolesIndexes\030\004 \003(\005B\002\020\001\022\027\n\017appVersionI" +
      "ndex\030\005 \001(\005\"y\n\013VectorClock\022\021\n\ttimestamp\030\001" +
      " \001(\003\022&\n\010versions\030\002 \003(\0132\024.VectorClock.Ver" +
      "sion\032/\n\007Version\022\021\n\thashIndex\030\001 \002(\005\022\021\n\tti" +
      "mestamp\030\002 \002(\003\"\007\n\005Empty\"K\n\007Address\022\016\n\006sys" +
      "tem\030\001 \002(\t\022\020\n\010hostname\030\002 \002(\t\022\014\n\004port\030\003 \002(" +
      "\r\022\020\n\010protocol\030\004 \001(\t\"E\n\rUniqueAddress\022\031\n\007" +
      "address\030\001 \002(\0132\010.Address\022\013\n\003uid\030\002 \002(\r\022\014\n\004" +
      "uid2\030\003 \001(\r\"V\n\021ClusterRouterPool\022\023\n\004pool\030" +
      "\001 \002(\0132\005.Pool\022,\n\010settings\030\002 \002(\0132\032.Cluster" +
      "RouterPoolSettings\"<\n\004Pool\022\024\n\014serializer" +
      "Id\030\001 \002(\r\022\020\n\010manifest\030\002 \002(\t\022\014\n\004data\030\003 \002(\014" +
      "\"\216\001\n\031ClusterRouterPoolSettings\022\026\n\016totalI" +
      "nstances\030\001 \002(\r\022\033\n\023maxInstancesPerNode\030\002 " +
      "\002(\r\022\031\n\021allowLocalRoutees\030\003 \002(\010\022\017\n\007useRol" +
      "e\030\004 \001(\t\022\020\n\010useRoles\030\005 \003(\t*D\n\022Reachabilit" +
      "yStatus\022\r\n\tReachable\020\000\022\017\n\013Unreachable\020\001\022" +
      "\016\n\nTerminated\020\002*\222\001\n\014MemberStatus\022\013\n\007Join" +
      "ing\020\000\022\006\n\002Up\020\001\022\013\n\007Leaving\020\002\022\013\n\007Exiting\020\003\022" +
      "\010\n\004Down\020\004\022\013\n\007Removed\020\005\022\014\n\010WeaklyUp\020\006\022\030\n\024" +
      "PreparingForShutdown\020\007\022\024\n\020ReadyForShutdo" +
      "wn\020\010B)\n%org.apache.pekko.cluster.protobu" +
      "f.msgH\001"
    };
    descriptor = org.apache.pekko.protobufv3.internal.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new org.apache.pekko.protobufv3.internal.Descriptors.FileDescriptor[] {
        });
    internal_static_Join_descriptor =
      getDescriptor().getMessageTypes().get(0);
    internal_static_Join_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Join_descriptor,
        new java.lang.String[] { "Node", "Roles", "AppVersion", });
    internal_static_Welcome_descriptor =
      getDescriptor().getMessageTypes().get(1);
    internal_static_Welcome_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Welcome_descriptor,
        new java.lang.String[] { "From", "Gossip", });
    internal_static_InitJoin_descriptor =
      getDescriptor().getMessageTypes().get(2);
    internal_static_InitJoin_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_InitJoin_descriptor,
        new java.lang.String[] { "CurrentConfig", });
    internal_static_InitJoinAck_descriptor =
      getDescriptor().getMessageTypes().get(3);
    internal_static_InitJoinAck_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_InitJoinAck_descriptor,
        new java.lang.String[] { "Address", "ConfigCheck", });
    internal_static_ConfigCheck_descriptor =
      getDescriptor().getMessageTypes().get(4);
    internal_static_ConfigCheck_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_ConfigCheck_descriptor,
        new java.lang.String[] { "Type", "ClusterConfig", });
    internal_static_Heartbeat_descriptor =
      getDescriptor().getMessageTypes().get(5);
    internal_static_Heartbeat_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Heartbeat_descriptor,
        new java.lang.String[] { "From", "SequenceNr", "CreationTime", });
    internal_static_HeartBeatResponse_descriptor =
      getDescriptor().getMessageTypes().get(6);
    internal_static_HeartBeatResponse_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_HeartBeatResponse_descriptor,
        new java.lang.String[] { "From", "SequenceNr", "CreationTime", });
    internal_static_GossipEnvelope_descriptor =
      getDescriptor().getMessageTypes().get(7);
    internal_static_GossipEnvelope_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_GossipEnvelope_descriptor,
        new java.lang.String[] { "From", "To", "SerializedGossip", });
    internal_static_GossipStatus_descriptor =
      getDescriptor().getMessageTypes().get(8);
    internal_static_GossipStatus_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_GossipStatus_descriptor,
        new java.lang.String[] { "From", "AllHashes", "Version", "SeenDigest", });
    internal_static_Gossip_descriptor =
      getDescriptor().getMessageTypes().get(9);
    internal_static_Gossip_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Gossip_descriptor,
        new java.lang.String[] { "AllAddresses", "AllRoles", "AllHashes", "Members", "Overview", "Version", "Tombstones", "AllAppVersions", });
    internal_static_GossipOverview_descriptor =
      getDescriptor().getMessageTypes().get(10);
    internal_static_GossipOverview_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_GossipOverview_descriptor,
        new java.lang.String[] { "Seen", "ObserverReachability", });
    internal_static_ObserverReachability_descriptor =
      getDescriptor().getMessageTypes().get(11);
    internal_static_ObserverReachability_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_ObserverReachability_descriptor,
        new java.lang.String[] { "AddressIndex", "Version", "SubjectReachability", });
    internal_static_SubjectReachability_descriptor =
      getDescriptor().getMessageTypes().get(12);
    internal_static_SubjectReachability_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_SubjectReachability_descriptor,
        new java.lang.String[] { "AddressIndex", "Status", "Version", });
    internal_static_Tombstone_descriptor =
      getDescriptor().getMessageTypes().get(13);
    internal_static_Tombstone_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Tombstone_descriptor,
        new java.lang.String[] { "AddressIndex", "Timestamp", });
    internal_static_Member_descriptor =
      getDescriptor().getMessageTypes().get(14);
    internal_static_Member_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Member_descriptor,
        new java.lang.String[] { "AddressIndex", "UpNumber", "Status", "RolesIndexes", "AppVersionIndex", });
    internal_static_VectorClock_descriptor =
      getDescriptor().getMessageTypes().get(15);
    internal_static_VectorClock_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_VectorClock_descriptor,
        new java.lang.String[] { "Timestamp", "Versions", });
    internal_static_VectorClock_Version_descriptor =
      internal_static_VectorClock_descriptor.getNestedTypes().get(0);
    internal_static_VectorClock_Version_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_VectorClock_Version_descriptor,
        new java.lang.String[] { "HashIndex", "Timestamp", });
    internal_static_Empty_descriptor =
      getDescriptor().getMessageTypes().get(16);
    internal_static_Empty_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Empty_descriptor,
        new java.lang.String[] { });
    internal_static_Address_descriptor =
      getDescriptor().getMessageTypes().get(17);
    internal_static_Address_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Address_descriptor,
        new java.lang.String[] { "System", "Hostname", "Port", "Protocol", });
    internal_static_UniqueAddress_descriptor =
      getDescriptor().getMessageTypes().get(18);
    internal_static_UniqueAddress_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_UniqueAddress_descriptor,
        new java.lang.String[] { "Address", "Uid", "Uid2", });
    internal_static_ClusterRouterPool_descriptor =
      getDescriptor().getMessageTypes().get(19);
    internal_static_ClusterRouterPool_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_ClusterRouterPool_descriptor,
        new java.lang.String[] { "Pool", "Settings", });
    internal_static_Pool_descriptor =
      getDescriptor().getMessageTypes().get(20);
    internal_static_Pool_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_Pool_descriptor,
        new java.lang.String[] { "SerializerId", "Manifest", "Data", });
    internal_static_ClusterRouterPoolSettings_descriptor =
      getDescriptor().getMessageTypes().get(21);
    internal_static_ClusterRouterPoolSettings_fieldAccessorTable = new
      org.apache.pekko.protobufv3.internal.GeneratedMessageV3.FieldAccessorTable(
        internal_static_ClusterRouterPoolSettings_descriptor,
        new java.lang.String[] { "TotalInstances", "MaxInstancesPerNode", "AllowLocalRoutees", "UseRole", "UseRoles", });
  }

  // @@protoc_insertion_point(outer_class_scope)
}
